#!/usr/bin/perl
use LWP;
use LWP::UserAgent;
#use JSON qw(decode_json);
use MIME::Base64;
use Sys::Hostname;
use Storable;
use Socket;
#use URI::Encode;
use File::Basename;
use File::Find;
use Cwd;
use XML::Simple;
use XML::Encode;
use JSON;
use IO::Socket::SSL;
use Data::Dumper;
use URI::Escape;

%arghash = @ARGV;
$| = 1;
my $hostname;
my $dbname;
my $bkptype;
my $count=0;

die "Usage:actDBM\n       --type \n            <backup> \n            <restore> \n            <clone> \n            <mount> \n            <cleanup> \n            <listImageDetails> \n            <runwf> \n            <createliveclone> \n            <refreshliveclone> \n            <restoreASMswitch> \n            <restoreASMrebalance> \n            <cdsconfig> \n            <listDiscoveredHost> \n            <listApplication> \n" if ( !exists $arghash{'--type'} );
die "Usage:actDBM\n       --type \n            <backup> \n            <restore> \n            <clone> \n            <mount> \n            <cleanup> \n            <listImageDetails> \n            <runwf> \n            <createliveclone> \n            <refreshliveclone> \n            <restoreASMswitch> \n            <restoreASMrebalance> \n            <cdsconfig> \n            <listDiscoveredHost> \n            <listApplication> \n" if ( (exists $arghash{'--help'}) && (!exists $arghash{'--type'}) );

if ($arghash{'--type'} eq "listmountpoint" ) {
   die "Usage:actDBM --type listmountpoint \n --dbname <database name> \n [--hostname <hostname>] \n --CDS <CDS name|ip> \n [--wait <yes|no>]\n" if ( (exists $arghash{'--help'} ) && ($arghash{'--type'} eq "listmountpoint") );
    die "Usage:actDBM --type listmountpoint \n --dbname <database name> \n [--hostname <hostname>] \n --CDS <CDS name|ip> \n [--wait <yes|no>]\n" if (( !exists $arghash{'--dbname'} ) && ($arghash{'--type'} eq "listmountpoint") );

    $dbname=$arghash{'--dbname'};
    if ( !exists $arghash{'--hostname'} ) {
        $sourceHost=hostname;
        $sourceHost =~ s/(\w+)\..*/\1/;
       # print "hostname is " . $sourceHost ."\n";
    }
    elsif ( exists $arghash{'--hostname'} ) {
        $sourceHost=$arghash{'--hostname'};
    }

    if ( !exists $arghash{'--wait'} ) {
        $statuswait="no";
    }
    elsif ( exists $arghash{'--wait'} ) {
        $statuswait=$arghash{'--wait'};
    }
    if ( !exists $arghash{'--CDS'} ) {
           $pwd = cwd();

    @sesdir = ("$pwd",);
    $count=0;
    find(\&wanted, @sesdir);
     my $retuser = retrieve ($userfile);
      $CDSips = $retuser -> {CDSip};
   if ( ($count >= 1) || ($CDSips eq "generic") ) {
     die "--CDS parameter is not specified\n Usage:actDBM --type listmountpoint \n --dbname <database name> \n [--hostname <hostname>] \n --CDS <CDS name|ip> \n [--wait <yes|no>]\n" if (( !exists $arghash{'--CDS'} ) && ($arghash{'--type'} eq "listmountpoint") );
     }
   }
    elsif ( exists $arghash{'--CDS'} ) {
        $CDSip=$arghash{'--CDS'};
    }
    #Calling backup subroutine
    listmountpoint();
}

if ($arghash{'--type'} eq "backup" ) {
   die "Usage:actDBM --type backup \n --dbname <database name> \n [--hostname <hostname>] \n [--backuptype <db|log|dblog] \n [--backuplabel <label name>] \n --CDS <CDS name|ip> \n [--wait <yes|no>]\n" if ( (exists $arghash{'--help'}) && ($arghash{'--type'} eq "backup") );
    die "Usage:actDBM --type backup \n --dbname <database name> \n [--hostname <hostname>] \n [--backuptype <db|log|dblog] \n [--backuplabel <label name>] \n --CDS <CDS name|ip> \n [--wait <yes|no>]\n" if (( !exists $arghash{'--dbname'} ) && ($arghash{'--type'} eq "backup") );

    $dbname=$arghash{'--dbname'};
    if ( !exists $arghash{'--hostname'} ) {
        $hostname=hostname;
        $hostname =~ s/(\w+)\..*/\1/;
    }
    elsif ( exists $arghash{'--hostname'} ) {
        $hostname=$arghash{'--hostname'};
    }
    if ( !exists $arghash{'--backuptype'} ) {
        $bkptype="db";
    }
    elsif ( exists $arghash{'--backuptype'} ) {
        $bkptype=$arghash{'--backuptype'};
    }

    if ( exists $arghash{'--backuplabel'} ) {
        $backlabel=$arghash{'--backuplabel'};
    }

    if ( !exists $arghash{'--wait'} ) {
        $statuswait="no";
    }
    elsif ( exists $arghash{'--wait'} ) {
        $statuswait=$arghash{'--wait'};
    }
    if ( !exists $arghash{'--CDS'} ) {
           $pwd = cwd();

    @sesdir = ("$pwd",);
    $count=0;
    find(\&wanted, @sesdir);
     my $retuser = retrieve ($userfile);
      $CDSips = $retuser -> {CDSip};
   if ( ($count >= 1) || ($CDSips eq "generic") ) {
     die "--CDS parameter is not specified\n Usage:actDBM --type backup \n --dbname <database name> \n [--hostname <hostname>] \n [--backuptype <db|log|dblog] \n [--backuplabel <label name>] \n --CDS <CDS name|ip> \n [--wait <yes|no>]\n" if (( !exists $arghash{'--CDS'} ) && ($arghash{'--type'} eq "backup") );
     }
   }
    elsif ( exists $arghash{'--CDS'} ) {
        $CDSip=$arghash{'--CDS'};
    }
    backup();
}

if ($arghash{'--type'} eq "listImageDetails" ) {
   die "Usage:actDBM --type listImageDetails \n --dbname <database name> \n [--hostname <hostname>] \n [--remoteApp <no|yes>] \n --CDS <CDS name|ip> \n [--wait <yes|no>]\n" if ( (exists $arghash{'--help'}) && ($arghash{'--type'} eq "listImageDetails") );
    die "Usage:actDBM --type listImageDetails \n --dbname <database name> \n [--hostname <hostname>] \n [--remoteApp <no|yes>] \n --CDS <CDS name|ip> \n [--wait <yes|no>]\n" if (( !exists $arghash{'--dbname'} ) && ($arghash{'--type'} eq "listImageDetails") );

    $dbname=$arghash{'--dbname'};
    if ( !exists $arghash{'--hostname'} ) {
        $sourceHost=hostname;
        $sourceHost =~ s/(\w+)\..*/\1/;
       # print "hostname is " . $sourceHost ."\n";
    }
    elsif ( exists $arghash{'--hostname'} ) {
        $sourceHost=$arghash{'--hostname'};
    }

    if ( !exists $arghash{'--remoteApp'} ) {
        $remoteapp="no";
    }
    elsif ( exists $arghash{'--remoteApp'} ) {
        $remoteapp=$arghash{'--remoteApp'};
    }

    if ( !exists $arghash{'--wait'} ) {
        $statuswait="no";
    }
    elsif ( exists $arghash{'--wait'} ) {
        $statuswait=$arghash{'--wait'};
    }
  

    if ( !exists $arghash{'--CDS'} ) {
           $pwd = cwd();

    @sesdir = ("$pwd",);
    $count=0;
    find(\&wanted, @sesdir);
      my $retuser = retrieve ($userfile);
      $CDSips = $retuser -> {CDSip};
   
   if ( ($count >= 1) || ($CDSips eq "generic") ) {
     die "--CDS parameter is not specified\n Usage:actDBM --type listImageDetails \n --dbname <database name> \n [--hostname <hostname>] \n [--remoteApp <no|yes>] \n --CDS <CDS name|ip> \n [--wait <yes|no>]\n" if (( !exists $arghash{'--CDS'} ) && ($arghash{'--type'} eq "listImageDetails") );
     }
   }
    elsif ( exists $arghash{'--CDS'} ) {
        $CDSip=$arghash{'--CDS'};
    }

    #Calling backup subroutine
    listImageDetails();
}

if ($arghash{'--type'} eq "createliveclone" ) {
   die "Usage:actDBM --type createliveclone \n --dbname <database name> \n --label <liveclone label> \n --diskpool <disk pool name> \n [--hostname <hostname>] \n [--sourceimage  <source image name>] \n [--backuplabel <source backup image label>] \n --CDS <CDS name|ip> \n [--wait <yes|no>]\n" if ( (exists $arghash{'--help'}) && ($arghash{'--type'} eq "createliveclone") );
    die "Usage:actDBM --type createliveclone \n --dbname <database name> \n --label <liveclone label> \n --diskpool <disk pool name> \n [--sourceimage  <source image name>] \n [--hostname <hostname>] \n [--backuplabel <source backup image label>] \n --CDS <CDS name|ip> \n [--wait <yes|no>]\n" if (( ( !exists $arghash{'--label'} ) || ( !exists $arghash{'--diskpool'} )) && ($arghash{'--type'} eq "createliveclone") );

    $dbname=$arghash{'--dbname'};
    if ( !exists $arghash{'--hostname'} ) {
        $hostname=hostname;
        $hostname =~ s/(\w+)\..*/\1/;
    }
    elsif ( exists $arghash{'--hostname'} ) {
        $hostname=$arghash{'--hostname'};
    }

    if ( exists $arghash{'--label'} ) {
        $lclabel=$arghash{'--label'};
    }
    
    if ( exists $arghash{'--diskpool'} ) {
        $dpool=$arghash{'--diskpool'};
    }
 
    if ( exists $arghash{'--backuplabel'} ) {
        $bkplabelid=$arghash{'--backuplabel'};
    }

    if ( exists $arghash{'--sourceimage'} ) {
        $simage=$arghash{'--sourceimage'};
    }

    if ( !exists $arghash{'--wait'} ) {
        $statuswait="no";
    }
    elsif ( exists $arghash{'--wait'} ) {
        $statuswait=$arghash{'--wait'};
    }
    if ( !exists $arghash{'--CDS'} ) {
           $pwd = cwd();

    @sesdir = ("$pwd",);
    $count=0;
    find(\&wanted, @sesdir);
     my $retuser = retrieve ($userfile);
      $CDSips = $retuser -> {CDSip};
   if ( ($count >= 1) || ($CDSips eq "generic") ) {
     die "--CDS parameter is not specified\n Usage:actDBM --type createliveclone \n --dbname <database name> \n --label <liveclone label> \n --diskpool <disk pool name> \n [--hostname <hostname>] \n [--sourceimage  <source image name>] \n [--backuplabel <source backup image label>] \n --CDS <CDS name|ip> \n [--wait <yes|no>]\n" if (( !exists $arghash{'--CDS'} ) && ($arghash{'--type'} eq "createliveclone") );
     }
   }
    elsif ( exists $arghash{'--CDS'} ) {
        $CDSip=$arghash{'--CDS'};
    }
    createliveclone();
}

if ($arghash{'--type'} eq "refreshliveclone" ) {
   die "Usage:actDBM --type refreshliveclone \n --dbname <database name> \n --label <liveclone label> \n [--hostname <hostname>] \n [--sourceimage  <source image name>] \n [--backuplabel <source backup image label>] \n --CDS <CDS name|ip> \n [--wait <yes|no>]\n" if ( (exists $arghash{'--help'}) && ($arghash{'--type'} eq "refreshliveclone") );
    die "Usage:actDBM --type refreshliveclone \n --dbname <database name> \n --label <liveclone label> \n [--hostname <hostname>] \n [--sourceimage  <source image name>] \n [--backuplabel <source backup image label>] \n --CDS <CDS name|ip> \n [--wait <yes|no>]\n" if ( ( !exists $arghash{'--label'} ) && ($arghash{'--type'} eq "refreshliveclone") );

    $dbname=$arghash{'--dbname'};
    if ( !exists $arghash{'--hostname'} ) {
        $hostname=hostname;
        $hostname =~ s/(\w+)\..*/\1/;
    }
    elsif ( exists $arghash{'--hostname'} ) {
        $hostname=$arghash{'--hostname'};
    }

    if ( exists $arghash{'--label'} ) {
        $lclabel=$arghash{'--label'};
    }

    #if ( exists $arghash{'--targetimage'} ) {
    #    $timage=$arghash{'--targetimage'};
    #}

    if ( exists $arghash{'--backuplabel'} ) {
        $bkplabelid=$arghash{'--backuplabel'};
    }

    if ( exists $arghash{'--sourceimage'} ) {
        $simage=$arghash{'--sourceimage'};
    }

    if ( !exists $arghash{'--wait'} ) {
        $statuswait="no";
    }
    elsif ( exists $arghash{'--wait'} ) {
        $statuswait=$arghash{'--wait'};
    }
    if ( !exists $arghash{'--CDS'} ) {
           $pwd = cwd();

    @sesdir = ("$pwd",);
    $count=0;
    find(\&wanted, @sesdir);
     my $retuser = retrieve ($userfile);
      $CDSips = $retuser -> {CDSip};
   if ( ($count >= 1) || ($CDSips eq "generic") ) {
     die "--CDS parameter is not specified\n Usage:actDBM --type refreshliveclone \n --dbname <database name> \n --label <liveclone label> \n [--hostname <hostname>] \n [--sourceimage  <source image name>] \n [--backuplabel <source backup image label>] \n [--targetimage  <target image name>] \n --CDS <CDS name|ip> \n [--wait <yes|no>]\n" if (( !exists $arghash{'--CDS'} ) && ($arghash{'--type'} eq "refreshliveclone") );
     }
   }
    elsif ( exists $arghash{'--CDS'} ) {
        $CDSip=$arghash{'--CDS'};
    }
    refreshliveclone();
}

if ($arghash{'--type'} eq "restore" ) {
die "Usage: perl actDBM.pl --type restore \n --dbname <source database name> \n --OSusername <OS oracle owner> \n [--OSpassword <OS oracle owner password>] \n [--image <Image name>] \n [--backuplabel <backup label ID>] \n [--sourceHost <source hostname>] \n [--pointInTime <Recovery time 'yyyy-mm-dd hh24:mi:ss'>] \n --CDS <CDS ip|name> \n [--wait <yes|no>]\n [--openDB <true|false>]\n" if ( (exists $arghash{'--help'} ) && ($arghash{'--type'} eq "restore") );
die "Usage: perl actDBM.pl --type restore \n --dbname <source database name> \n --OSusername <OS oracle owner> \n [--OSpassword <OS oracle owner password>] \n [--image <Image name>] \n [--backuplabel <backup label ID>] \n [--sourceHost <source hostname>] \n [--pointInTime <Recovery time 'yyyy-mm-dd hh24:mi:ss'>] \n --CDS <CDS ip|name> \n [--wait <yes|no>]\n [--openDB <true|false>]\n" if ( ($arghash{'--type'} eq "restore") && (( !exists $arghash{'--dbname'} ) || ( !exists $arghash{'--OSusername'} ) ));
    $dbname=$arghash{'--dbname'};
    $hostname=hostname;
    $hostname =~ s/(\w+)\..*/\1/;
    $openDB="true";
    $pointInTime="";
    $image="";

    if ( exists $arghash{'--sourceHost'} ) {
        $hostname=$arghash{'--sourceHost'};
    }

    if ( exists $arghash{'--openDB'} ) {
            $openDB=$arghash{'--openDB'};
    }

    if ( exists $arghash{'--pointInTime'} ) {
        $pointInTime=$arghash{'--pointInTime'};
        if ($pointInTime=~/\d{4,4}\-\d{2,2}\-\d{2,2}\s+\d{2,2}\:\d{2,2}\:\d{2,2}/) {
                print "recovery time is " . $pointInTime ."\n";
	$pointInTime=~s/\:/%3A/g;
	$pointInTime=~s/ /%20/g;
        }
        else {
            die "Date and Time format is not matching with yyyy-mm-dd HH24:MI:SS";
        }
    }

    if ( exists $arghash{'--image'} ) {
        $image=$arghash{'--image'};
    }
     if ( exists $arghash{'--backuplabel'} ) {
        $bkplabelid=$arghash{'--backuplabel'};
    }

    if ( exists $arghash{'--OSusername'} ) {
        $osuser=$arghash{'--OSusername'};
    }
    if ( !exists $arghash{'--wait'} ) {
        $statuswait="no";
    }
    elsif ( exists $arghash{'--wait'} ) {
        $statuswait=$arghash{'--wait'};
    }

    if ( !exists $arghash{'--CDS'} ) {
           $pwd = cwd();

    @sesdir = ("$pwd",);
    $count=0;
    find(\&wanted, @sesdir);
     my $retuser = retrieve ($userfile);
      $CDSips = $retuser -> {CDSip};
   if ( ($count >= 1) || ($CDSips eq "generic") ) {
die "--CDS parameter is not specified \n Usage: perl actDBM.pl --type restore \n --dbname <source database name> \n --OSusername <OS oracle owner> \n [--OSpassword <OS oracle owner password>] \n [--image <Image name>] \n [--sourceHost <source hostname>] \n [--pointInTime <Recovery time 'yyyy-mm-dd hh24:mi:ss'>] \n --CDS <CDS ip|name> \n [--wait <yes|no>]\n [--openDB <true|false>]\n" if ( (!exists $arghash{'--CDS'} ) && ($arghash{'--type'} eq "restore") );
     }
   }
    elsif ( exists $arghash{'--CDS'} ) {
        $CDSip=$arghash{'--CDS'};
    }

        restore();
}

if ($arghash{'--type'} eq "clone" ) {
#	die "Usage: perl actDBM.pl --type clone \n [--optype <newclone|refresh>] \n --dbname <source database name> \n --TargetDBname <app-aware mounted database name> \n --OSusername <OS oracle owner> \n [--image <Image name>] \n [--sourceHost <source hostname>] \n [--targetHost <target hostname>] \n [--imageType <Type of Image (snapshot, dedup, dedupasync, liveclone)>] \n [--TargetOracleHome <Target Oracle Home>] \n [--listenerpath <Target Oracle Listener path>] \n [--pointInTime <Recovery time 'yyyy-mm-dd hh24:mi:ss'>] \n [--ASMdiskgroup <ASM diskgroupname>] \n [--RACNodeList <list of RAC nodes seperated by colon>] \n [--protectNewApplication <yes|no>] \n [--totalmemory <Database memory size in MB>] \n [--SGApct <SGA %>] \n [--tnsip <TNS Listener IP/scan IP>] \n [--tnsport <TNS listener port>] \n [--tnsdomain <TNS Domain>] \n [--redosize <redo size in MB>] \n [--recovery <yes|no>] \n [--envvar <variable1:variable2>] \n [--backuplabel <backup label ID>] \n [--standalone <yes|no>] \n [--CDS <CDS ip|name>] \n [--wait <yes|no>]\n" if ( (exists $arghash{'--help'} ) && ($arghash{'--type'} eq "clone") && (!exists $arghash{'--optype'} ) );
        die "Usage: perl actDBM.pl --type clone \n [--optype <newclone|refresh>]\n" if ( ( (exists $arghash{'--help'} ) || (!exists $arghash{'--help'} ) ) && ($arghash{'--type'} eq "clone") && (!exists $arghash{'--optype'} ) );
    	die "Usage: perl actDBM.pl --type clone \n [--optype <newclone>] \n --dbname <source database name> \n [--remoteApp <no|yes>] \n --TargetDBname <app-aware mount database name> \n --OSusername <OS oracle owner> \n --TargetOracleHome <Target Oracle Home> \n --listenerpath <Target Oracle Listener path> \n [--image <Image name>] \n [--sourceHost <source hostname>] \n [--targetHost <target hostname>] \n [--imageType <Type of Image (snapshot, dedup, dedupasync, liveclone)>] \n [--pointInTime <Recovery time 'yyyy-mm-dd hh24:mi:ss'>] \n [--ASMdiskgroup <ASM diskgroupname>] \n [--RACNodeList <list of RAC nodes seperated by colon>] \n [--protectNewApplication <yes|no>] \n [--totalmemory <Database memory size in MB>] \n [--SGApct <SGA %>] \n [--SharedPoolSize <shared pool size in MB>] \n [--DBcacheSize <DB cache size in MB>] \n [--DBrecoveryFileDestSize <DB Recovery file dest size in MB>] \n [--Processes <Number of Processes>] \n [--OpenCursors <Max Number of Cursors>] \n [--DiagnosticDestination <Diagnostic Destination>] \n [--tnsip <TNS Listener IP/scan IP>] \n [--tnsport <TNS listener port>] \n [--tnsdomain <TNS Domain>] \n [--redosize <redo size in MB>] \n [--recovery <yes|no>] \n [--envvar <variable1:variable2>] \n [--backuplabel <backup label ID>] \n [--standalone <yes|no>] \n [--mountpoint <filesystem mountpoint '/act/mnt'>] \n [--DoNotUpdateTNSname <flag to update TNSentry yes|no>] \n [--DoNotchangeDBid <flag to change DBID yes|no>] \n [--template <child db protect template name>] \n [--profile <child db protect profile name>] \n --CDS <CDS ip|name> \n [--wait <yes|no>]\n" if ((( !exists $arghash{'--TargetDBname'} ) || ( !exists $arghash{'--TargetOracleHome'} ) || ( !exists $arghash{'--listenerpath'} ) || ( !exists $arghash{'--dbname'} ))  && ($arghash{'--type'} eq "clone") &&  ($arghash{'--optype'} eq "newclone"));

        #die "Usage: perl actDBM.pl --type clone \n [--optype <newclone>] \n --dbname <source database name> \n --TargetDBname <app-aware mounted database name> \n --OSusername <OS oracle owner> \n --TargetOracleHome <Target Oracle Home> \n --listenerpath <Target Oracle Listener path> \n [--image <Image name>] \n [--sourceHost <source hostname>] \n [--targetHost <target hostname>] \n [--pointInTime <Recovery time yyyy mm dd hh24:mi:ss>] \n [--ASMdiskgroup <ASM diskgroupname>] \n [--RACNodeList <list of RAC nodes seperated by colon>] \n [--protectNewApplication <yes|no>] \n [--totalmemory <Database memory size in MB>] \n [--SGApct <SGA %>] \n [--tnsip <TNS Listener IP/scan IP>] \n [--tnsport <TNS listener port>] \n [--tnsdomain <TNS Domain>] \n [--recovery <yes|no>] \n --CDS <CDS ip|name> \n [--wait <yes|no>]\n" if (($arghash{'--type'} eq "clone") && ((!exists $arghash{'--optype'}) || ($arghash{'--optype'} eq "newclone")));
       
	 die " Usage: perl actDBM.pl --type clone \n [--optype <newclone>] \n --dbname <source database name> \n [--remoteApp <no|yes>] \n --TargetDBname <app-aware mount database name> \n --OSusername <OS oracle owner> \n --TargetOracleHome <Target Oracle Home> \n --listenerpath <Target Oracle Listener path> \n [--image <Image name>] \n [--sourceHost <source hostname>] \n [--targetHost <target hostname>] \n [--imageType <Type of Image (snapshot, dedup, dedupasync, liveclone)>] \n [--pointInTime <Recovery time 'yyyy-mm-dd hh24:mi:ss'>] \n [--ASMdiskgroup <ASM diskgroupname>] \n [--RACNodeList <list of RAC nodes seperated by colon>] \n [--protectNewApplication <yes|no>] \n [--totalmemory <Database memory size in MB>] \n [--SGApct <SGA %>] \n [--SharedPoolSize <shared pool size in MB>] \n [--DBcacheSize <DB cache size in MB>] \n [--DBrecoveryFileDestSize <DB Recovery file dest size in MB>] \n [--Processes <Number of Processes>] \n [--OpenCursors <Max Number of Cursors>] \n [--DiagnosticDestination <Diagnostic Destination>] \n [--tnsip <TNS Listener IP/scan IP>] \n [--tnsport <TNS listener port>] \n [--tnsdomain <TNS Domain>] \n [--redosize <redo size in MB>] \n [--recovery <yes|no>] \n [--envvar <variable1:variable2>] \n  [--backuplabel <backup label ID>] \n [--backuplabel <backup label ID>] \n [--standalone <yes|no>] \n  [--mountpoint <filesystem mountpoint '/act/mnt'>] \n [--DoNotUpdateTNSname <flag to update TNSentry yes|no>] \n [--DoNotchangeDBid <flag to change DBID yes|no>] \n [--template <child db protect template name>] \n [--profile <child db protect profile name>] \n --CDS <CDS ip|name> \n [--wait <yes|no>]\n" if (( !exists $arghash{'--OSusername'} ) && ($arghash{'--optype'} eq "newclone"));
#die " Usage: perl actDBM.pl --type clone \n [--optype <newclone>] \n --dbname <source database name> \n --TargetDBname <app-aware mounted database name> \n --OSusername <OS oracle owner> \n [--image <Image name>] \n [--sourceHost <source hostname>] \n [--targetHost <target hostname>] \n [--TargetOracleHome <Target Oracle Home>] \n [--listenerpath <Target Oracle Listener path>] \n [--pointInTime <Recovery time 'yyyy-mm-dd hh24:mi:ss'>] \n [--ASMdiskgroup <ASM diskgroupname>] \n [--RACNodeList <list of RAC nodes seperated by colon>] \n [--protectNewApplication <yes|no>] \n [--totalmemory <Database memory size in MB>] \n [--SGApct <SGA %>] \n [--tnsip <TNS Listener IP/scan IP>] \n [--tnsport <TNS listener port>] \n [--tnsdomain <TNS Domain>] \n [--recovery <yes|no>] \n [--envvar <variable1:variable2>] \n [--backuplabel <backup label ID>] \n [--standalone <yes|no>] \n [--template <child db protect template name>] \n [--profile <child db protect profile name>] \n --CDS <CDS ip|name> \n [--wait <yes|no>]\n" if ( ($arghash{'--type'} eq "clone") && ($arghash{'--optype'} eq "newclone"));
    $dbname=$arghash{'--dbname'};

    $sourceHost=hostname;
    $sourceHost =~ s/(\w+)\..*/\1/;
    $optype="newclone";
    $targetHost=hostname;
    $targetHost =~ s/(\w+)\..*/\1/;
    $pointInTime="";
    $openDB="yes";
    $asmDG="";
    $RACNodeList="";
    $torahome=$sorahome;
    #$tdbname=$dbname;	
    $dbmemory="";
    $osuser="";
    $ttnsadmin="";
    $temptabsize="";
    $pnewapp="false";	
    #$osuser="oracle";
    #$ospassword="12%21pass345";
    $ttnsadmin=$torahome . "%2Fnetwork%2Fadmin";
    $rrecovery="true";
    $standalone="false";
    $donotupdatetns="false";
    $donotupdateDBid="false";

    if ( exists $arghash{'--sourceHost'} ) {
        $sourceHost=$arghash{'--sourceHost'};
    }
    if ( exists $arghash{'--optype'} ) {
        $optype=$arghash{'--optype'};
    }
    if ( exists $arghash{'--targetHost'} ) {
        $targetHost=$arghash{'--targetHost'};
    }
    if ( exists $arghash{'--imageType'} ) {
        $imagetype=$arghash{'--imageType'};
    }
    if ( exists $arghash{'--pointInTime'} ) {
        $pointInTime=$arghash{'--pointInTime'};
        if ($pointInTime=~/\d{4,4}\-\d{2,2}\-\d{2,2}\s+\d{2,2}\:\d{2,2}\:\d{2,2}/) {
            print "recovery time is " . $pointInTime ."\n";
        $pointInTime=~s/\:/%3A/g;
        $pointInTime=~s/ /%20/g;

        }
        else {
            die "Date and Time format is not matching with yyyy-mm-dd HH24:MI:SS";
        }
    }

    if ( exists $arghash{'--image'} ) {
        $image=$arghash{'--image'};
    }
    if ( exists $arghash{'--openDB'} ) {
        $openDB=$arghash{'--openDB'};
    }
    if ( exists $arghash{'--ASMdiskgroup'} ) {
        $asmDG=$arghash{'--ASMdiskgroup'};
    }
    if ( exists $arghash{'--RACNodeList'} ) {
        $RACNodeList=$arghash{'--RACNodeList'};
        $RACNodeList=~s/\:/%3A/g;
        printf $RACNodeList . "\n";
    }

    if ( exists $arghash{'--TargetDBname'} ) {
        $tdbname=$arghash{'--TargetDBname'};
    }
    if ( exists $arghash{'--TargetOracleHome'} ) {
        $torahome=$arghash{'--TargetOracleHome'};
        $torahome=~s/\//%2F/g;
    }
    if ( exists $arghash{'--databaseMemory'} ) {
        $dbmemory=$arghash{'--databaseMemory'};
    }
    if ( exists $arghash{'--OSusername'} ) {
        $osuser=$arghash{'--OSusername'};
    }
    if ( exists $arghash{'--listenerpath'} ) {
        $ttnsadmin=$arghash{'--listenerpath'};
        $ttnsadmin=~s/\//%2F/g;
    }
    if ( exists $arghash{'--TemptablespaceSize'} ) {
        $temptabsize=$arghash{'--TemptablespaceSize'};
    }
    if ( exists $arghash{'--protectNewApplication'} ) {
        $pnewapp=$arghash{'--protectNewApplication'};
    }
    if ( exists $arghash{'--totalmemory'} ) {
        $tmemory=$arghash{'--totalmemory'};
    }
    if ( exists $arghash{'--SGApct'} ) {
        $sgap=$arghash{'--SGApct'};
    }
    if ( exists $arghash{'--SharedPoolSize'} ) {
        $sharedpool=$arghash{'--SharedPoolSize'};
    }
    if ( exists $arghash{'--DBcacheSize'} ) {
        $dbcache=$arghash{'--DBcacheSize'};
    }
    if ( exists $arghash{'--DBrecoveryFileDestSize'} ) {
        $dbrfds=$arghash{'--DBrecoveryFileDestSize'};
    }
    if ( exists $arghash{'--Processes'} ) {
        $process=$arghash{'--Processes'};
    }
    if ( exists $arghash{'--OpenCursors'} ) {
        $opencursor=$arghash{'--OpenCursors'};
    }
    if ( exists $arghash{'--DiagnosticDestination'} ) {
        $diagdest=$arghash{'--DiagnosticDestination'};
    }
    if ( exists $arghash{'--tnsip'} ) {
        $tnslip=$arghash{'--tnsip'};
    }
    if ( exists $arghash{'--tnsport'} ) {
        $tnsport=$arghash{'--tnsport'};
    }
    if ( exists $arghash{'--tnsdomain'} ) {
        $tnsdomain=$arghash{'--tnsdomain'};
    }
    if ( exists $arghash{'--redosize'} ) {
        $redosize=$arghash{'--redosize'};
    }
     if ( exists $arghash{'--recovery'} ) {
        $rrecovery=$arghash{'--recovery'};
    }
     if ( exists $arghash{'--envvar'} ) {
        $envvar=$arghash{'--envvar'};
        @envvararray = split /:/, $envvar;
        $env = $envvararray[0];
        $dbtype = $envvararray[1];
    }
     if ( exists $arghash{'--backuplabel'} ) {
        $bkplabelid=$arghash{'--backuplabel'};
    }
     if ( exists $arghash{'--recovery'} ) {
        $rrecovery=$arghash{'--recovery'};
    }
     if ( exists $arghash{'--standalone'} ) {
        $standalone=$arghash{'--standalone'};
    }
     if ( exists $arghash{'--template'} ) {
        $template=$arghash{'--template'};
    }
     if ( exists $arghash{'--profile'} ) {
        $profile=$arghash{'--profile'};
    }
    
    if ( exists $arghash{'--mountpoint'} ) {
        $mountpoint=$arghash{'--mountpoint'};
    }

    if ( exists $arghash{'--DoNotUpdateTNSname'} ) {
        $donotupdatetns=$arghash{'--DoNotUpdateTNSname'};
    }
    if ( exists $arghash{'--DoNotchangeDBid'} ) {
        $donotupdateDBid=$arghash{'--DoNotchangeDBid'};
    }

    if ( !exists $arghash{'--remoteApp'} ) {
        $remoteapp="no";
    }
    elsif ( exists $arghash{'--remoteApp'} ) {
        $remoteapp=$arghash{'--remoteApp'};
    }

    if ( !exists $arghash{'--wait'} ) {
        $statuswait="no";
    }
    elsif ( exists $arghash{'--wait'} ) {
        $statuswait=$arghash{'--wait'};
    }

    if ( !exists $arghash{'--CDS'} ) {
           $pwd = cwd();

    @sesdir = ("$pwd",);
    $count=0;
    find(\&wanted, @sesdir);
      my $retuser = retrieve ($userfile);
      $CDSips = $retuser -> {CDSip};
      #print "cds ips is " . $CDSips . "\n";
      #print "count number is " . $count . "\n";
   if ( ($count >= 1) || ($CDSips eq "generic") ) {
        die "--CDS parameter is not specified\n Usage: perl actDBM.pl --type clone \n [--optype <newclone|refresh>] \n --dbname <source database name> \n [--remoteApp <no|yes>] \n --TargetDBname <app-aware mount database name> \n --OSusername <OS oracle owner> \n --TargetOracleHome <Target Oracle Home> \n --listenerpath <Target Oracle Listener path> \n [--image <Image name>] \n [--sourceHost <source hostname>] \n [--targetHost <target hostname>] \n [--imageType <Type of Image (snapshot, dedup, dedupasync, liveclone)>] \n [--pointInTime <Recovery time 'yyyy-mm-dd hh24:mi:ss'>] \n [--ASMdiskgroup <ASM diskgroupname>] \n [--RACNodeList <list of RAC nodes seperated by colon>] \n [--protectNewApplication <yes|no>] \n [--totalmemory <Database memory size in MB>] \n [--SGApct <SGA %>] \n [--SharedPoolSize <shared pool size in MB>] \n [--DBcacheSize <DB cache size in MB>] \n [--DBrecoveryFileDestSize <DB Recovery file dest size in MB>] \n [--Processes <Number of Processes>] \n [--OpenCursors <Max Number of Cursors>] \n [--DiagnosticDestination <Diagnostic Destination>] \n [--DBCharacterSet <Database Character Set>] \n [--tnsip <TNS Listener IP/scan IP>] \n [--tnsport <TNS listener port>] \n [--tnsdomain <TNS Domain>] \n [--redosize <redo log size in MB>] \n [--recovery <yes|no>] \n [--envvar <variable1:variable2>] \n [--backuplabel < backup label ID>] \n [--standalone <yes|no>] \n [--DoNotUpdateTNSname <flag to update TNSentry yes|no>] \n [--DoNotchangeDBid <flag to change DBID yes|no>] \n [--template <child db protect template name>] \n [--profile <child db protect profile name>] \n --CDS <CDS ip|name> \n [--wait <yes|no>]\n" if (( !exists $arghash{'--CDS'} ) && ($arghash{'--type'} eq "clone") && ((!exists $arghash{'--optype'})&&($arghash{'--optype'} eq "newclone")));
     }
   }
    elsif ( exists $arghash{'--CDS'} ) {
        $CDSip=$arghash{'--CDS'};
    }
    
    if ($pnewapp eq "yes") {
	$pnewapp="true";
     }	 
     elsif ($pnewapp eq "no") {
         $pnewapp="false";
     }

    if ($rrecovery eq "yes") {
        $rrecovery="true";
     }
     elsif ($rrecovery eq "no") {
         $rrecovery="false";
     }

    if ($standalone eq "yes") {
        $standalone="true";
     }
     elsif ($standalone eq "no") {
         $standalone="false";
     }

    if ($donotupdateDBid eq "yes") {
        $donotupdateDBid="true";
     }
     elsif ($donotupdateDBid eq "no") {
         $donotupdateDBid="false";
     }
	
    if ($donotupdatetns eq "yes") {
        $donotupdatetns="true";
     }
     elsif ($donotupdatetns eq "no") {
         $donotupdatetns="false";
     }

    if ($optype eq "newclone") {
    clone();
    }
    elsif ($optype eq "refresh") {
	die "Usage: perl actDBM.pl --type clone --optype refresh \n --dbname <source database name> \n --TargetDBname <app-aware mount database name> \n [--image <Image name>] \n [--sourceHost <source hostname>] \n [--targetHost <target hostname>] \n [--imageType <Type of Image (snapshot, dedup, dedupasync, liveclone)>] \n [--pointInTime <Recovery time 'yyyy-mm-dd hh24:mi:ss'>] \n [--backuplabel <backup label ID>] \n --CDS <CDS ip|name> \n [--wait <yes|no>]\n" if ( (exists $arghash{'--help'}) && ($arghash{'--optype'} eq "refresh") && ($arghash{'--type'} eq "clone") );
     if (($tdbname eq "") || ($targetHost eq "") || ($dbname eq "") || ($sourceHost eq "")) {
	die "Usage: perl actDBM.pl --type clone --optype refresh \n --dbname <source database name> \n --TargetDBname <app-aware mount database name> \n [--image <Image name>] \n [--sourceHost <source hostname>] \n [--targetHost <target hostname>] \n [--imageType <Type of Image (snapshot, dedup, dedupasync, liveclone)>] \n [--pointInTime <Recovery time 'yyyy-mm-dd hh24:mi:ss'>] \n [--backuplabel <backup label ID>] \n --CDS <CDS ip|name> \n [--wait <yes|no>]\n";
     }
    if ( !exists $arghash{'--CDS'} ) {
           $pwd = cwd();

    @sesdir = ("$pwd",);
    $count=0;
    find(\&wanted, @sesdir);
   if ( ($count >= 1) || ($CDSips eq "generic") ) {
        die "--CDS parameter is not specified\n Usage:perl actDBM.pl --type clone --optype refresh \n --dbname <source database name> \n --TargetDBname <app-aware mount database name> \n [--image <Image name>] \n [--sourceHost <source hostname>] \n [--targetHost <target hostname>] \n [--imageType <Type of Image (snapshot, dedup, dedupasync, liveclone)>] \n [--pointInTime <Recovery time 'yyyy-mm-dd hh24:mi:ss'>] \n [--backuplabel <backup label ID>] \n --CDS <CDS ip|name> \n [--wait <yes|no>]\n";
	}
   }
    elsif ( exists $arghash{'--CDS'} ) {
        $CDSip=$arghash{'--CDS'};
    }
    reprovision();

 }
}

if ( $arghash{'--type'} eq "cdsconfig" ) {
    die " Usage: perl actDBM.pl --type cdsconfig \n --username <CDS username> \n --password <CDS password> \n --CDS <CDS details>\n" if ( !exists $arghash{'--username'} );
    die " Usage: perl actDBM.pl --type cdsconfig \n --username <CDS username> \n --password <CDS password> \n --CDS <CDS details>\n" if ( !exists $arghash{'--password'} );
    die " Usage: perl actDBM.pl --type cdsconfig \n --username <CDS username> \n --password <CDS password> \n --CDS <CDS details>\n" if ( !exists $arghash{'--CDS'} );
    die " Usage: perl actDBM.pl --type cdsconfig \n --username <CDS username> \n --password <CDS password> \n --CDS <CDS details>\n" if ( (exists $arghash{'--help'}) && ($arghash{'--type'} eq "cdsconfig") );
    my $username=$arghash{'--username'};
    my $password_en=MIME::Base64::encode($arghash{'--password'});
    my $CDSip=$arghash{'--CDS'};

    my %userhash = (username => $username, password => $password_en, CDSip => $CDSip);
    $pwd = cwd();
    #print "dir is " . $pwd;
    $detfile=$pwd . "/" . $CDSip . "_details";
    #print "file is " . $detfile;
    store \%userhash, $detfile;
    print "user details are stored successfully \n";
}

if ($arghash{'--type'} eq "listDiscoveredHost" ) {
die "Usage:actDBM --type listDiscoveredHost \n --CDS <CDS name|ip> \n [--wait <yes|no>]\n" if ( (exists $arghash{'--help'}) && ($arghash{'--type'} eq "listDiscoveredHost") );
die "Usage:actDBM --type listDiscoveredHost \n --CDS <CDS name|ip> \n [--wait <yes|no>]\n" if ( !exists $arghash{'--CDS'} );
    if ( !exists $arghash{'--wait'} ) {
        $statuswait="no";
    }
    elsif ( exists $arghash{'--wait'} ) {
        $statuswait=$arghash{'--wait'};
    }
    if ( !exists $arghash{'--CDS'} ) {
           $pwd = cwd();

    @sesdir = ("$pwd",);
    $count=0;
    find(\&wanted, @sesdir);
  # if ($count > 1) {
   if ( ($count >= 1) || ($CDSips eq "generic") ) {
     die "--CDS parameter is not specified\n Usage:actDBM --type listDiscoveredHost \n --CDS <CDS name|ip> \n [--wait <yes|no>]\n" if (( !exists $arghash{'--CDS'} ) && ($arghash{'--type'} eq "listDiscoveredHost") );
     }
   }
    elsif ( exists $arghash{'--CDS'} ) {
        $CDSip=$arghash{'--CDS'};
    }
listDiscoveredHost();
}

if ($arghash{'--type'} eq "listApplication" ) {

   die "Usage:actDBM --type listApplication \n --hostname <hostname> \n [--apptype <application type Oracle/SqlServerWriter>] \n [--protection <protectionState all/protected/disabled/notProtected] \n --CDS <CDS name|ip> \n [--wait <yes|no>]\n" if ( (exists $arghash{'--help'}) && ($arghash{'--type'} eq "listApplication") );
    die "Usage:actDBM --type listApplication \n --hostname <hostname> \n [--apptype <application type Oracle/SqlServerWriter>] \n [--protection <protectionState all/protected/disabled/notProtected] \n --CDS <CDS name|ip> \n [--wait <yes|no>]\n" if (( !exists $arghash{'--hostname'} ) && ($arghash{'--type'} eq "listApplication") );
die "Usage:actDBM --type listApplication \n --hostname <hostname> \n [--apptype <application type Oracle/SqlServerWriter>] \n [--protection <protectionState all/protected/disabled/notProtected] \n --CDS <CDS name|ip> \n [--wait <yes|no>]\n" if ( !exists $arghash{'--CDS'} );

    $sourceHost=$arghash{'--hostname'};
    if ( !exists $arghash{'--apptype'} ) {
        $appType='Oracle';
    }
    elsif ( exists $arghash{'--apptype'} ) {
        $appType=$arghash{'--apptype'};
    }

    if ( !exists $arghash{'--protection'} ) {
        $protection="all";
    }
    elsif ( exists $arghash{'--protection'} ) {
        $protection=$arghash{'--protection'};
    }

    if ( !exists $arghash{'--wait'} ) {
        $statuswait="no";
    }
    elsif ( exists $arghash{'--wait'} ) {
        $statuswait=$arghash{'--wait'};
    }
    if ( !exists $arghash{'--CDS'} ) {
           $pwd = cwd();

    @sesdir = ("$pwd",);
    $count=0;
    find(\&wanted, @sesdir);
   print "count " . $count . "\n";
   if ( ($count >= 1) || ($CDSips eq "generic") ) {
  # if ($count > 1) {
     die "--CDS parameter is not specified\n Usage:actDBM --type listApplication \n --hostname <hostname> \n [--apptype <application type Oracle/SqlServerWriter>] \n [--protection <protectionState all/protected/disabled/notProtected] \n --CDS <CDS name|ip> \n [--wait <yes|no>]\n" if (( !exists $arghash{'--CDS'} ) && ($arghash{'--type'} eq "listApplication") );
     }
   }
    elsif ( exists $arghash{'--CDS'} ) {
        $CDSip=$arghash{'--CDS'};
    }
listApplication();
}


$userfile;
sub wanted {
    #my $file_name = $_;
     $file_list = $CDSip . "_details"; 
    if ( ( -f $file_list ) ) {
        $userfile=$file_list;
     $count++;
     last;
    }
   # $count++;
}

my $ua = LWP::UserAgent->new;

sub getSession {
    $pwd = cwd();
    @sesdir = ("$pwd",);
    $count=0;
    find(\&wanted, @sesdir);
      my $retuser = retrieve ($userfile);
      $CDSips = $retuser -> {CDSip};
     # print "CDS in file " . $CDSips . "\n";
    if ( ($CDSip ne "") && ($CDSips ne "generic") ) {
    $detfile=$pwd . "/" . $CDSip . "_details";
    }
    elsif ( ($CDSip ne "") && ($CDSips eq "generic") ) {
    $detfile=$pwd . "/generic_details";
    }
   if ($count == 1) {
    $sesfile=$userfile;
  }
   if ($count > 1) {
    $sesfile=$detfile; 
  }
  if (!-e $sesfile) {
   die "CDS user details file is missing\n";
  }
    my $retuser = retrieve ($sesfile);
    my $username = $retuser -> {username};
    my $password_en = $retuser -> {password};

   # my $CDSip = $retuser -> {CDSip};

    #print "user is ". $username . "\n";
    #print "CDSip is ". $CDSip . "\n";

    #Authenticate with CDS
    my $password_de = MIME::Base64::decode($password_en);
    my $pass_enc = uri_escape($password_de); 
    my $auth_url = 'https://' . $CDSip . '/actifio/api/login?name=' . $username . '&password=' . $pass_enc . '&vendorkey=act';
    my $context = new IO::Socket::SSL::SSL_Context(
          SSL_version => 'tlsv1',
          SSL_verify_mode => Net::SSLeay::VERIFY_NONE(),
    );
    IO::Socket::SSL::set_default_context($context);
    
    $ua = LWP::UserAgent->new;

    my $res = $ua->get($auth_url);

    my $res_str =  $res->content;
   # print "res_str : " . $res_str . "\n";
    my $json_r = JSON->new->utf8;
    my $JSON_RES = $json_r->decode($res_str);
    my $sessionid = $JSON_RES->{'sessionid'};

    scriptlog("sessionid: " . $sessionid . "\n");

    return $sessionid;
}

sub listmountpoint {
    my ($bname) = @_;
    $sessionid = getSession();
    #my $retuser = retrieve ($sesfile);
    #$CDSip = $retuser -> {CDSip};
    if ( $sessionid eq "" ) {
        die "Authentication is not established\n";
    }

    my $imgt_url = 'https://' . $CDSip . '/actifio/api/info/lsbackup?sessionid=' . $sessionid . '&argument=' . $bname;
    $ua = LWP::UserAgent->new;
    my $imgt_res = $ua->get($imgt_url);
    my $imgt_res_str = $imgt_res->content;

    my $imgt_json_r = JSON->new->utf8;
    my $IMGT_RES = $imgt_json_r->decode($imgt_res_str);
    my $backupt = $IMGT_RES->{'result'};
    print $bkpname . ":\n";

    my $asmDG = "";
    my $archflag = "";

    $asmDG = $backupt->{"  mountedmountpoint"};
    
              if ( $backupt->{"  beginpit"} ne "" ) {
                 print "archive log backup exists \n";
                 $archflag="yes";
             }

    print "ASM DG: " . $asmDG . "\n";
    print "Archive flag: " . $archflag . "\n";
    return $asmDG . ":" . $archflag;
}

sub getHost {
   # my $retuser = retrieve ($sesfile);
    #$CDSip = $retuser -> {CDSip};
    #print "actual CDS is " . $CDSip . "\n"; 
  #  my $host_url ='https://' . $CDSip . '/actifio/api/info/lshost?sessionid=' . $sessionid . '&argument=' . $hostname;
    my $host_url ='https://' . $CDSip . '/actifio/api/info/lshost?sessionid=' . $sessionid . '&filtervalue=hostname%3D' . $hostname; 
    $ua = LWP::UserAgent->new;
    my $host_res = $ua->get($host_url);
    my $host_res_str =  $host_res->content;
    my $host_json_r = JSON->new->utf8;
    my $HOST_RES = $host_json_r->decode($host_res_str);
    my $hostid = $HOST_RES->{'result'}->[0]->{'id'};
    scriptlog("host id is " . $hostid . "\n");

    return $hostid;
}

sub getApp {
    my $retuser = retrieve ($sesfile);
    #$CDSip = $retuser -> {CDSip};
    my $app_url = 'https://' . $CDSip . '/actifio/api/info/lsapplication?sessionid=' . $sessionid . '&filtervalue=hostid%3D' . $hostid . '%26appname%3D' . $dbname;
    $ua = LWP::UserAgent->new;
    my $app_res = $ua->get($app_url);

    my $app_res_str = $app_res->content;
    my $app_json_r = JSON->new->utf8;
    my $APP_RES = $app_json_r->decode($app_res_str);
    my $appid = $APP_RES->{'result'}->[0]->{'id'};
    my $origappid = $APP_RES->{'result'}->[0]->{'originalappid'};

    if ( $origappid ne "0" ) {
        $appid = $origappid;
     }
   # printf "App id is " . $appid . "\n";
   # printf "Original App id is " . $origappid . "\n";
     scriptlog("App id is " . $appid . "\n");
    return $appid;
}

my $rhostid;
sub getOhostid {
    my ($remoteapp) = @_;
    my $retuser = retrieve ($sesfile);
    #$CDSip = $retuser -> {CDSip};

   #my $subhost_url ='https://' . $CDSip . '/actifio/api/info/lshost?sessionid=' . $sessionid . '&argument=' . $hostid;
   my $host_url ='https://' . $CDSip . '/actifio/api/info/lshost?sessionid=' . $sessionid . '&filtervalue=hostname%3D' . $hostname;
    $ua = LWP::UserAgent->new;
    my $subhost_res = $ua->get($host_url);
    my $subhost_res_str =  $subhost_res->content;
    my $subhost_json_r = JSON->new->utf8;
    my $SUB_HOST_RES = $subhost_json_r->decode($subhost_res_str);
    my @hosts = @{$SUB_HOST_RES->{'result'}};

    foreach my $host (@hosts) {
       my $hostid = $host->{'id'};
       my $subhostid = $host->{'id'};
   #print "sub host id is " . $subhostid . "\n";
    my $osubhostid = $host->{'originalhostid'};
   #print "remote app is " . $remoteapp . "\n";
        if ( $osubhostid ne "0" ) {
        $hostid = $osubhostid;
       }
        if ( $remoteapp eq "yes" ) {
           if ( $osubhostid ne "0" ) {
               $hostid = $subhostid;
           }

       }
 #print "host id is " . $hostid . "\n";
  $rhostid = $hostid;
}
#print "host id in return " . $rhostid . "\n";
    return $rhostid;
}

my $fbkps;

sub getLatestImage {
    my $retuser = retrieve ($sesfile);
   # $CDSip = $retuser -> {CDSip};

     $hostid=getOhostid($remoteapp);
    if ($imagetype eq "") {
        $imagetype="snapshot";
    }
    print "hostid is " . $hostid . "\n";
    print "image type is " . $imagetype . "\n";
    my $img_url = 'https://' . $CDSip . '/actifio/api/info/lsbackup?sessionid=' . $sessionid . '&filtervalue=jobclass%3D' . $imagetype . '%26appid%3D' . $appid;
  #  my $img_url = 'https://' . $CDSip . '/actifio/api/info/lsbackup?sessionid=' . $sessionid . '&filtervalue=appid%3D' . $appid;
    $ua = LWP::UserAgent->new;
    my $img_res = $ua->get($img_url);

    my $img_res_str = $img_res->content;

    my $img_json_r = JSON->new->utf8;
    my $IMG_RES = $img_json_r->decode($img_res_str);
    my @backupo = @{$IMG_RES->{'result'}};
    # print "backup arrary is " . $img_json_r->decode($img_res_str) . "\n";
  #  my @backups = sort{$b cmp $a} @backupo;
   # my @backups = sort{$a cmp $b} @backupo;
        my @backups;
        foreach my $backup (@backupo) {
          my $bkpname = $backup->{backupname};
          @bkpidarray = split /_/, $bkpname;
           my ($bkps,$bkpi)=split('_',reverse($bkpname),2); # reverse and split.

$bkps = reverse($bkps); # reverse each piece.
$bkpi = reverse($bkpi);

($bkps,$bkpi) = ($bkpi,$bkps); # swap
   print "first backup str is " . $bkps . "\n";
   $fbkps = $bkps;
        #   my $bkpid = $bkpidarray[-1];
        push(@backups, ($bkpi));
       }

      my @backup_sort = sort{$b <=> $a} @backups;
    printf "backup names in sort order " . @backup_sort . "\n";
    print join(" \n ", @backup_sort);
      foreach my $backupid (@backup_sort) {
       # my $backupname = $backup->{backupname};
      printf "backup string is " . $fbkps . " \n";
     printf "backup id is " . $backupid . " \n";
       my $backupname = $fbkps . "_" . $backupid;
       printf "backup name is " . $backupname . " \n";
       printf "Image Type is " . $imagetype . "\n";
        my $imgb_url = 'https://' . $CDSip . '/actifio/api/info/lsbackup?sessionid=' . $sessionid . '&argument=' . $backupname;
            my $imgb_res = $ua->get($imgb_url);
           my $imgb_res_str = $imgb_res->content;

         my $imgb_json_r = JSON->new->utf8;
         my $IMGB_RES = $imgb_json_r->decode($imgb_res_str);
        my $backupb = $IMGB_RES->{'result'};
         if ( ( $backupb->{"logsmarttype"} eq "" ) || ( $backupb->{"    sourcemountpoint"} eq "$dbname" ) ) {
                my $imageid = $backupb->{id};
                my $backupnameb = $backupb->{backupname};
                print "Image ID " . $imageid . " name " . $backupnameb . "\n";
                return $imageid .":". $backupnameb;
                last;
	    }

    }
}

sub getImageDetailsByName {
    my ($bname) = @_;
    my $retuser = retrieve ($sesfile);
   # $CDSip = $retuser -> {CDSip};
    my $img_url = 'https://' . $CDSip . '/actifio/api/info/lsbackup?sessionid=' . $sessionid . '&argument=' . $bname;
    #printf $img_url . "\n";
    $ua = LWP::UserAgent->new;
    my $img_res = $ua->get($img_url);

    my $img_res_str = $img_res->content;

    my $img_json_r = JSON->new->utf8;
    my $IMG_RES = $img_json_r->decode($img_res_str);

    my $backup = $IMG_RES->{'result'};

    #print "endpit=". $backup->{"  endpit"} . "\n";
    #print "beginpit='". $backup->{"  beginpit"} . "'\n";
    $epit = $backup->{"  endpit"};
    #foreach my $key (keys %{$backup}) {
     #   if (index($key, "  endpit") != -1) {
            #print $key . "=". $backup->{$key} . "\n";
	#	$epit = $backup->{$key};
	#print "end point is " . $epit . "\n";
        #}
	return $epit;

      #  if (index($key, "  beginpit") != -1) {
       #     print $key . "=". $backup->{$key} . "\n";
       # }
    #}
}

sub getImagebyLabel {
    my $retuser = retrieve ($sesfile);
   # $CDSip = $retuser -> {CDSip};
    my $img_url = 'https://' . $CDSip . '/actifio/api/info/lsbackup?sessionid=' . $sessionid . '&filtervalue=label%3D' . $bkplabelid . '%26hostid%3D' . $hostid . '%26appid%3D' . $appid;
    $ua = LWP::UserAgent->new;
    my $img_res = $ua->get($img_url);

    my $img_res_str = $img_res->content;

    my $img_json_r = JSON->new->utf8;
    my $IMG_RES = $img_json_r->decode($img_res_str);

    my @backups = @{$IMG_RES->{'result'}};
    my $backup = pop @backups;
    my $imageid = $backup->{id};
    my $backupname = $backup->{backupname};

    scriptlog("firstbackupname=" . $backupname . "\n");

    return $imageid .":". $backupname;
}

sub listImageDetails {
    $sessionid = getSession();
    my $retuser = retrieve ($sesfile);
    #$CDSip = $retuser -> {CDSip};
    if ( $sessionid eq "" ) {
        die "Authentication is not established\n";
    }

    $hostname=$sourceHost;
    #Get Host
   #  $hostid = getHost();
    $hostid=getOhostid($remoteapp);
     if ( $hostid eq "" ) {
    	 die "could not get hostid\n";
                     }
    
     #Get Application
     $appid = getApp();
     if ( $appid eq "" ) {
    	 die "could not get appid\n";
         }
    
    my $img_url = 'https://' . $CDSip . '/actifio/api/info/lsbackup?sessionid=' . $sessionid . '&filtervalue=jobclass%3Dsnapshot' . '%26hostid%3D' . $hostid . '%26appid%3D' . $appid;
   # my $img_url = 'https://' . $CDSip . '/actifio/api/info/lsbackup?sessionid=' . $sessionid . '&filtervalue=hostid%3D' . $hostid . '%26appid%3D' . $appid;
    $ua = LWP::UserAgent->new;
    my $img_res = $ua->get($img_url);

    my $img_res_str = $img_res->content;
    my $img_json_r = JSON->new->utf8;
    my $IMG_RES = $img_json_r->decode($img_res_str);
    print "Database Name: " . $dbname . "\n";
    print "Host Name: " . $hostname . "\n";
    #print "Backup Image and Recovery Range:\n";
    #print "Snapshot Pool Images:\n";
    my @backups = @{$IMG_RES->{'result'}};
 
    my @rbackups = reverse @backups;      
  
    foreach my $backup (@rbackups) {
        my $backupname = $backup->{backupname};
        my $jobc = $backup->{jobclass};
        if ( $jobc ne "mount" ) {
        my $imgt_url = 'https://' . $CDSip . '/actifio/api/info/lsbackup?sessionid=' . $sessionid . '&argument=' . $backupname;
            my $imgt_res = $ua->get($imgt_url);
            my $imgt_res_str = $imgt_res->content;

         my $imgt_json_r = JSON->new->utf8;
         my $IMGT_RES = $imgt_json_r->decode($imgt_res_str);
         my $backupt = $IMGT_RES->{'result'};
         if ( ( $backupt->{"logsmarttype"} eq "" ) || ( $backupt->{"sourcemountpoint"} eq "$dbname" ) ) {
           my $backupnameb = $backupt->{backupname};
         print "\n";
         print $backupt->{"jobclass"} .  " Image and Recovery Range:\n";
         print $backupnameb . ":\n";
         %hash = %$backupt;
         @begin = ();
         @end = ();
         for my $key ( keys %hash ) {
             if ($key =~ /^beginLSN/) {
                 push(@begin, $key);
             }
             if ($key =~ /^endLSN/) {
                 push(@end, $key);
             }
         }

         my $size = @begin;
         my $index = 1;
         if ( $backupt->{"label"} ne "" ) {
            print "Backup Label: '" . $backupt->{"label"} . "' \n";
         }

         if ( $backupt->{"beginpit"} ne "" ) {
             print "RecoveryST: '" . $backupt->{"beginpit"} . "'  RecoveryET: '" . $backupt->{"endpit"} . "' \n";
             my $index = 1;
             while ($index <= $size) {
                 print "Thread" . $index . ":        StartSequence: " . $backupt->{"beginLSN_thread_" . $index} . "         EndSequence: " . $backupt->{"endLSN_thread_". $index} . "\n";
                 $index = $index + 1;
             }
         }
         if ( $backupt->{"beginpit"} eq "" ) {
             $backupt->{"backupdate"}=~s/(\.\d+)//;
             $backupt->{"expiration"}=~s/(\.\d+)//;
             print "RecoveryST: '" . $backupt->{"backupdate"} . "'  RecoveryET: '" . $backupt->{"backupdate"} . "' \n";
         }

         #sleep(1);
	select(undef, undef, undef, 0.50); 
         }
	}
     }
my $img_url = 'https://' . $CDSip . '/actifio/api/info/lsbackup?sessionid=' . $sessionid . '&filtervalue=hostid%3D' . $hostid . '%26appid%3D' . $appid;
    $ua = LWP::UserAgent->new;
    my $img_res = $ua->get($img_url);

    my $img_res_str = $img_res->content;
    my $img_json_r = JSON->new->utf8;
    my $IMG_RES = $img_json_r->decode($img_res_str);
    print "Database Name: " . $dbname . "\n";
    print "Host Name: " . $hostname . "\n";
    #print "Backup Image and Recovery Range:\n";
    #print "Snapshot Pool Images:\n";
    my @backups = @{$IMG_RES->{'result'}};

    my @rbackups = reverse @backups;

    foreach my $backup (@rbackups) {
        my $backupname = $backup->{backupname};
        my $jobc = $backup->{jobclass};
        if ( ( $jobc ne "mount" ) && ( $jobc ne "snapshot" ) ) {
        my $imgt_url = 'https://' . $CDSip . '/actifio/api/info/lsbackup?sessionid=' . $sessionid . '&argument=' . $backupname;
            my $imgt_res = $ua->get($imgt_url);
            my $imgt_res_str = $imgt_res->content;

         my $imgt_json_r = JSON->new->utf8;
         my $IMGT_RES = $imgt_json_r->decode($imgt_res_str);
         my $backupt = $IMGT_RES->{'result'};
         if ( ( $backupt->{"logsmarttype"} eq "" ) || ( $backupt->{"sourcemountpoint"} eq "$dbname" ) ) {
           my $backupnameb = $backupt->{backupname};
         print "\n";
         print $backupt->{"jobclass"} .  " Image and Recovery Range:\n";
         print $backupnameb . ":\n";
         %hash = %$backupt;
         @begin = ();
         @end = ();
         for my $key ( keys %hash ) {
             if ($key =~ /^beginLSN/) {
                 push(@begin, $key);
             }
             if ($key =~ /^endLSN/) {
                 push(@end, $key);
             }
         }

         my $size = @begin;
         my $index = 1;
         if ( $backupt->{"label"} ne "" ) {
            print "Backup Label: '" . $backupt->{"label"} . "' \n";
         }

         if ( $backupt->{"beginpit"} ne "" ) {
             print "RecoveryST: '" . $backupt->{"beginpit"} . "'  RecoveryET: '" . $backupt->{"endpit"} . "' \n";
             my $index = 1;
             while ($index <= $size) {
                 print "Thread" . $index . ":        StartSequence: " . $backupt->{"beginLSN_thread_" . $index} . "         EndSequence: " . $backupt->{"endLSN_thread_". $index} . "\n";
                 $index = $index + 1;
             }
         }
         if ( $backupt->{"beginpit"} eq "" ) {
             $backupt->{"backupdate"}=~s/(\.\d+)//;
             $backupt->{"expiration"}=~s/(\.\d+)//;
             print "RecoveryST: '" . $backupt->{"backupdate"} . "'  RecoveryET: '" . $backupt->{"backupdate"} . "' \n";
         }
    #sleep(1);
        select(undef, undef, undef, 0.50);
         }
        }
   }   
 }
sub getLatestMountImage {
    my $retuser = retrieve ($sesfile);
   # $CDSip = $retuser -> {CDSip};

   my $img_url = 'https://' . $CDSip . '/actifio/api/info/lsbackup?sessionid=' . $sessionid . '&filtervalue=jobclass%3Dmount' . '%26hostid%3D' . $hostid . '%26appid%3D' . $appid . '%26mountedhost%3D' . $thostid;
    $ua = LWP::UserAgent->new;
    my $img_res = $ua->get($img_url);

    my $img_res_str = $img_res->content;

    my $img_json_r = JSON->new->utf8;
    my $IMG_RES = $img_json_r->decode($img_res_str);
    #printf "latest mount points " . $IMG_RES->{'result'} . " \n";
    my @backups = @{$IMG_RES->{'result'}};
    my $backup = pop @backups;
    my $imageid = $backup->{id};
    my $backupname = $backup->{backupname};

    printf "firstbackupname=" . $backupname . "\n";

    return $imageid .":". $backupname;
}

sub getCloneMountImage {
    my $retuser = retrieve ($sesfile);
   # $CDSip = $retuser -> {CDSip};

   # my $img_url = 'https://' . $CDSip . '/actifio/api/info/lsbackup?sessionid=' . $sessionid . '&filtervalue=jobclass%3Dmount' . '%26hostid%3D' . $hostid . '%26appid%3D' . $appid;
    my $fimgid_url = 'https://' . $CDSip . '/actifio/api/info/lsapplication?sessionid=' . $sessionid . '&filtervalue=appname%3D' . $dbname;
    $ua = LWP::UserAgent->new;
    my $img_res = $ua->get($fimgid_url);

    my $img_res_str = $img_res->content;

	    my $img_json_r = JSON->new->utf8;
	    my $IMG_RES = $img_json_r->decode($img_res_str);
    #printf "latest mount points " . $IMG_RES->{'result'} . " \n";
    my @apps = @{$IMG_RES->{'result'}};
    my $app = pop @apps;
    my $appid = $app->{id};
#    my $backupname = $app->{backupname};
    my $fapp_url = 'https://' . $CDSip . '/actifio/api/info/lsapplication?sessionid=' . $sessionid . '&argument=' . $appid;
    my $app_res = $ua->get($fapp_url);

    my $app_res_str = $app_res->content;

            my $app_json_r = JSON->new->utf8;
            my $APP_RES = $app_json_r->decode($app_res_str);
   # printf "latest mount points " . $APP_RES->{'result'} . " \n";
	my $backupname = $APP_RES->{'result'}->{backupname};
printf "image details " . $appid . " backup name " . $backupname . "\n";
 
    return $appid .":". $backupname;
}

sub getLatestMountImagebyHost {
    my $retuser = retrieve ($sesfile);
   # $CDSip = $retuser -> {CDSip};

    my $img_url = 'https://' . $CDSip . '/actifio/api/info/lsbackup?sessionid=' . $sessionid . '&filtervalue=jobclass%3Dmount' . '%26hostid%3D' . $hostid . '%26appid%3D' . $appid . '%26mountedhost%3D' . $thostid;
    $ua = LWP::UserAgent->new;
    my $img_res = $ua->get($img_url);

    my $img_res_str = $img_res->content;

    my $img_json_r = JSON->new->utf8;
    my $IMG_RES = $img_json_r->decode($img_res_str);
    my @backups = @{$IMG_RES->{'result'}};

foreach my $backup (@backups) {
           my $backupname = $backup->{backupname};

           my $imgt_url = 'https://' . $CDSip . '/actifio/api/info/lsbackup?sessionid=' . $sessionid . '&argument=' . $backupname;
           my $imgt_res = $ua->get($imgt_url);
           my $imgt_res_str = $imgt_res->content;

           my $imgt_json_r = JSON->new->utf8;
           my $IMGT_RES = $imgt_json_r->decode($imgt_res_str);
           my $backupt = $IMGT_RES->{'result'};
           print $backupname . ":\n";
           $mntpts = $backupt->{"  mountedmountpoint"};
      if ( $mntpts eq "$taname" ) {
        printf "firstbackupname=" . $backupname . "\n";
        $backupname=$backupt->{backupname};
        $imageid=$backup->{id};
        return $imageid .":". $backupname;
        last;
           }
      }
}

sub jobStatus {
    my $retuser = retrieve ($sesfile);
   # $CDSip = $retuser -> {CDSip};
    my $stat_url = 'https://' . $CDSip . '/actifio/api/info/lsjob?sessionid=' . $sessionid . '&argument=' . $job_name;
    my $stathist_url = 'https://' . $CDSip . '/actifio/api/info/lsjobhistory?sessionid=' . $sessionid . '&argument=' . $job_name;
    $ua = LWP::UserAgent->new;
    my $stat_res = $ua->get($stat_url);
    
    my $stat_res_str = $stat_res->content;
    my $stat_json_r = JSON->new->utf8;
    my $STAT_RES = $stat_json_r->decode($stat_res_str);
    $job_status = $STAT_RES->{'result'}->{'status'};
    $job_error = $STAT_RES->{'errorcode'};

    return $job_status .":". $job_error;
}

sub backup {
    $sessionid = getSession();
    my $retuser = retrieve ($sesfile);
  #  $CDSip = $retuser -> {CDSip};
    if ( $sessionid eq "" ) {
        die "Authentication is not established\n";
    }

    #Get Host
    $hostid = getHost();
    if ( $hostid eq "" ) {
        die "could not get hostid\n";
    }

    #Get Application
    $appid = getApp();
    if ( $appid eq "" ) {
        die "could not get appid\n";
    }

    #Get SLT
    my $sla_url = 'https://' . $CDSip . '/actifio/api/info/lssla?sessionid=' . $sessionid . '&filtervalue=appid%3D' . $appid;
    my $sla_res = $ua->get($sla_url);

    my $sla_res_str = $sla_res->content;
    my $sla_json_r = JSON->new->utf8;
    my $SLA_RES = $sla_json_r->decode($sla_res_str);
    my $sltid = $SLA_RES->{'result'}->[0]->{'sltid'};
    #printf "sltid=" . $sltid . "\n";
    scriptlog("sltid=" . $sltid . "\n");
    if ( $sltid eq " " ) {
        die "could not get sltid\n";
    }

    #Get Policy
    my $policy_url = 'https://' . $CDSip . '/actifio/api/info/lspolicy?sessionid=' . $sessionid . '&filtervalue=sltid%3D' . $sltid;
    my $policy_res = $ua->get($policy_url);

    my $policy_res_str = $policy_res->content;
    my $policy_json_r = JSON->new->utf8;
    my $POLICY_RES = $policy_json_r->decode($policy_res_str);

    my @policies = @{$POLICY_RES->{'result'}};
    my $policyid = 0;
    foreach my $policy (@policies) {
        if ($policy->{"op"} eq "snap") {
            $policyid = $policy->{'id'};
            break;
        }
    }
    printf "policyid=" . $policyid . "\n";
    if ( $policyid eq " " ) {
        die "could not get policyid\n";
    }
       $bkp_string = '&app=' . $appid . '&policy=' . $policyid . '&backuptype=' . $bkptype;
    if ( $backlabel ne "" ) {
      $bkp_string = $bkp_string . '&label=' . $backlabel;
	}
    my $bkp_url = 'https://' . $CDSip . '/actifio/api/task/backup?sessionid=' . $sessionid . $bkp_string;
    my $bkp_res = $ua->post($bkp_url);
    my $bkp_res_str =  $bkp_res->content;
    my $bkp_json_r = JSON->new->utf8;
    my $BKP_RES = $bkp_json_r->decode($bkp_res_str);
    my $req_status = $BKP_RES->{'errorcode'};

    if ($req_status > 0) {
        my $errorcode = $BKP_RES->{'errorcode'};
        my $errmsg = $BKP_RES->{'errormessage'};
        $re_code = $errorcode;
        scriptlog("Failed: " . $errorcode . " - " . $errmsg . "\n");
        print "Failed: " . $errorcode . " - " . $errmsg . "\n";
        exit $re_code;
    }

    $job_name = $BKP_RES->{'result'};
    print $job_name. "\n";
    scriptlog("Backup Job ". $job_name. "is started \n");
    if ($statuswait eq "yes") {
        $job_stat = jobStatus();
        @jobstatarray = split /:/, $job_stat;
        $job_status = $jobstatarray[0];
        $job_error = $jobstatarray[1];

        while ( $job_error ne "10016" ) {
            sleep(60);
            $job_stat = jobStatus();
            @jobstatarray = split /:/, $job_stat;
            $job_status = $jobstatarray[0];
            $job_error = $jobstatarray[1];
        }

        if ($job_error eq "10016"){
            my $stathist_url = 'https://' . $CDSip . '/actifio/api/info/lsjobhistory?sessionid=' . $sessionid . '&argument=' . $job_name;
            $ua = LWP::UserAgent->new;
            my $stathist_res = $ua->get($stathist_url);

            my $stathist_res_str = $stathist_res->content;
            my $stathist_json_r = JSON->new->utf8;
            my $STATHIST_RES = $stathist_json_r->decode($stathist_res_str);
            $job_status = $STATHIST_RES->{'result'}->{'status'};
            $job_errcode = $STATHIST_RES->{'result'}->{'errorcode'};
            $job_errmsg = $STATHIST_RES->{'result'}->{'message'};
            print "Backup Job " . $job_name . " Status is " . $job_status . "\n";
	         #my $pwd = cwd();
	        # my $logfile_name=$pwd . "/actDBMlog.log";
	        # open FILE_HANDLE, ">>$logfile_name" or die "cannot open file : $!\n";
            scriptlog("Backup Job " . $job_name . " Status is " . $job_status . "\n");
        }
        $re_code = 0;
	if ($job_status ne "succeeded") {
            $re_code = $job_errcode;
            print $job_errmsg . "\n";
            scriptlog($job_errmsg . "\n");
        }
	 exit $re_code;
    }
}

sub createliveclone {
    $sessionid = getSession();
    my $retuser = retrieve ($sesfile);
  #  $CDSip = $retuser -> {CDSip};

    if ( $sessionid eq "" ) {
        die "Authentication is not established\n";
    }

    $hostid = getHost();
    if ( $hostid eq "" ) {
        die "could not get hostid\n";
    }

    $appid = getApp();
    if ( $appid eq "" ) {
        die "could not get appid\n";
    }

    if ($simage ne "") {
        $bkpname=$simage;
        }
    if ( ($simage eq "") && ($bkplabelid ne "") ) {
    $bkpstring = getImagebyLabel();
    @bkparray = split /:/, $bkpstring;
    $imageid = $bkparray[0];
    $bkpname = $bkparray[1];
    print "image id is " . $imageid ."\n";
    print "image name is " . $bkpname ."\n";
    }

    if ( ($simage eq "") && ($bkplabelid eq "") ) {
    $bkpstring = getLatestImage();
    @bkparray = split /:/, $bkpstring;
    $imageid = $bkparray[0];
    $bkpname = $bkparray[1];
    print "image id is " . $imageid ."\n";
    print "image name is " . $bkpname ."\n";
    }

    if ( $bkpname eq "" ) {
        die "could not get latest imagename\n";
    }

    $lvstring='&nowait=true&sourceimage=' . $bkpname . '&label=' . $lclabel . '&diskpool=' . $dpool;
    my $uri = URI::Encode->new( { double_encode => 0 } );
    $refencoded = $uri->encode($lvstring);

    my $lvc_url = 'https://' . $CDSip . '/actifio/api/task/createliveclone?sessionid=' . $sessionid . $refencoded;
    my $lvc_res = $ua->post($lvc_url);
    my $lvc_res_str =  $lvc_res->content;
    my $lvc_json_r = JSON->new->utf8;
    my $LVC_RES = $lvc_json_r->decode($lvc_res_str);
    my $req_status = $LVC_RES->{'errorcode'};

    if ($req_status > 0) {
        my $errorcode = $MOUNT_RES->{'errorcode'};
        my $errmsg = $MOUNT_RES->{'errormessage'};
        $re_code=$errorcode;
        print "Failed: " . $errorcode . " - " . $errmsg . "\n";
        scriptlog("Failed: " . $errorcode . " - " . $errmsg . "\n");
        exit $re_code;
    }
    $job_name_lvc = $LVC_RES->{'result'};
    my @words = split / /, $job_name_lvc;
    $job_name = $words[0];
    printf $job_name_lvc . "\n";

    if ($statuswait eq "yes") {
        $job_stat = jobStatus();
        @jobstatarray = split /:/, $job_stat;
        $job_status = $jobstatarray[0];
        $job_error = $jobstatarray[1];

        while ( $job_error ne "10016" ) {
            sleep(60);
            $job_stat = jobStatus();
            @jobstatarray = split /:/, $job_stat;
            $job_status = $jobstatarray[0];
            $job_error = $jobstatarray[1];
        }

        if ($job_error eq "10016"){
            my $stathist_url = 'https://' . $CDSip . '/actifio/api/info/lsjobhistory?sessionid=' . $sessionid . '&argument=' . $job_name;
            $ua = LWP::UserAgent->new;
            my $stathist_res = $ua->get($stathist_url);

            my $stathist_res_str = $stathist_res->content;
            my $stathist_json_r = JSON->new->utf8;
            my $STATHIST_RES = $stathist_json_r->decode($stathist_res_str);
            $job_status = $STATHIST_RES->{'result'}->{'status'};
            $job_errcode = $STATHIST_RES->{'result'}->{'errorcode'};
            $job_errmsg = $STATHIST_RES->{'result'}->{'message'};
            print "Liveclone Job " . $job_name . " Status is " . $job_status . "\n";
            scriptlog("Liveclone Job " . $job_name . " Status is " . $job_status . "\n");
        }
        $re_code = 0;
        if ($job_status ne "succeeded") {
            $re_code = $job_errcode;
            print $job_errmsg . "\n";
            scriptlog($job_errmsg . "\n");
        }

        exit $re_code;
    }
}

sub refreshliveclone {
    $sessionid = getSession();
    my $retuser = retrieve ($sesfile);
  #  $CDSip = $retuser -> {CDSip};

    if ( $sessionid eq "" ) {
        die "Authentication is not established\n";
    }

    $hostid = getHost();
    if ( $hostid eq "" ) {
        die "could not get hostid\n";
    }

    $appid = getApp();
    if ( $appid eq "" ) {
        die "could not get appid\n";
    }

    if ($simage ne "") {
        $bkpname=$simage;
        }
    if ( ($simage eq "") && ($bkplabelid ne "") ) {
    $bkpstring = getImagebyLabel();
    @bkparray = split /:/, $bkpstring;
    $imageid = $bkparray[0];
    $bkpname = $bkparray[1];
    print "image id is " . $imageid ."\n";
    print "image name is " . $bkpname ."\n";
    }

    if ( ($simage eq "") && ($bkplabelid eq "") ) {
    $bkpstring = getLatestImage();
    @bkparray = split /:/, $bkpstring;
    $imageid = $bkparray[0];
    $bkpname = $bkparray[1];
    print "image id is " . $imageid ."\n";
    print "image name is " . $bkpname ."\n";
    }

    if ( $bkpname eq "" ) {
        die "could not get latest imagename\n";
    }

    $lvstring='&nowait=true&sourceimage=' . $bkpname;
    if ( $lclabel ne "" ) {
     $lvstring= $lvstring . '&label=' . $lclabel;
    }
   # if ( ( $lclabel eq "" ) && (timage ne "") ) {
    # $lvstring= $lvstring . '&targetimage=' . $timage;
    #}
    my $uri = URI::Encode->new( { double_encode => 0 } );
    $refencoded = $uri->encode($lvstring);

    my $lvc_url = 'https://' . $CDSip . '/actifio/api/task/refreshliveclone?sessionid=' . $sessionid . $refencoded;
    my $lvc_res = $ua->post($lvc_url);
    my $lvc_res_str =  $lvc_res->content;
    my $lvc_json_r = JSON->new->utf8;
    my $LVC_RES = $lvc_json_r->decode($lvc_res_str);
    my $req_status = $LVC_RES->{'errorcode'};

    if ($req_status > 0) {
        my $errorcode = $MOUNT_RES->{'errorcode'};
        my $errmsg = $MOUNT_RES->{'errormessage'};
        $re_code=$errorcode;
        print "Failed: " . $errorcode . " - " . $errmsg . "\n";
        scriptlog("Failed: " . $errorcode . " - " . $errmsg . "\n");
        exit $re_code;
    }
    $job_name_lvc = $LVC_RES->{'result'};
    my @words = split / /, $job_name_lvc;
    $job_name = $words[0];
    printf $job_name_lvc . "\n";

    if ($statuswait eq "yes") {
        $job_stat = jobStatus();
        @jobstatarray = split /:/, $job_stat;
        $job_status = $jobstatarray[0];
        $job_error = $jobstatarray[1];

        while ( $job_error ne "10016" ) {
            sleep(60);
            $job_stat = jobStatus();
            @jobstatarray = split /:/, $job_stat;
            $job_status = $jobstatarray[0];
            $job_error = $jobstatarray[1];
        }

        if ($job_error eq "10016"){
            my $stathist_url = 'https://' . $CDSip . '/actifio/api/info/lsjobhistory?sessionid=' . $sessionid . '&argument=' . $job_name;
            $ua = LWP::UserAgent->new;
            my $stathist_res = $ua->get($stathist_url);

            my $stathist_res_str = $stathist_res->content;
            my $stathist_json_r = JSON->new->utf8;
            my $STATHIST_RES = $stathist_json_r->decode($stathist_res_str);
            $job_status = $STATHIST_RES->{'result'}->{'status'};
            $job_errcode = $STATHIST_RES->{'result'}->{'errorcode'};
            $job_errmsg = $STATHIST_RES->{'result'}->{'message'};
            print "Liveclone Job " . $job_name . " Status is " . $job_status . "\n";
            scriptlog("Liveclone Job " . $job_name . " Status is " . $job_status . "\n");
        }
        $re_code = 0;
        if ($job_status ne "succeeded") {
            $re_code = $job_errcode;
            print $job_errmsg . "\n";
            scriptlog($job_errmsg . "\n"); 
        }

        exit $re_code;
    }
}

sub restore {
    $sessionid = getSession();
    my $retuser = retrieve ($sesfile);
  #  $CDSip = $retuser -> {CDSip};

    if ( $sessionid eq "" ) {
        die "Authentication is not established\n";
    }

    $hostid = getHost();
    if ( $hostid eq "" ) {
        die "could not get hostid\n";
    }

    $appid = getApp();
    if ( $appid eq "" ) {
        die "could not get appid\n";
    }

    if ($image ne "") {
        $bkpname=$image;
        }
    if ( ($image eq "") && ($bkplabelid ne "") ) {
    $bkpstring = getImagebyLabel();
    @bkparray = split /:/, $bkpstring;
    $imageid = $bkparray[0];
    $bkpname = $bkparray[1];
    print "image id is " . $imageid ."\n";
    print "image name is " . $bkpname ."\n";
    }

    if ( ($image eq "") && ($bkplabelid eq "") ) {
    $bkpstring = getLatestImage();
    @bkparray = split /:/, $bkpstring;
    $imageid = $bkparray[0];
    $bkpname = $bkparray[1];
    print "image id is " . $imageid ."\n";
    print "image name is " . $bkpname ."\n";
    }

    if ( $bkpname eq "" ) {
        die "could not get latest imagename\n";
    }
 
    $reststring='&nowait=true&image=' . $bkpname . '&restoreoption=';
  
    if ($osuser ne "") {
        $reststring = $reststring . '&username=' . $osuser;
    }
    if ($ospassword ne "") {
        $reststring = $reststring . '&password=' . $ospassword;
    }  
    if ($pointInTime ne "") {
        $reststring = $reststring . '&recoverytime=' . $pointInTime;
    }
    
    if ($openDB ne "") {
        $reststring = $reststring . '&recover=' . $openDB;
    }
   
    #if ($asmDG ne "") {
    #    $reststring=$reststring . 'volgroupname%3D' . $asmDG . '%2C';
    #}

    #if ($RACNodeList ne "") {
    #    $reststring=$reststring . 'asmracnodelist%3D' . $RACNodeList . '%2C';
    #}
   
    my $uri = URI::Encode->new( { double_encode => 0 } );
    $refencoded = $uri->encode($reststring);
    
    my $mnt_url = 'https://' . $CDSip . '/actifio/api/task/restoreimage?sessionid=' . $sessionid . $refencoded;
    my $mnt_res = $ua->post($mnt_url);
    my $mnt_res_str =  $mnt_res->content;
    my $mnt_json_r = JSON->new->utf8;
    my $MOUNT_RES = $mnt_json_r->decode($mnt_res_str);
    my $req_status = $MOUNT_RES->{'status'};

    if ($req_status eq "failure") {
        my $errorcode = $MOUNT_RES->{'errorcode'};
        my $errmsg = $MOUNT_RES->{'msg'};
        $re_code=$errorcode;
	print "Failed: " . $errorcode . " - " . $errmsg . "\n";
	scriptlog("Failed: " . $errorcode . " - " . $errmsg . "\n");
        exit $re_code;
    }

    $job_name_mnt = $MOUNT_RES->{'result'};
    my @words = split / /, $job_name_mnt;
    $job_name = $words[0];
    printf $job_name_mnt . "\n";

    if ($statuswait eq "yes") {
        $job_stat = jobStatus();
        @jobstatarray = split /:/, $job_stat;
        $job_status = $jobstatarray[0];
        $job_error = $jobstatarray[1];

        while ( $job_error ne "10016" ) {
            sleep(60);
            $job_stat = jobStatus();
            @jobstatarray = split /:/, $job_stat;
            $job_status = $jobstatarray[0];
            $job_error = $jobstatarray[1];
        }

        if ($job_error eq "10016"){
            my $stathist_url = 'https://' . $CDSip . '/actifio/api/info/lsjobhistory?sessionid=' . $sessionid . '&argument=' . $job_name;
            $ua = LWP::UserAgent->new;
            my $stathist_res = $ua->get($stathist_url);

            my $stathist_res_str = $stathist_res->content;
            my $stathist_json_r = JSON->new->utf8;
            my $STATHIST_RES = $stathist_json_r->decode($stathist_res_str);
            $job_status = $STATHIST_RES->{'result'}->{'status'};
            $job_errcode = $STATHIST_RES->{'result'}->{'errorcode'};
            print "Restore Job " . $job_name . " Status is " . $job_status . "\n";
            scriptlog("Restore Job " . $job_name . " Status is " . $job_status . "\n");
        }
        $re_code = 0;
        if ($job_status ne "succeeded") {
            $re_code = $job_errcode;
        }

        exit $re_code;
    }
}

sub clone {
    $sessionid = getSession();
   # my $retuser = retrieve ($sesfile);
  #  $CDSip = $retuser -> {CDSip};
    if ( $sessionid eq "" ) {
        die "Authentication is not established\n";
    }

    $hostname=$sourceHost;
    #Get Host
    #$hostid = getHost();
    $hostid = getOhostid($remoteapp);
    if ( $hostid eq "" ) {
        die "could not get hostid\n";
    }

    #Get Application
    $appid = getApp();
    if ( $appid eq "" ) {
        die "could not get appid\n";
    }

    #$hostid=getOhostid($hostid);

    if ($imagetype eq "") {
        $imagetype="snapshot";
    }

    #Get Latest Image
    if ($image ne "") {
	$bkpname=$image;
	}
    if ( ($image eq "") && ($bkplabelid ne "") ) {
    $bkpstring = getImagebyLabel();
    @bkparray = split /:/, $bkpstring;
    $imageid = $bkparray[0];
    $bkpname = $bkparray[1];
    print "image id is " . $imageid ."\n";
    print "image name is " . $bkpname ."\n";
    }

    if ( ($image eq "") && ($bkplabelid eq "") ) {
    $bkpstring = getLatestImage();
    @bkparray = split /:/, $bkpstring;
    $imageid = $bkparray[0];
    $bkpname = $bkparray[1];
    print "image id is " . $imageid ."\n";
    print "image name is " . $bkpname ."\n";
    }
    if ( $bkpname eq "" ) {
        die "could not get latest imagename\n";
    }

    $hostname=$targetHost;
    #Get Host
    $targethostid = getHost();
    if ( $targethostid eq "" ) {
        die "could not get hostid\n";
    }
    $appaware="true";
    $provstring='&nowait=true&image=' . $bkpname . '&host=' . $targetHost;
    
    if ($pointInTime eq "") {
    	$pointInTime = getImageDetailsByName($bkpname);
	print "Image details by name " . $pointInTime . "\n"; 
	}
    
    if ($pointInTime ne "") {
        $provstring = $provstring . '&recoverytime=' . $pointInTime;
    }

    $provstring = $provstring . '&restoreoption=reprotect%3D' . $pnewapp . '%2C';

    if ( ($template ne "") && ($profile ne "") && ($pnewapp eq "true") ) {
    my $sla_url = 'https://' . $CDSip . '/actifio/api/info/lsslt?sessionid=' . $sessionid . '&argument=' . $template;
    my $sla_res = $ua->get($sla_url);

    my $sla_res_str = $sla_res->content;
    my $sla_json_r = JSON->new->utf8;
    my $SLA_RES = $sla_json_r->decode($sla_res_str);
    my $sltid = $SLA_RES->{'result'}->{'id'};
    printf "sltid=" . $sltid . "\n";
        scriptlog("sltid=" . $sltid . "\n");
            if ( $sltid eq " " ) {
                    die "could not get sltid\n";
                        }

    $provstring=$provstring . 'sltid%3D' . $sltid . '%2C';
    my $slp_url = 'https://' . $CDSip . '/actifio/api/info/lsslp?sessionid=' . $sessionid . '&argument=' . $profile;
    my $slp_res = $ua->get($slp_url);

    my $slp_res_str = $slp_res->content;
    my $slp_json_r = JSON->new->utf8;
    my $SLP_RES = $slp_json_r->decode($slp_res_str);
    my $slpid = $SLP_RES->{'result'}->{'id'};
    printf "slpid=" . $slpid . "\n";
        scriptlog("slpid=" . $slpid . "\n");
            if ( $slpid eq " " ) {
                    die "could not get slpid\n";
                        }

    $provstring=$provstring . 'slpid%3D' . $slpid . '%2C';
    }
 
    if ($mountpoint ne "") {
        $provstring = $provstring . 'mountpointperimage%3D' . $mountpoint . '%2C';
    }

    if ($asmDG ne "") {
        $provstring=$provstring . 'volgroupname%3D' . $asmDG . '%2C'; 
    }

    if ($RACNodeList ne "") {
        $provstring=$provstring . 'asmracnodelist%3D' . $RACNodeList . '%2C';
    }
    if ($envvar ne "") {
    $provstring=$provstring . 'provisioningoptions%3D<provisioning-options><databasesid>' . $tdbname . '<%2Fdatabasesid><orahome>' . $torahome . '<%2Forahome><username>' . $osuser . '<%2Fusername><tnsadmindir>' . $ttnsadmin . '<%2Ftnsadmindir><tnsport>' .$tnsport. '<%2Ftnsport><totalmemory>' . $tmemory . '<%2Ftotalmemory><sgapct>' . $sgap . '<%2Fsgapct><shared_pool_size>' . $sharedpool . '<%2Fshared_pool_size><open_cursors>' . $opencursor . '<%2Fopen_cursors><diagnostic_dest>' . $diagdest . '<%2Fdiagnostic_dest><db_cache_size>' . $dbcache . '<%2Fdb_cache_size><db_recovery_file_dest_size>' . $dbrfds . '<%2Fdb_recovery_file_dest_size><processes>' . $process . '<%2Fprocesses><rrecovery>' .$rrecovery . '<%2Frrecovery><tnsip>' . $tnslip . '<%2Ftnsip><tnsdomain>' . $tnsdomain . '<%2Ftnsdomain><redosize>' . $redosize . '<%2Fredosize><standalone>' . $standalone . '<%2Fstandalone><notnsupdate>' . $donotupdatetns . '<%2Fnotnsupdate><nonid>' . $donotupdateDBid . '<%2Fnonid><envvar>' . $envvar . '<%2Fenvvar><%2Fprovisioning-options>';
	}
	else {
	$provstring=$provstring . 'provisioningoptions%3D<provisioning-options><databasesid>' . $tdbname . '<%2Fdatabasesid><orahome>' . $torahome . '<%2Forahome><username>' . $osuser . '<%2Fusername><tnsadmindir>' . $ttnsadmin . '<%2Ftnsadmindir><tnsport>' .$tnsport. '<%2Ftnsport><totalmemory>' . $tmemory . '<%2Ftotalmemory><sgapct>' . $sgap . '<%2Fsgapct><shared_pool_size>' . $sharedpool . '<%2Fshared_pool_size><open_cursors>' . $opencursor . '<%2Fopen_cursors><diagnostic_dest>' . $diagdest . '<%2Fdiagnostic_dest><db_cache_size>' . $dbcache . '<%2Fdb_cache_size><db_recovery_file_dest_size>' . $dbrfds . '<%2Fdb_recovery_file_dest_size><processes>' . $process . '<%2Fprocesses><rrecovery>' .$rrecovery . '<%2Frrecovery><tnsip>' . $tnslip . '<%2Ftnsip><tnsdomain>' . $tnsdomain . '<%2Ftnsdomain><redosize>' . $redosize . '<%2Fredosize><standalone>' . $standalone . '<%2Fstandalone><notnsupdate>' . $donotupdatetns . '<%2Fnotnsupdate><nonid>' . $donotupdateDBid . '<%2Fnonid><%2Fprovisioning-options>';
	}
    my $uri = URI::Encode->new( { double_encode => 0 } );
    $encoded = $uri->encode($provstring);
    my $clone_url = 'https://' . $CDSip . '/actifio/api/task/mountimage?sessionid=' . $sessionid . $encoded;
    my $clone_res = $ua->post($clone_url);
    my $clone_res_str =  $clone_res->content;
    my $clone_json_r = JSON->new->utf8;
    my $CLONE_RES = $clone_json_r->decode($clone_res_str);
    my $req_status = $CLONE_RES->{'errorcode'};
    if ($req_status > 0) {
        my $errorcode = $CLONE_RES->{'errorcode'};
        my $errmsg = $CLONE_RES->{'errormessage'};
        $re_code=$errorcode;
	print "Failed: " . $errorcode . " - " . $errmsg . "\n";
        scriptlog("Failed: " . $errorcode . " - " . $errmsg . "\n");
        exit $re_code;
    }

    $job_name_res = $CLONE_RES->{'result'};
    my @words = split / /, $job_name_res;
    $job_name = $words[0];
    printf $job_name_res . "\n";
    if ($statuswait eq "yes") {
        $job_stat = jobStatus();
        @jobstatarray = split /:/, $job_stat;
        $job_status = $jobstatarray[0];
        $job_error = $jobstatarray[1];

        while ( $job_error ne "10016" ) {
            sleep(60);
            $job_stat = jobStatus();
            @jobstatarray = split /:/, $job_stat;
            $job_status = $jobstatarray[0];
            $job_error = $jobstatarray[1];
        }

        if ($job_error eq "10016"){
            my $stathist_url = 'https://' . $CDSip . '/actifio/api/info/lsjobhistory?sessionid=' . $sessionid . '&argument=' . $job_name;
            $ua = LWP::UserAgent->new;
            my $stathist_res = $ua->get($stathist_url);
            
            my $stathist_res_str = $stathist_res->content;
            my $stathist_json_r = JSON->new->utf8;
            my $STATHIST_RES = $stathist_json_r->decode($stathist_res_str);
            $job_status = $STATHIST_RES->{'result'}->{'status'};
	    $job_errcode = $STATHIST_RES->{'result'}->{'errorcode'};
            $job_errmsg = $STATHIST_RES->{'result'}->{'message'};
            print "Clone Job " . $job_name . " Status is " . $job_status . "\n";
            scriptlog("Clone Job " . $job_name . " Status is " . $job_status . "\n");
        }

        $re_code = 0;
        if ($job_status ne "succeeded") {
            $re_code = $job_errcode;
            print $job_errmsg . "\n";
            scriptlog($job_errmsg . "\n");
        }

        exit $re_code;
    }
}

    # my $pwd = cwd();
    # my $logfile_name=$pwd . "/actDBMlog.log";
    # open FILE_HANDLE, ">>$logfile_name" or die "cannot open file : $!\n";

sub scriptlog {

     $pwd = cwd();
      $logfile_name=$pwd . "/actDBMlog.log";
     open FILE_HANDLE, ">>$logfile_name" or die "cannot open file : $!\n";

 my $text = shift;

 ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) =
                                                localtime(time);
  $year += 1900;
  print FILE_HANDLE "$year-$mon-$mday $hour:$min:$sec $text\n";

}

sub reprovision {
    $sessionid = getSession();
    my $retuser = retrieve ($sesfile);
  #  $CDSip = $retuser -> {CDSip};
    if ( $sessionid eq "" ) {
        die "Authentication is not established\n";
    }

    $hostname=$sourceHost;
    $hostid = getHost();
    if ( $hostid eq "" ) {
        die "could not get source hostid\n";
    }
    
    $appid = getApp();
    if ( $appid eq "" ) {
        die "could not get appid\n";
    }
    #$hostid = getOhostid();
    if ($image ne "") {
        $bkpname=$image;
        }
    if ( ($image eq "") && ($bkplabelid ne "") ) {
    $bkpstring = getImagebyLabel();
    @bkparray = split /:/, $bkpstring;
    $imageid = $bkparray[0];
    $bkpname = $bkparray[1];
    print "image id is " . $imageid ."\n";
    print "image name is " . $bkpname ."\n";
    }

    if ( ($image eq "") && ($bkplabelid eq "") ) {
    $bkpstring = getLatestImage();
    @bkparray = split /:/, $bkpstring;
    $imageid = $bkparray[0];
    $bkpname = $bkparray[1];
    print "image id is " . $imageid ."\n";
    print "image name is " . $bkpname ."\n";
    }

    if ( $bkpname eq "" ) {
        die "could not get latest imagename\n";
    }

    $hostname=$targetHost;
    $hostid=getHost();
    if ( $hostid eq "" ) {
        die "could not get target hostid\n";
    }

    $dbname=$tdbname;
        $appid = getApp();
    if ( $appid eq "" ) {
        die "could not get appid\n";
    }
    $refstring='&nowait=true&image=' . $bkpname . '&appid=' . $appid;

    if ($pointInTime eq "") {
        $pointInTime = getImageDetailsByName($bkpname);
        print "Image details by name " . $pointInTime . "\n";
        }
    
    if ($pointInTime ne "") {
        $refstring = $refstring . '&recoverytime=' . $pointInTime;
    }
    my $uri = URI::Encode->new( { double_encode => 0 } );
    $refencoded = $uri->encode($refstring);

    if ($pointInTime ne "") {
        $provstring = $provstring . '&recoverytime=' . $pointInTime;
    }

    my $ref_url = 'https://' . $CDSip . '/actifio/api/task/reprovisionimage?sessionid=' . $sessionid . $refencoded;
    my $ref_res = $ua->post($ref_url);

    my $ref_res_str =  $ref_res->content;
    my $ref_json_r = JSON->new->utf8;
    my $REFRESH_RES = $ref_json_r->decode($ref_res_str);
    my $req_status = $REFRESH_RES->{'errorcode'};

    if ($req_status > 0) {
        my $errorcode = $REFRESH_RES->{'errorcode'};
        my $errmsg = $REFRESH_RES->{'errormessage'};
        $re_code=$errorcode;
	print "Failed: " . $errorcode . " - " . $errmsg . "\n";
        scriptlog("Failed: " . $errorcode . " - " . $errmsg . "\n");
        exit $re_code;
    }

    $job_name_ref = $REFRESH_RES->{'result'};
    my @words = split / /, $job_name_ref;
    $job_name = $words[0];
    printf $job_name_ref . "\n";

    if ($statuswait eq "yes") {
        $job_stat = jobStatus();
        @jobstatarray = split /:/, $job_stat;
        $job_status = $jobstatarray[0];
        $job_error = $jobstatarray[1];

        while ( $job_error ne "10016" ) {
            sleep(60);
            $job_stat = jobStatus();
            @jobstatarray = split /:/, $job_stat;
            $job_status = $jobstatarray[0];
            $job_error = $jobstatarray[1];
        }

        if ($job_error eq "10016"){
            my $stathist_url = 'https://' . $CDSip . '/actifio/api/info/lsjobhistory?sessionid=' . $sessionid . '&argument=' . $job_name;
            $ua = LWP::UserAgent->new;
            my $stathist_res = $ua->get($stathist_url);

            my $stathist_res_str = $stathist_res->content;
            my $stathist_json_r = JSON->new->utf8;
            my $STATHIST_RES = $stathist_json_r->decode($stathist_res_str);
            $job_status = $STATHIST_RES->{'result'}->{'status'};
	    $job_errcode = $STATHIST_RES->{'result'}->{'errorcode'};
            $job_errmsg = $STATHIST_RES->{'result'}->{'message'};
            print "Clone refresh Job " . $job_name . " Status is " . $job_status . "\n";
            scriptlog("Clone refresh Job " . $job_name . " Status is " . $job_status . "\n"); 
        }

        $re_code = 0;
        if ($job_status ne "succeeded") {
            $re_code = $job_errcode;
            print $job_errmsg . "\n";
            scriptlog($job_errmsg . "\n");
        }

        exit $re_code;
    }
}

if ($arghash{'--type'} eq "mount" ) {
   die "Usage:actDBM --type mount \n --dbname <database name> \n [--image <Image name>] \n [--sourceHost <source host name>] \n [--targetHost <Target Host name>] \n [--ASMdiskgroup <ASM diskgroup name>] \n [--RACNodeList <RAC node list>] \n [--mountpoint <filesystem mountpoint '/act/mnt'>] \n --CDS <CDS name|ip> \n [--wait <yes|no>]\n" if ( (exists $arghash{'--help'}) && ($arghash{'--type'} eq "mount") );
    die "Usage:actDBM --type mount \n --dbname <database name> \n [--image <Image name>] \n [--sourceHost <source host name>] \n [--targetHost <Target Host name>] \n [--ASMdiskgroup <ASM diskgroup name>] \n [--RACNodeList <RAC node list>] \n [--mountpoint <filesystem mountpoint '/act/mnt'>] \n --CDS <CDS name|ip> \n [--wait <yes|no>]\n" if (( !exists $arghash{'--dbname'} ) && ($arghash{'--type'} eq "mount") );
    $dbname=$arghash{'--dbname'};
    $sourceHost=hostname;
    $sourceHost =~ s/(\w+)\..*/\1/;
    $image="";
    $targetHost=$sourceHost;
 
    if ( exists $arghash{'--sourceHost'} ) {
        $sourceHost=$arghash{'--sourceHost'};
    }

    if ( exists $arghash{'--image'} ) {
        $image=$arghash{'--image'};
    }
    if ( exists $arghash{'--targetHost'} ) {
        $targetHost=$arghash{'--targetHost'};
    }
    if ( !exists $arghash{'--wait'} ) {
        $statuswait="no";
    }
    elsif ( exists $arghash{'--wait'} ) {
        $statuswait=$arghash{'--wait'};
    }
    if ( exists $arghash{'--ASMdiskgroup'} ) {
        $asmDG=$arghash{'--ASMdiskgroup'};
    }
    if ( exists $arghash{'--RACNodeList'} ) {
        $RACNodeList=$arghash{'--RACNodeList'};
        $RACNodeList=~s/\:/%3A/g;
        printf $RACNodeList . "\n";
    }

    if ( exists $arghash{'--mountpoint'} ) {
        $mountpoint=$arghash{'--mountpoint'};
    }
 
    if ( !exists $arghash{'--CDS'} ) {
           $pwd = cwd();

    @sesdir = ("$pwd",);
    $count=0;
    find(\&wanted, @sesdir);
     my $retuser = retrieve ($userfile);
      $CDSips = $retuser -> {CDSip};
   if ( ($count >= 1) || ($CDSips eq "generic") ) {
     die "--CDS parameter is not specified\n Usage:actDBM --type mount \n --dbname <database name> \n [--image <Image name>] \n [--sourceHost <source host name>] \n [--targetHost <Target Host name>] \n [--ASMdiskgroup <ASM diskgroup name>] \n [--RACNodeList <RAC node list>] \n [--mountpoint <filesystem mountpoint '/act/mnt'>] \n --CDS <CDS name|ip> \n [--wait <yes|no>]\n" if (( !exists $arghash{'--CDS'} ) && ($arghash{'--type'} eq "mount") );
     }
   }
    elsif ( exists $arghash{'--CDS'} ) {
        $CDSip=$arghash{'--CDS'};
    }
        mount();
}

if ($arghash{'--type'} eq "restoreASMswitch" ) {
   die "Note: This needs to run from the protected database host \n Usage:actDBM --type restoreASMswitch \n --dbname <database name> \n --OracleHome <Oracle Home> \n --OSusername <OS oracle username> \n --OSgridusername <OS grid username> \n --standalone <yes/no> \n --ASMdiskgroup <ASM diskgroup name> \n --RACNodeList <RAC node list> \n [--image <Image name>] \n [--sourceHost <source host name>] \n [--mountpoint <archivelog filesystem mountpoint '/act/mnt'>] \n [--pointInTime <Recovery time 'yyyymmddhh24mi'>] \n --CDS <CDS name|ip> \n [--wait <yes|no>]\n" if ( (exists $arghash{'--help'}) && ($arghash{'--type'} eq "restoreASMswitch") );
    die "Note: This needs to run from the protected database host \n Usage:actDBM --type restoreASMswitch \n --dbname <database name> \n --OracleHome <Oracle Home> \n --OSusername <OS oracle username> \n --OSgridusername <OS grid username> \n --standalone <yes/no> \n --ASMdiskgroup <ASM diskgroup name> \n --RACNodeList <RAC node list> \n [--image <Image name>] \n [--sourceHost <source host name>] \n [--mountpoint <archivelog filesystem mountpoint '/act/mnt'>] \n [--pointInTime <Recovery time 'yyyymmddhh24mi'>] \n --CDS <CDS name|ip> \n [--wait <yes|no>]\n" if ( (( !exists $arghash{'--dbname'} ) || ( !exists $arghash{'--OracleHome'} ) || ( !exists $arghash{'--OSusername'} ) || ( !exists $arghash{'--OSgridusername'} ) || ( !exists $arghash{'--ASMdiskgroup'} ) || ( !exists $arghash{'--RACNodeList'} ) ) && ($arghash{'--type'} eq "restoreASMswitch") );
    $dbname=$arghash{'--dbname'};
    $sourceHost=hostname;
    $sourceHost =~ s/(\w+)\..*/\1/;
    $image="";
    #$targetHost=$sourceHost;

    if ( exists $arghash{'--sourceHost'} ) {
        $sourceHost=$arghash{'--sourceHost'};
    }

    if ( exists $arghash{'--image'} ) {
        $image=$arghash{'--image'};
    }
    $targetHost=$sourceHost;
    if ( !exists $arghash{'--wait'} ) {
        $statuswait="no";
    }
    elsif ( exists $arghash{'--wait'} ) {
        $statuswait=$arghash{'--wait'};
    }
    if ( exists $arghash{'--ASMdiskgroup'} ) {
        $asmDG=$arghash{'--ASMdiskgroup'};
    }
    if ( exists $arghash{'--RACNodeList'} ) {
        $RACNodeList=$arghash{'--RACNodeList'};
        printf $RACNodeList . "\n";
    }
    if ( exists $arghash{'--standalone'} ) {
        $standalone=$arghash{'--standalone'};
    }

    if ( exists $arghash{'--mountpoint'} ) {
        $archmnt=$arghash{'--mountpoint'};
    }

        if ( exists $arghash{'--pointInTime'} ) {
        $pointInTime=$arghash{'--pointInTime'};
        }

    if ( exists $arghash{'--OracleHome'} ) {
        $torahome=$arghash{'--OracleHome'};
    }
    if ( exists $arghash{'--OSusername'} ) {
        $ouser=$arghash{'--OSusername'};
    }
    if ( exists $arghash{'--OSgridusername'} ) {
        $guser=$arghash{'--OSgridusername'};
    }

    if ( !exists $arghash{'--CDS'} ) {
           $pwd = cwd();

    @sesdir = ("$pwd",);
    $count=0;
    find(\&wanted, @sesdir);
     my $retuser = retrieve ($userfile);
      $CDSips = $retuser -> {CDSip};
   if ( ($count >= 1) || ($CDSips eq "generic") ) {
     die "--CDS parameter is not specified\n Usage:actDBM --type mount \n --dbname <database name> \n --OracleHome <Oracle Home> \n --OSusername <OS oracle username> \n --OSgridusername <OS grid username> \n --standalone <yes/no> \n --ASMdiskgroup <ASM diskgroup name> \n --RACNodeList <RAC node list> \n [--image <Image name>] \n [--sourceHost <source host name>] \n [--mountpoint <archivelog filesystem mountpoint '/act/mnt'>] \n [--pointInTime <Recovery time 'yyyymmddhh24mi'>] \n --CDS <CDS name|ip> \n [--wait <yes|no>]\n" if (( !exists $arghash{'--CDS'} ) && ($arghash{'--type'} eq "mount") );
     }
   }
    elsif ( exists $arghash{'--CDS'} ) {
        $CDSip=$arghash{'--CDS'};
    }
        restoreASMswitch();
}

if ($arghash{'--type'} eq "restoreASMrebalance" ) {
   die "Note: This needs to run from the protected database host \n Usage:actDBM --type restoreASMrebalance \n  --ASMdiskgroup <Mounted ASM diskgroup name> \n --OSgridusername <OS grid username> \n --OSusername <OS oracle username> \n --ASMdiskString <ASM disk string seperated by comma> \n --CDS <CDS name|ip> \n [--wait <yes|no>]\n" if ( (exists $arghash{'--help'}) && ($arghash{'--type'} eq "restoreASMrebalance") );
    die "Note: This needs to run from the protected database host \n Usage:actDBM --type restoreASMrebalance \n  --ASMdiskgroup <Mounted ASM diskgroup name> \n --OSgridusername <OS grid username> \n --OSusername <OS oracle username> \n --ASMdiskString <ASM disk string seperated by comma> \n --CDS <CDS name|ip> \n [--wait <yes|no>]\n" if (( !exists $arghash{'--ASMdiskgroup'} ) && ($arghash{'--type'} eq "restoreASMrebalance") );

    if ( !exists $arghash{'--wait'} ) {
        $statuswait="no";
    }
    elsif ( exists $arghash{'--wait'} ) {
        $statuswait=$arghash{'--wait'};
    }
    if ( exists $arghash{'--ASMdiskgroup'} ) {
        $asmDG=$arghash{'--ASMdiskgroup'};
    }
    if ( exists $arghash{'--OSgridusername'} ) {
        $guser=$arghash{'--OSgridusername'};
    }
    if ( exists $arghash{'--OSusername'} ) {
        $ouser=$arghash{'--OSusername'};
    }


    if ( exists $arghash{'--ASMdiskString'} ) {
        $dstring=$arghash{'--ASMdiskString'};
    }
      #$dstring =~ s/,/\n/ig;

    if ( !exists $arghash{'--CDS'} ) {
           $pwd = cwd();

    @sesdir = ("$pwd",);
    $count=0;
    find(\&wanted, @sesdir);
     my $retuser = retrieve ($userfile);
      $CDSips = $retuser -> {CDSip};
   if ( ($count >= 1) || ($CDSips eq "generic") ) {
    die "--CDS parameter is not specified\n Usage:actDBM --type restoreASMrebalance \n  --ASMdiskgroup <Mounted ASM diskgroup name> \n --OSgridusername <OS grid username> \n --OSusername <OS oracle username> \n --ASMdiskString <ASM disk string seperated by comma> \n --CDS <CDS name|ip> \n [--wait <yes|no>]\n" if (( !exists $arghash{'--CDS'} ) && ($arghash{'--type'} eq "mount") );
     }
   }
    elsif ( exists $arghash{'--CDS'} ) {
        $CDSip=$arghash{'--CDS'};
    }
        restoreASMrebalance();
}

sub restoreASMrebalance {
    $sessionid = getSession();
    my $retuser = retrieve ($sesfile);
  #  $CDSip = $retuser -> {CDSip};
    if ( $sessionid eq "" ) {
        die "Authentication is not established\n";
    }

    $hostname=$sourceHost;
    $hostid = getHost();
    my $dfilename="/act/act_scripts/asmrestore/asm_disks.conf";

    print $dstring . "\n";

    open(my $fh, '>', $dfilename) or die "Could not open file '$dfilename' $!";
    @tokens = split(/,/, $dstring);

    foreach my $token (@tokens) {
        print $fh $token . "\n";
    }

    #print $fh "$dstring";
    close $fh;
    print "\ndone\n";

    system("sh /act/act_scripts/asmrestore/asmdgRebalance.sh $asmDG $ouser $guser");
    
if ( $? > 0 ) {
    print "status: failed\n";
}
else {
    print "status: succeeded\n";		
}

}

sub restoreASMswitch {
   $sessionid = getSession();
    my $retuser = retrieve ($sesfile);
 #   $CDSip = $retuser -> {CDSip};
    if ( $sessionid eq "" ) {
        die "Authentication is not established\n";
    }

    $hostname=$sourceHost;
    $hostid = getHost();
    if ( $hostid eq "" ) {
        die "could not get source hostid\n";
    }
    $appid = getApp();
    if ( $appid eq "" ) {
        die "could not get appid\n";
    }
    if ($image eq "") {
        $bkpstring = getLatestImage();
        @bkparray = split /:/, $bkpstring;
        $imageid = $bkparray[0];
        $bkpname = $bkparray[1];
        print "image id is " . $imageid ."\n";
        print "image name is " . $bkpname ."\n";
    }
    else {
        $bkpname=$image;
    }

    if ( $bkpname eq "" ) {
        die "could not get latest imagename\n";
    }

    $hostname=$targetHost;
    $thostid=getHost();
    
    if ( $thostid eq "" ) {
        die "could not get target hostid\n";
    }

$mount_status=mount();
if ( $mount_status > 0 ) {
die return $mount_status;
}
else {
       $bkpstring = getLatestMountImage();
        @bkparray = split /:/, $bkpstring;
        $imageid = $bkparray[0];
        $bkpname = $bkparray[1];
        print "image name is " . $bkpname ."\n";
$hostid=$thostid;
$mntstring = listmountpoint($bkpname);
@mntarray=split /:/, $mntstring;
$asmDG=$mntarray[0];
$archflag=$mntarray[1];
printf "asm disk group is " . $asmDG . " \n";
printf "archive flag is " . $archflag . "\n";

if ( $archflag eq "yes" ) {
$image1=$bkpname;
@imgarr=split /_/, $image1;
$imgstr=$imgarr[1];
$archmnt="/act/mnt/Job_" . $imgstr . "_mountpoint_";
printf "output arch mountpoint is " . $archmnt . " \n";
}

if ( $archmnt eq "" ) {
$pointInTime="";
printf "point in time is " . $pointInTime . "\n";
}

    my $nodefile="/act/act_scripts/asmrestore/asm_node_config.conf";

    open(my $fh, '>', $nodefile) or die "Could not open file '$nodefile' $!";
    @tokens = split(/:/, $RACNodeList);
     my $index=1;
    foreach my $token (@tokens) {
        print $fh "ASM_NODE" . $index . ":" . $token . "\n";
        $index = $index + 1;
    }

    close $fh;
    print "\ndone\n";

system("sh /act/act_scripts/asmrestore/ASMOracleRestore.sh $torahome $asmDG $ouser $guser $standalone $archmnt $pointInTime");
$switch_status=$?;

if ( $switch_status > 0 ) {
    print "status: failed\n";
    die return $switch_status;
}
else {
    print "status: succeeded\n";
    die return $switch_status;
}

}

}

sub mount {
    $sessionid = getSession();
    my $retuser = retrieve ($sesfile);
#    $CDSip = $retuser -> {CDSip};
    if ( $sessionid eq "" ) {
        die "Authentication is not established\n";
    }

    $hostname=$sourceHost;
    $hostid = getHost();
    if ( $hostid eq "" ) {
        die "could not get source hostid\n";
    }
    $appid = getApp();
    if ( $appid eq "" ) {
        die "could not get appid\n";
    }
    if ($image eq "") {
        $bkpstring = getLatestImage();
        @bkparray = split /:/, $bkpstring;
        $imageid = $bkparray[0];
        $bkpname = $bkparray[1];
        print "image id is " . $imageid ."\n";
        print "image name is " . $bkpname ."\n";
    }
    else {
        $bkpname=$image;
    }

    if ( $bkpname eq "" ) {
        die "could not get latest imagename\n";
    }

    $hostname=$targetHost;
    $hostid=getHost();
    if ( $hostid eq "" ) {
        die "could not get target hostid\n";
    }

    $mntstring='&nowait=true&appaware=false&image=' . $bkpname . '&host=' . $hostid . '&restoreoption=';
 
    if ($asmDG ne "") {
        $mntstring=$mntstring . 'volgroupname%3D' . $asmDG . '%2C';
    }

    if ($RACNodeList ne "") {
        $mntstring=$mntstring . 'asmracnodelist%3D' . $RACNodeList . '%2C';
    }

    if ($mountpoint ne "") {
        $mntstring=$mntstring . 'mountpointperimage%3D' . $mountpoint . '%2C';
    }

    my $uri = URI::Encode->new( { double_encode => 0 } );
    $refencoded = $uri->encode($mntstring);

    my $mnt_url = 'https://' . $CDSip . '/actifio/api/task/mountimage?sessionid=' . $sessionid . $refencoded;
    my $mnt_res = $ua->post($mnt_url);
    
    my $mnt_res_str =  $mnt_res->content;

    my $mnt_json_r = JSON->new->utf8;
    my $MOUNT_RES = $mnt_json_r->decode($mnt_res_str);
    my $req_status = $MOUNT_RES->{'status'};

    if ($req_status eq "failure") {
        my $errorcode = $MOUNT_RES->{'errorcode'};
        my $errmsg = $MOUNT_RES->{'msg'};
        $re_code=1;
        print "Failed: " . $errorcode . " - " . $errmsg . "\n";
        scriptlog("Failed: " . $errorcode . " - " . $errmsg . "\n");
        die return $re_code;
    }

    $job_name_mnt = $MOUNT_RES->{'result'};
    my @words = split / /, $job_name_mnt;
    $job_name = $words[0];
    printf $job_name_mnt . "\n";

    if ($statuswait eq "yes") {
        $job_stat = jobStatus();
        @jobstatarray = split /:/, $job_stat;
        $job_status = $jobstatarray[0];
        $job_error = $jobstatarray[1];

        while ( $job_error ne "10016" ) {
            sleep(60);
            $job_stat = jobStatus();
            @jobstatarray = split /:/, $job_stat;
            $job_status = $jobstatarray[0];
            $job_error = $jobstatarray[1];
        }

        if ($job_error eq "10016"){
            my $stathist_url = 'https://' . $CDSip . '/actifio/api/info/lsjobhistory?sessionid=' . $sessionid . '&argument=' . $job_name;
            $ua = LWP::UserAgent->new;
            my $stathist_res = $ua->get($stathist_url);

            my $stathist_res_str = $stathist_res->content;
            my $stathist_json_r = JSON->new->utf8;
            my $STATHIST_RES = $stathist_json_r->decode($stathist_res_str);
            $job_status = $STATHIST_RES->{'result'}->{'status'};
            print "Mount Job " . $job_name . " Status is " . $job_status . "\n";
            scriptlog("Mount Job " . $job_name . " Status is " . $job_status . "\n");
        }
	$re_code = 0;
	if ($job_status ne "succeeded") {
            $re_code = 1;
        }

        die return $re_code;
    }
}

if ($arghash{'--type'} eq "cleanup" ) {
   die "Usage:actDBM --type cleanup \n --appName <Source Database Name or Source File System Mount Point> \n --sourceHost <source host name> \n --targetHost <target host name> \n [--imageName <Mounted Image Name>] \n [--targetAppName <Target Cloned Database Name or Target Mounted File System MountPoint>] \n --CDS <CDS name|ip> \n [--wait <yes|no>]\n" if ( (exists $arghash{'--help'}) && ($arghash{'--type'} eq "cleanup") );
    die "Usage:actDBM --type cleanup \n --appName <Source Database Name or Source File System Mount Point> \n --sourceHost <source host name> \n --targetHost <target host name> \n [--imageName <Mounted Image Name>] \n [--targetAppName <Target Cloned Database Name or Target Mounted File System MountPoint>] \n --CDS <CDS name|ip> \n [--wait <yes|no>]\n" if ((( !exists $arghash{'--appName'} ) || ( !exists $arghash{'--sourceHost'} ) || ( !exists $arghash{'--targetHost'} )) && ($arghash{'--type'} eq "cleanup") );
    $appname=$arghash{'--appName'};
    $image="";
    $targetHost="";

    if ( exists $arghash{'--sourceHost'} ) {
        $sourceHost=$arghash{'--sourceHost'};
    }

    if ( exists $arghash{'--imageName'} ) {
        $image=$arghash{'--imageName'};
    }
    if ( exists $arghash{'--targetHost'} ) {
        $targetHost=$arghash{'--targetHost'};
    }
    if ( exists $arghash{'--targetAppName'} ) {
        $taname=$arghash{'--targetAppName'};
        #$taname =~ s/(.)/\u$1/g;
    }
    if ( !exists $arghash{'--wait'} ) {
        $statuswait="no";
    }
    elsif ( exists $arghash{'--wait'} ) {
        $statuswait=$arghash{'--wait'};
    }
    if ( !exists $arghash{'--CDS'} ) {
           $pwd = cwd();

    @sesdir = ("$pwd",);
    $count=0;
    find(\&wanted, @sesdir);
    my $retuser = retrieve ($userfile);
    $CDSips = $retuser -> {CDSip};
    if ( ($count >= 1) || ($CDSips eq "generic") ) {
     die "--CDS parameter is not specified\n Usage:actDBM --type cleanup \n --appName <Source Database Name or Source File System Mount Point> \n --sourceHost <source host name> \n --targetHost <target host name> \n [--imageName <Mounted Image Name>] \n [--targetAppName <Target Cloned Database Name or Target Mounted File System MountPoint>] \n --CDS <CDS name|ip> \n [--wait <yes|no>]\n"; #if (( !exists $arghash{'--CDS'} ) && ($arghash{'--type'} eq "cleanup") );
     }
   }
    elsif ( exists $arghash{'--CDS'} ) {
        $CDSip=$arghash{'--CDS'};
    }
        cleanup();
}

sub cleanup {
    $sessionid = getSession();
   # my $retuser = retrieve ($sesfile);
  #  $CDSip = $retuser -> {CDSip};
    if ( $sessionid eq "" ) {
        die "Authentication is not established\n";
    }

    $hostname=$sourceHost;
    $hostid = getHost();
    if ( $hostid eq "" ) {
        die "could not get source hostid\n";
    }
    if ( $targetHost ne "" ) {
        $hostname=$targetHost;
        $thostid= getHost();
    }
    $hostname=$sourceHost;

    $dbname=$appname;
     $appid = getApp();

    if ( $appid eq "" ) {
       die "could not get source appid\n";
       }
 
    if ( $taname ne "" ) {
       $dbname=$taname;
       $hostid=$thostid;
    }
    $tappid = getApp();
    $dbname=$appname;

    if ( $tappid ne "" ) {
      $appid = $tappid;
      $dbname=$taname;
    }
    else {
          $hostname=$sourceHost;
          $hostid = getHost();
     }

 if ( $image ne "" ) {
     $bkpname=$image;
     print "Mounted Image Name is " . $image . "\n";
        }
    if ( ( $image eq "" ) && ( $taname eq "" ) ) {
        die "Error: either --imageName OR --targetAppName value must be provided \n";
    }
    if ( ( $image eq "" ) && ( $taname ne "" ) && ( $tappid eq "" ) ) {
        $bkpstring = getLatestMountImagebyHost();
        @bkparray = split /:/, $bkpstring;
        $imageid = $bkparray[0];
        $bkpname = $bkparray[1];
        print "target host mount image by host id is " . $imageid . "\n";
        print "target host mount image by host name is " . $bkpname . "\n";
    }

    if ( ( $image eq "" ) && ( $taname ne "" ) && ( $tappid ne "" ) ) {
        $bkpstring = getCloneMountImage();
        @bkparray = split /:/, $bkpstring;
        $imageid = $bkparray[0];
        $bkpname = $bkparray[1];
        print "target host clone image id is " . $imageid . "\n";
        print "target host clone image name is " . $bkpname . "\n";
    }

    if ( $bkpname eq "" ) {
        die "could not get mounted imagename\n";
    }

    $umntstring='&nowait=true&delete=true&image=' . $bkpname;
    my $uri = URI::Encode->new( { double_encode => 0 } );
    $refencoded = $uri->encode($umntstring);

    my $umnt_url = 'https://' . $CDSip . '/actifio/api/task/unmountimage?sessionid=' . $sessionid . $refencoded;
    my $umnt_res = $ua->post($umnt_url);

    my $umnt_res_str =  $umnt_res->content;
    my $umnt_json_r = JSON->new->utf8;
    my $UMOUNT_RES = $umnt_json_r->decode($umnt_res_str);
    my $req_status = $UMOUNT_RES->{'status'};

    if ($req_status eq "failure") {
        my $errorcode = $UMOUNT_RES->{'errorcode'};
        my $errmsg = $UMOUNT_RES->{'msg'};
        $re_code=1;
        print "Failed: " . $errorcode . " - " . $errmsg . "\n";
        scriptlog("Failed: " . $errorcode . " - " . $errmsg . "\n");
        die return $re_code;
    }

    $job_name_umnt = $UMOUNT_RES->{'result'};
    my @words = split / /, $job_name_umnt;
    $job_name = $words[0];
    printf $job_name_umnt . "\n";

    if ($statuswait eq "yes") {
        $job_stat = jobStatus();
        @jobstatarray = split /:/, $job_stat;
        $job_status = $jobstatarray[0];
        $job_error = $jobstatarray[1];

        while ( $job_error ne "10016" ) {
            sleep(60);
            $job_stat = jobStatus();
            @jobstatarray = split /:/, $job_stat;
            $job_status = $jobstatarray[0];
            $job_error = $jobstatarray[1];
        }

        if ($job_error eq "10016"){
            my $stathist_url = 'https://' . $CDSip . '/actifio/api/info/lsjobhistory?sessionid=' . $sessionid . '&argument=' . $job_name;
            $ua = LWP::UserAgent->new;
            my $stathist_res = $ua->get($stathist_url);

            my $stathist_res_str = $stathist_res->content;
            my $stathist_json_r = JSON->new->utf8;
            my $STATHIST_RES = $stathist_json_r->decode($stathist_res_str);
            $job_status = $STATHIST_RES->{'result'}->{'status'};
            print "Cleanup Job " . $job_name . " Status is " . $job_status . "\n";
            scriptlog("Cleanup Job " . $job_name . " Status is " . $job_status . "\n");
        }
        $re_code = 0;
        if ($job_status ne "succeeded") {
            $re_code = 1;
        }

        die return $re_code;
    }
}

if ($arghash{'--type'} eq "runwf" ) {
   die "Usage:actDBM --type runwf \n --subtype directmount \n --dbname <source database name> \n --hostname <sourcehostname> \n --wfname <workflow name> \n --reprovision <yes|no> \n [--image <Image name>] \n --CDS <CDS name|ip> \n [--wait <yes|no>]\n" if ( (exists $arghash{'--help'}) && ($arghash{'--type'} eq "runwf") && ($arghash{'--subtype'} eq "directmount") );
die "Usage:actDBM --type runwf \n --subtype [<directmount|liveclone>] \n" if ( ((exists $arghash{'--help'}) || (!exists $arghash{'--help'}) ) && ($arghash{'--type'} eq "runwf") && ( !exists $arghash{'--subtype'}) );
  die "Usage:actDBM --type runwf \n --subtype directmount \n --dbname <source database name> \n --hostname <sourcehostname> \n --wfname <workflow name> \n --reprovision <yes|no> \n [--image <Image name>] --CDS <CDS name|ip> \n [--wait <yes|no>]\n" if ( (exists $arghash{'--help'}) && ($arghash{'--type'} eq "runwf") && ($arghash{'--subtype'} eq "directmount") );
die "Usage:actDBM --type runwf \n --subtype directmount \n --dbname <source database name> \n --hostname <sourcehostname> \n --wfname <workflow name> \n --reprovision <yes|no> \n [--image <Image name>] \n --CDS <CDS name|ip> \n [--wait <yes|no>]\n" if ((( !exists $arghash{'--dbname'} ) || ( !exists $arghash{'--hostname'} ) || ( !exists $arghash{'--wfname'} ) ) && ($arghash{'--type'} eq "runwf") && ($arghash{'--subtype'} eq "directmount") );
    $wfname=$arghash{'--wfname'};
    $dbname=$arghash{'--dbname'};
    $hostname=hostname;
    $hostname =~ s/(\w+)\..*/\1/;
    $reflive="";
    $provlive="";

    if ( exists $arghash{'--subtype'} ) {
        $subtype=$arghash{'--subtype'};
    }

    if ( exists $arghash{'--hostname'} ) {
        $hostname=$arghash{'--hostname'};
    }

    if ( exists $arghash{'--wfname'} ) {
        $wfname=$arghash{'--wfname'};
    }

    if ( exists $arghash{'--image'} ) {
        $image=$arghash{'--image'};
    }
     
    if ( exists $arghash{'--refreshliveclone'} ) {
        $reflive=$arghash{'--refreshliveclone'};
    }

     if ( exists $arghash{'--provisionliveclone'} ) {
        $provlive=$arghash{'--provisionliveclone'};
    }

     if ( exists $arghash{'--reprovision'} ) {
        $reprov=$arghash{'--reprovision'};
    }

    if ( !exists $arghash{'--wait'} ) {
        $statuswait="no";
    }
    elsif ( exists $arghash{'--wait'} ) {
        $statuswait=$arghash{'--wait'};
    }

    if ( !exists $arghash{'--CDS'} ) {
           $pwd = cwd();

    @sesdir = ("$pwd",);
    $count=0;
    find(\&wanted, @sesdir);
    my $retuser = retrieve ($userfile);
    $CDSips = $retuser -> {CDSip};
    if ( ($count >= 1) || ($CDSips eq "generic") ) {
     die "--CDS parameter is not specified\n Usage:actDBM --type runwf \n --subtype directmount \n --dbname <source database name> \n --hostname <sourcehostname> \n --wfname <workflow name> \n --reprovision <yes|no> \n [--image <Image name>] \n --CDS <CDS name|ip> \n [--wait <yes|no>]\n" if (( !exists $arghash{'--CDS'} ) && ($arghash{'--type'} eq "runwf") && ($arghash{'--subtype'} eq "directmount") );
     }
   }
    elsif ( exists $arghash{'--CDS'} ) {
        $CDSip=$arghash{'--CDS'};
    }
    
    if ($reflive eq "yes") {
        $reflive="false";
     }
     elsif ($reflive eq "no") {
         $reflive="true";
     }
    if ($provlive eq "yes") {
        $provlive="fasle";
     }
     elsif ($provlive eq "no") {
         $provlive="true";
     }

    if ($subtype eq "directmount") {
    runwf();
    }
    elsif ($subtype eq "liveclone") {
   die "Usage:actDBM --type runwf \n --subtype liveclone \n --dbname <source database name> \n --hostname <sourcehostname> \n --wfname <workflow name> \n --reprovision <yes|no> \n [--image <Image name>] \n [--refreshliveclone <yes|no>] \n [--provisionliveclone <yes|no>] \n --CDS <CDS name|ip> \n [--wait <yes|no>]\n" if ( (exists $arghash{'--help'}) && ($arghash{'--type'} eq "runwf") && ($arghash{'--subtype'} eq "liveclone") );
  die "Usage:actDBM --type runwf \n --subtype liveclone \n --dbname <source database name> \n --hostname <sourcehostname> \n --wfname <workflow name> \n --reprovision <yes|no> \n [--image <Image name>] \n [--refreshliveclone <yes|no>] \n [--provisionliveclone <yes|no>] \n --CDS <CDS name|ip> \n [--wait <yes|no>]\n" if ((( !exists $arghash{'--dbname'} ) || ( !exists $arghash{'--hostname'} ) || ( !exists $arghash{'--wfname'} ) ) && ($arghash{'--type'} eq "runwf") && ($arghash{'--subtype'} eq "liveclone") );
     
    if ( !exists $arghash{'--CDS'} ) {
           $pwd = cwd();

    @sesdir = ("$pwd",);
    $count=0;
    find(\&wanted, @sesdir);
    my $retuser = retrieve ($userfile);
    $CDSips = $retuser -> {CDSip};
    if ( ($count >= 1) || ($CDSips eq "generic") ) {
     die "--CDS parameter is not specified\n Usage:actDBM --type runwf \n --subtype liveclone \n --dbname <source database name> \n --hostname <sourcehostname> \n --wfname <workflow name> \n --reprovision <yes|no> \n [--image <Image name>] \n [--refreshliveclone <yes|no>] \n [--provisionliveclone <yes|no>] \n --CDS <CDS name|ip> \n [--wait <yes|no>]\n" if (( !exists $arghash{'--CDS'} ) && ($arghash{'--type'} eq "runwf") && ($arghash{'--subtype'} eq "liveclone") );
        }
   }

	runwfliveclone();
 }

}

sub runwf {
    $sessionid = getSession();
    my $retuser = retrieve ($sesfile);
   # $CDSip = $retuser -> {CDSip};
    if ( $sessionid eq "" ) {
        die "Authentication is not established\n";
    }

    $hostid = getHost();
    if ( $hostid eq "" ) {
        die "could not get source hostid\n";
    }
    $appid = getApp();
    if ( $appid eq "" ) {
        die "could not get appid\n";
    }
  
    if ($image eq "") {
        $bkpstring = getLatestImage();
        @bkparray = split /:/, $bkpstring;
        $imageid = $bkparray[0];
        $bkpname = $bkparray[1];
        print "image id is " . $imageid ."\n";
        print "image name is " . $bkpname ."\n";
    }
    else {
        $bkpname=$image;
    }

    if ( $bkpname eq "" ) {
        die "could not get latest imagename\n";
    }
 
    my $wf_url = "https://" . $CDSip . "/actifio/api/info/lsworkflow?sessionid=" . $sessionid . '&argument=' . $wfname;
     
    if ( $wfname eq " " ) {
    	my $wf_url = 'https://' . $CDSip . '/actifio/api/info/lsapplication?sessionid=' . $sessionid . '&filtervalue=appid%3D' . $appid;
     }
	
    #printf "wf_url= " . $wf_url . "\n";

    my $wf_res = $ua->get($wf_url);

    my $wf_res_str = $wf_res->content;
    my $wf_json_r = JSON->new->utf8;
    my $WF_JSON_RES = $wf_json_r->decode($wf_res_str);
    my $wf_id = $WF_JSON_RES->{'result'}{'id'};
    my $xmlstr = $WF_JSON_RES->{'result'}{'tasks'};

    printf "WF Id = " . $wf_id . "\n";
    my $ref = XMLin($xmlstr);
    my $itemid = $ref->{mount}->{id};
    print "mount id: ". $itemid . "\n";

    if ( $wf_id eq " " ) {
	    die "could not get workflow id\n";
	}

    my $mount_itemid = $ref->{mount}->{id};
    my $dbsid_itemid = $ref->{mount}->{'provisioning-options'}->{databasesid}->{id};

    my $tdbname = $ref->{mount}->{'provisioning-options'}->{databasesid}->{content};

    my $thostid = $ref->{mount}->{host}->{hostid};
    print "database name is " . $tdbname . "\n";
    print "total  " . $xmlstr . "\n";
    print "target host id: ". $thostid . "\n";

    if ( $wf_id eq " " ) {
            die "could not get workflow id\n";
    }

# Clone workflow.
    my $clone_wf_url = "https://" . $CDSip . "/actifio/api/task/cloneworkflow?sessionid=" . $sessionid . "&argument=" . $wf_id;
    my $clone_wf_res = $ua->post($clone_wf_url);
    my $clone_wf_res_str =  $clone_wf_res->content;
    my $clone_wf_json_r = JSON->new->utf8;

    my $CL_WF_JSON_RES = $clone_wf_json_r->decode($clone_wf_res_str);
    my $cwf_id = $CL_WF_JSON_RES->{'result'};
    printf "clone work flow id: " . $cwf_id . "\n";

if ( $reprov eq "yes" ) {
# Creating flow item property for reprovision. udstask mkflowitem -workflow <cloned wf id> -type reprovision -depends <mount id>
    my $mkfi_rep_url = "https://" . $CDSip . "/actifio/api/task/mkflowitem?sessionid=" . $sessionid . "&workflow=" . $cwf_id . "&type=reprovision&depends=" . $mount_itemid;
    my $mkfi_rep_res = $ua->post($mkfi_rep_url);
    my $mkfi_rep_res_str =  $mkfi_rep_res->content;
    my $mkfi_rep_json_r = JSON->new->utf8;

    my $MKFI_REP_JSON_RES = $mkfi_rep_json_r->decode($mkfi_rep_res_str);
    my $reprovision_id = $MKFI_REP_JSON_RES->{'result'};

# Creating flow item property for application. udstask mkflowitem -workflow <cloned wf id> -type app -depends <reprovision id>
    my $mkfi_app_url = "https://" . $CDSip . "/actifio/api/task/mkflowitem?sessionid=" . $sessionid . "&workflow=" . $cwf_id . "&type=app&depends=" . $reprovision_id;
    my $mkfi_app_res = $ua->post($mkfi_app_url);
    my $mkfi_app_res_str =  $mkfi_app_res->content;
    my $mkfi_app_json_r = JSON->new->utf8;

    my $MKFI_APP_JSON_RES = $mkfi_app_json_r->decode($mkfi_app_res_str);
    my $app_id = $MKFI_APP_JSON_RES->{'result'};
    print "app ID is " . $app_id . "\n"; 

# List application by name and get id.
    my $list_app_url = "https://" . $CDSip . "/actifio/api/info/lsapplication?sessionid=" . $sessionid . "&filtervalue=appname%3D" . $tdbname . '%26hostid%3D' . $thostid;
    my $list_app_res = $ua->get($list_app_url);
    my $list_app_res_str =  $list_app_res->content;

    my $list_app_json_r = JSON->new->utf8;
    my $LIST_APP_RES = $list_app_json_r->decode($list_app_res_str);
    my $tdb_id = $LIST_APP_RES->{'result'}->[0]->{'id'};
    print "target DB ID is " . $tdb_id . "\n";

# Add value to the flow item app in reprovision. udstask addflowitemvalue -workflow <clone wf id> -itemid <app element id> -value <child application id>
    my $addfiv_app_url = "https://" . $CDSip . "/actifio/api/task/addflowitemvalue?sessionid=" . $sessionid . "&workflow=" . $cwf_id . "&itemid=" . $app_id . "&value=" . $tdb_id;
    my $addfiv_app_res = $ua->post($addfiv_app_url);
    print "addfiv_app res is " . $addfiv_app_res . "\n"; 
}

# Add image to the cloned workflow. udstask addflowproperty -name image -value <image name> <cloned workflow id>
    my $add_wf_url = "https://" . $CDSip . "/actifio/api/task/addflowproperty?sessionid=" . $sessionid . "&name=image&value=" . $bkpname . "&argument=" . $cwf_id;
    my $add_wf_res = $ua->post($add_wf_url);
    my $add_wf_res_str =  $add_wf_res->content;

    my $run_wf_url = "https://" . $CDSip . "/actifio/api/task/runworkflow?sessionid=" . $sessionid . "&argument=" . $cwf_id;
    my $run_wf_res = $ua->post($run_wf_url);
       
    my $run_wf_res_str =  $run_wf_res->content;
    my $run_wf_json_r = JSON->new->utf8;
    my $RUNWF_RES = $run_wf_json_r->decode($run_wf_res_str);
    my $req_status = $RUNWF_RES->{'status'};
    
    print "run wf url is " . $run_wf_url . "\n";
    print "run wf res str is " . $run_wf_res_str . "\n";

    if ($statuswait eq "yes") {
        $wf_status = get_wfstatus($CDSip, $sessionid, $wf_id);
        while ( $wf_status eq "RUNNING" ) {
            sleep(60);
            $wf_status = get_wfstatus($CDSip, $sessionid, $wf_id);
        }
        $re_code = 0;
        if ($wf_status ne "SUCCESS") {
            $re_code = 1;
        }

        die return $re_code;
    }
}

sub runwfliveclone {
    $sessionid = getSession();
    my $retuser = retrieve ($sesfile);
  #  $CDSip = $retuser -> {CDSip};
    if ( $sessionid eq "" ) {
        die "Authentication is not established\n";
    }

    $hostid = getHost();
    if ( $hostid eq "" ) {
        die "could not get source hostid\n";
    }
    $appid = getApp();
    if ( $appid eq "" ) {
        die "could not get appid\n";
    }

    if ($image eq "") {
        $bkpstring = getLatestImage();
        @bkparray = split /:/, $bkpstring;
        $imageid = $bkparray[0];
        $bkpname = $bkparray[1];
        print "image id is " . $imageid ."\n";
        print "image name is " . $bkpname ."\n";
    }
    else {
        $bkpname=$image;
    }

    if ( $bkpname eq "" ) {
        die "could not get latest imagename\n";
    }

    my $wf_url = "https://" . $CDSip . "/actifio/api/info/lsworkflow?sessionid=" . $sessionid . '&argument=' . $wfname;

    my $wf_res = $ua->get($wf_url);

    my $wf_res_str = $wf_res->content;
    my $wf_json_r = JSON->new->utf8;
    my $WF_JSON_RES = $wf_json_r->decode($wf_res_str);
    my $wf_id = $WF_JSON_RES->{'result'}{'id'};
    my $xmlstr = $WF_JSON_RES->{'result'}{'tasks'};

    #print $xmlstr . "\n";
    my $ref = XMLin($xmlstr);
    print Dumper($ref);
    my $mount_itemid = $ref->{mount}->{id};
    my $dbsid_itemid = $ref->{mount}->{'provisioning-options'}->{databasesid}->{id};
    
    my $tdbname = $ref->{mount}->{'provisioning-options'}->{databasesid}->{content};
    print "database name is " . $dbgname . "\n";
    #print "mount id: ". $mount_itemid . "\n";
    #print "dbsid id: ". $dbsid_itemid . "\n";

    if ( $wf_id eq " " ) {
            die "could not get workflow id\n";
    }

# Clone workflow.
    my $clone_wf_url = "https://" . $CDSip . "/actifio/api/task/cloneworkflow?sessionid=" . $sessionid . "&argument=" . $wf_id;
    my $clone_wf_res = $ua->post($clone_wf_url);
    my $clone_wf_res_str =  $clone_wf_res->content;
    my $clone_wf_json_r = JSON->new->utf8;

    my $CL_WF_JSON_RES = $clone_wf_json_r->decode($clone_wf_res_str);
    my $cwf_id = $CL_WF_JSON_RES->{'result'};
    printf "clone work flow id: " . $cwf_id . "\n";

if ( $reprov eq "yes" ) {
# Creating flow item property for reprovision. udstask mkflowitem -workflow <cloned wf id> -type reprovision -depends <mount id>
    my $mkfi_rep_url = "https://" . $CDSip . "/actifio/api/task/mkflowitem?sessionid=" . $sessionid . "&workflow=" . $cwf_id . "&type=reprovision&depends=" . $mount_itemid;
    my $mkfi_rep_res = $ua->post($mkfi_rep_url);
    my $mkfi_rep_res_str =  $mkfi_rep_res->content;
    my $mkfi_rep_json_r = JSON->new->utf8;
    
    my $MKFI_REP_JSON_RES = $mkfi_rep_json_r->decode($mkfi_rep_res_str);
    my $reprovision_id = $MKFI_REP_JSON_RES->{'result'};

# Creating flow item property for application. udstask mkflowitem -workflow <cloned wf id> -type app -depends <reprovision id>
    my $mkfi_app_url = "https://" . $CDSip . "/actifio/api/task/mkflowitem?sessionid=" . $sessionid . "&workflow=" . $cwf_id . "&type=app&depends=" . $reprovision_id;
    my $mkfi_app_res = $ua->post($mkfi_app_url);
    my $mkfi_app_res_str =  $mkfi_app_res->content;
    my $mkfi_app_json_r = JSON->new->utf8;

    my $MKFI_APP_JSON_RES = $mkfi_app_json_r->decode($mkfi_app_res_str);
    my $app_id = $MKFI_APP_JSON_RES->{'result'};

# List application by name and get id.
    my $list_app_url = "https://" . $CDSip . "/actifio/api/info/lsapplication?sessionid=" . $sessionid . "&filtervalue=appname%3D" . $tdbname;
    my $list_app_res = $ua->get($list_app_url);
    my $list_app_res_str =  $list_app_res->content;
   
    my $list_app_json_r = JSON->new->utf8;
    my $LIST_APP_RES = $list_app_json_r->decode($list_app_res_str);
    my $tdb_id = $LIST_APP_RES->{'result'}->[0]->{'id'};

# Add value to the flow item app in reprovision. udstask addflowitemvalue -workflow <clone wf id> -itemid <app element id> -value <child application id>
    my $addfiv_app_url = "https://" . $CDSip . "/actifio/api/task/addflowitemvalue?sessionid=" . $sessionid . "&workflow=" . $cwf_id . "&itemid=" . $app_id . "&value=" . $tdb_id;
    my $addfiv_app_res = $ua->post($addfiv_app_url);
}

print "cwfid: " . $cwf_id . "\n";
# Add image to the cloned workflow. udstask addflowproperty -name image -value <image name> <cloned workflow id>
    my $add_wf_url = "https://" . $CDSip . "/actifio/api/task/addflowproperty?sessionid=" . $sessionid . "&name=image&value=" . $bkpname . "&argument=" . $cwf_id;
    my $add_wf_res = $ua->post($add_wf_url);
    my $add_wf_res_str =  $add_wf_res->content;

    my $wf_url = "https://" . $CDSip . "/actifio/api/info/lsworkflow?sessionid=" . $sessionid . '&argument=' . $cwf_id;

    my $wf_res = $ua->get($wf_url);

    my $wf_res_str = $wf_res->content;
    my $wf_json_r = JSON->new->utf8;
    my $WF_JSON_RES = $wf_json_r->decode($wf_res_str);
    my $wf_id = $WF_JSON_RES->{'result'}{'id'};
    my $xmlstr = $WF_JSON_RES->{'result'}{'tasks'};

    #print $xmlstr . "\n";

    my $run_wf_url = "https://" . $CDSip . "/actifio/api/task/runworkflow?sessionid=" . $sessionid;
    $run_wf_url = $run_wf_url . "&argument=" . $cwf_id;
    if ( ( $reflive ne "" ) || ( $reflive eq "false" ) ) {    
    	$run_wf_url = $run_wf_url . "&norefreshliveclone=" . $reflive; 
    }
    if ( ( $provlive ne "" ) || ( $provlive eq "false" ) ) { 
        $run_wf_url = $run_wf_url . "&nocreatevirtualclone=" . $provlive;
    }
    print $run_wf_url . "\n";

    my $run_wf_res = $ua->post($run_wf_url);
    my $run_wf_res_str =  $run_wf_res->content;
    my $run_wf_json_r = JSON->new->utf8;
    my $RUNWF_RES = $run_wf_json_r->decode($run_wf_res_str);
    my $req_status = $RUNWF_RES->{'status'};

    if ($statuswait eq "yes") {
        $wf_status = get_wfstatus($CDSip, $sessionid, $wf_id);
        while ( $wf_status eq "RUNNING" ) {
            sleep(60);
            $wf_status = get_wfstatus($CDSip, $sessionid, $wf_id);
        }
        $re_code = 0;
        if ($wf_status ne "SUCCESS") {
            $re_code = 1;
        }

        if ( $re_code == 1 ) {
        print "status = SUCCESS\n";
        }
        else {
         print "status = FAILED\n";
        }

        die return $re_code;
    }
}

sub get_wfstatus() {
    $sCDSip = $_[0];
    $ssessionid = $_[1];
    $swf_id = $_[2];

    if ( $sessionid eq "" ) {
        die "Authentication is not established\n";
    }

    my $stathist_url = 'https://' . $CDSip . '/actifio/api/info/lsworkflowstatus?sessionid=' . $sessionid . '&argument=' . $swf_id;
    $ua = LWP::UserAgent->new;
    my $stathist_res = $ua->get($stathist_url);
    my $stathist_res_str = $stathist_res->content;
    my $stathist_json_r = JSON->new->utf8;
    my $STATHIST_RES = $stathist_json_r->decode($stathist_res_str);
#    my $result = $STATHIST_RES->{'result'};
    my @resulto = @{$STATHIST_RES->{'result'}};

    foreach $key (sort keys %{ $resulto[0] } ) {
        if ( $key eq "status" ) {
             $wf_status = ${ $resulto[0] }{$key};
                }
        }

    print "status = " . $wf_status . "\n";
    return $wf_status;
}

sub listDiscoveredHost {
    $sessionid = getSession();
    my $retuser = retrieve ($sesfile);
    $CDSip = $retuser -> {CDSip};
    if ( $sessionid eq "" ) {
        die "Authentication is not established\n";
    }

    my $host_url ='https://' . $CDSip . '/actifio/api/info/lshost?sessionid=' . $sessionid;
    $ua = LWP::UserAgent->new;
    my $host_res = $ua->get($host_url);

    my $host_res_str =  $host_res->content;
    my $host_json_r = JSON->new->utf8;
    my $HOST_RES = $host_json_r->decode($host_res_str);
    my @hosts = @{$HOST_RES->{'result'}};

    foreach my $host (@hosts) {
        my $hostname = $host->{hostname};
        my $hostid = $host->{id};
        my $hostip = $host->{ipaddress};
        print "hostName: " . $hostname . "\n";
        print "hostIP:   ". $hostip . "\n";
        print "hostID:   ". $hostid . "\n";
        print "\n";
     }
}

sub listApplication {
    $sessionid = getSession();
    my $retuser = retrieve ($sesfile);
    $CDSip = $retuser -> {CDSip};
    if ( $sessionid eq "" ) {
        die "Authentication is not established\n";
    }

       $hostname=$sourceHost;
    #Get Host
     $hostid = getHost();
     if ( $hostid eq "" ) {
         die "could not get hostid\n";
       }
    my $appo_url = 'https://' . $CDSip . '/actifio/api/info/lsapplication?sessionid=' . $sessionid . '&filtervalue=hostid%3D' . $hostid. '%26apptype%3D' . $appType;
   # my $appo_url = 'https://' . $CDSip . '/actifio/api/info/lsapplication?sessionid=' . $sessionid . '&filtervalue=hostid%3D' . $hostid. '%26apptype%3D' . $appType . '%26protectable%3D' . $protection;

       my $appo_res = $ua->get($appo_url);
       my $appo_res_str = $appo_res->content;
       my $appo_json_r = JSON->new->utf8;
       my $APPO_RES = $appo_json_r->decode($appo_res_str);
       my @apps = @{$APPO_RES->{'result'}};

    foreach my $app (@apps) {
       sleep(10);
       my $appid = $app->{id};
       my $appd_url = 'https://' . $CDSip . '/actifio/api/info/lsapplication?sessionid=' . $sessionid . '&argument=' . $appid;
       my $appd_res = $ua->get($appd_url);

        my $appd_res_str = $appd_res->content;
        my $appd_json_r = JSON->new->utf8;
        my $APPD_RES = $appd_json_r->decode($appd_res_str);

       $appid = $APPD_RES->{'result'}->{'id'};
       $appname = $APPD_RES->{'result'}->{'appname'};
       $apptype = $APPD_RES->{'result'}->{'apptype'};
       $protectable = $APPD_RES->{'result'}->{'protectable'};
       
       # print $hostname . ":\n";

          my $sla_url = 'https://' . $CDSip . '/actifio/api/info/lssla?sessionid=' . $sessionid . '&filtervalue=appid%3D' . $appid;
          my $sla_res = $ua->get($sla_url);
          my $sla_res_str = $sla_res->content;
          my $sla_json_r = JSON->new->utf8;
          my $SLA_RES = $sla_json_r->decode($sla_res_str);
          my @slas = @{$SLA_RES->{'result'}};
          foreach my $sla (@slas) {
          my $slpid = $sla->{slpid};
          $sltid = $sla->{sltid};
          $expireoff = $sla->{'expirationoff'};
          $scheduleoff = $sla->{'scheduleoff'};

      if ( $sltid ne "" ) {
          my $slt_url = 'https://' . $CDSip . '/actifio/api/info/lsslt?sessionid=' . $sessionid . '&argument=' . $sltid;
           $ua = LWP::UserAgent->new;
          my $slt_res = $ua->get($slt_url);
          my $slt_res_str = $slt_res->content;
          my $slt_json_r = JSON->new->utf8;
          my $SLT_RES = $slt_json_r->decode($slt_res_str);
          $templatename = $SLT_RES->{'result'}->{'name'};
        }
        if ( $protection eq "protected" ) {
          if ( ( $sltid ne "" ) && ( $scheduleoff eq "false" ) ) {
             if ( $apptype eq "Oracle" ) {
                print $hostname . "\n";
                print "    oracleApplicationName: " . $appname . "\n";
                print "    oracleApplicationID:   " . $appid . "\n";
                print "    CDS:                   " . $CDSip . "\n";
                print "    templateApplied:       " . $templatename . "\n";
                print "    protection:             Protected\n";
            }

          if ( $apptype eq "SqlServerWriter" ) {
              print $hostname . "\n";
              print "    sqlServerApplicationName: " . $appname . "\n";
              print "    sqlServerApplicationID:   " . $appid . "\n";
              print "    CDS:                      " . $CDSip . "\n";
              print "    templateApplied:          " . $templatename . "\n";
              print "    protection:                Protected\n";
           }
        }
          if ( ( ( $apptype eq "Oracle" ) && ( $apptype ne "SqlServerWriter" ) ) && ( $scheduleoff ne "false" ) ) {
           print " Protection on Oralce application " . $appname . " is not enabled on " . $hostname . "\n";
          }
          if ( ( ( $apptype ne "Oracle" ) && ( $apptype eq "SqlServerWriter" ) ) && ( $scheduleoff ne "false" ) ) {
           print " Protection on SQLServer application " . $appname . " is not enabled on " . $hostname . "\n";
          }
      }

        if ( $protection eq "disabled" ) {
          if ( ( $sltid ne "" ) && ( $scheduleoff eq "true" ) ) {
             if ( $apptype eq "Oracle" ) {
                print $hostname . "\n";
                print "    oracleApplicationName: " . $appname . "\n";
                print "    oracleApplicationID:   " . $appid . "\n";
                print "    CDS:                   " . $CDSip . "\n";
                print "    templateApplied:       " . $templatename . "\n";
                print "    protection:             Protection Disabled\n";
            }

          if ( $apptype eq "SqlServerWriter" ) {
              print $hostname . "\n";
              print "    sqlServerApplicationName: " . $appname . "\n";
              print "    sqlServerApplicationID:   " . $appid . "\n";
              print "    CDS:                      " . $CDSip . "\n";
              print "    templateApplied:          " . $templatename . "\n";
              print "    protection:                Protection Disabled\n";
           }
        }
          if ( ( ( $apptype eq "Oracle" ) && ( $apptype ne "SqlServerWriter" ) ) && ( $scheduleoff ne "true" ) ) {
           print " Protection on Oralce application " . $appname . " is disabled on " . $hostname . "\n";
          }
          if ( ( ( $apptype ne "Oracle" ) && ( $apptype eq "SqlServerWriter" ) ) && ( $scheduleoff ne "true" ) ) {
           print " Protection on SQLServer application " . $appname . " is disabled on " . $hostname . "\n";
          }
      }

        if ( $protection eq "all" ) {
             if ( $apptype eq "Oracle" ) {
                print $hostname . "\n";
                print "    oracleApplicationName: " . $appname . "\n";
                print "    oracleApplicationID:   " . $appid . "\n";
                print "    CDS:                   " . $CDSip. "\n";
                if ( $templatename ne "" ) {
                print "    templateApplied:       " . $templatename . "\n";
                }
                if ( ( $templatename ne "" ) && ( $scheduleoff eq "true" ) ) {
                print "    protection:             Protection Disabled\n";
                }
                if ( ( $templatename ne "" ) && ( $scheduleoff eq "false" ) ) {
                print "    protection:             Protected\n";
                } 
            }

          if ( $apptype eq "SqlServerWriter" ) {
              print $hostname . "\n";
              print "    sqlServerApplicationName: " . $appname . "\n";
              print "    sqlServerApplicationID:   " . $appid . "\n";
              print "    CDS:                      " . $CDSip . "\n";
                if ( $templatename ne "" ) {
                print "    templateApplied:        " . $templatename . "\n";
                }
               if ( ( $templatename ne "" ) && ( $scheduleoff eq "true" ) ) {
                print "    protection:             Protection Disabled\n";
                }
                if ( ( $templatename ne "" ) && ( $scheduleoff eq "false" ) ) {
                print "    protection:             Protected\n";
                }
           }
         if ( ( $apptype ne "Oracle" ) && ( $apptype ne "SqlServerWriter" ) ) {
           print " No Oralce and SQLServer applications are discovered on " . $hostname . "\n";
          }
        }

        if ( $protection eq "notProtected" ) {
          if ( $sltid eq ""  ) {
             if ( $apptype eq "Oracle" ) {
                print $hostname . "\n";
                print "    oracleApplicationName: " . $appname . "\n";
                print "    oracleApplicationID:   " . $appid . "\n";
                print "    CDS:                   " . $CDSip . "\n";
            }

          if ( $apptype eq "SqlServerWriter" ) {
              print $hostname . "\n";
              print "    sqlServerApplicationName: " . $appname . "\n";
              print "    sqlServerApplicationID:   " . $appid . "\n";
              print "    CDS:                      " . $CDSip . "\n";
           }
        }
         if ( ( ( $apptype eq "Oracle" ) && ( $apptype ne "SqlServerWriter" ) ) && ( $sltid eq "" ) ) {
           print "Oralce application " . $appname . " is not protected on " . $hostname . "\n";
          }
          if ( ( ( $apptype ne "Oracle" ) && ( $apptype eq "SqlServerWriter" ) ) && ( $sltid eq "" ) ) {
           print "SQLServer application " . $appname . " is not protected on " . $hostname . "\n";
          }
      }

     print "\n";
   }
}
}
exit $re_code;
# print "\nscript completed\n";
