#!/bin/sh

ORACLE_HOME=$1
orasid=$2
confDir=$3
ouser=$4
swfile=$5

BASEDIR=$(dirname $0)
echo $BASEDIR
cd $BASEDIR

cuser=`whoami`

if [ "$cuser" != "$ouser" ]; then
suser="su -m $ouser -c "
else
suser=""
fi
if [ "x$suser" = "x" ]; then
inc=`srvctl config database -d $orasid|grep -i "Database instances"| head -n1 | cut -f2 -d":"`
else
inc=`$suser"srvctl config database -d $orasid "|grep -i "Database instances"| head -n1 | cut -f2 -d":"`
fi

origsid="init"$orasid".ora"
var=`grep "ASM_" $confDir/asm_node_config.conf | cut -f2 -d:`
m=0
for x in $var; do
  echo $x
  m=$(($m + 1));
  orasid1=$orasid$m
  orasidnode="init"$orasid1".ora"
   if [ $m = 1 ]
    then
	echo "Parameter file is available in Current node"
	if [ "$inc" == " " ]; 
	then
           if [ "x$suser" = "x" ]; then
	   srvctl add instance -i $orasid1 -d $orasid -n $x
           else
           $suser"srvctl add instance -i $orasid1 -d $orasid -n $x"
           fi
	fi
    else
      if [ "x$suser" = "x" ]; then
      ssh -o StrictHostKeyChecking=no -l$ouser $x exit
      scp $ORACLE_HOME/dbs/$origsid $ouser@$x:$ORACLE_HOME/dbs/$orasidnode
      scp $swfile $ouser@$x:$swfile
      else
      $suser"ssh -o StrictHostKeyChecking=no -l$ouser $x exit"
      $suser"scp $ORACLE_HOME/dbs/$origsid $ouser@$x:$ORACLE_HOME/dbs/$orasidnode"
      $suser"scp $swfile $ouser@$x:$swfile"
      fi
        if [ "$inc" == " " ];
        then
           if [ "x$suser" = "x" ]; then
           srvctl add instance -i $orasid1 -d $orasid -n $x
           else
           $suser"srvctl add instance -i $orasid1 -d $orasid -n $x"
           fi
        fi
   fi
done

exit 0
