/* ============================================================
 * Actifio VirtualData Pipeline
 * Copyright (c) 2011 Actifio Inc. All Rights Reserved
 *
 * This program code contains trade secrets of Actifio Inc. that
 * (i) derive independent economic value, actual or potential, from not being
 * generally known to, and not being readily ascertainable by proper means by
 * other persons who can obtain economic value from their disclosure or use and;
 * (ii) are the subject of efforts by Actifio Inc that are reasonable under the
 * circumstances to maintain their secrecy. You may not use this program code
 * without prior written authorization from Actifio Inc.
 *
 * Filename       : asmrestoreGenerateRedoRename.sql
 *
 * Description:   generate redo rename file
 *
 * =============================================================
 */
SET TERMOUT OFF
SET HEADING OFF
SET PAGESIZE 5000
SET LINESIZE 200
SET TRIMSPOOL OFF
SET WRAP OFF
SET FEEDBACK OFF
SET ECHO OFF
spool /act/act_scripts/asmclone/asmrestoreRenameRedo.sql
select 'SET TERMOUT OFF' from dual;
select 'SET HEADING OFF' from dual;
select 'SET TRIMSPOOL OFF' from dual;
select 'SET WRAP OFF' from dual;
select 'SET FEEDBACK OFF' from dual;
select 'SET ECHO OFF' from dual;
--select 'alter database rename file '||''''||member||''''||' to '||''''||'$dataDir1/$nsid/onlinelog/'||substr(member,instr(member,'/',-1,1)+1)||''''||';' from v\$logfile;
select 'alter database rename file '||''''||member||''''||' to '||'''&1'||substr(member,instr(member,'/',1))||''''||';'
from v$logfile
select 'exit;' from dual;
spool off
exit;



