/* ============================================================
 * Actifio VirtualData Pipeline
 * Copyright (c) 20112 Actifio Inc. All Rights Reserved
 *
 * This program code contains trade secrets of Actifio Inc. that
 * (i) derive independent economic value, actual or potential, from not being
 * generally known to, and not being readily ascertainable by proper means by
 * other persons who can obtain economic value from their disclosure or use and;
 * (ii) are the subject of efforts by Actifio Inc that are reasonable under the
 * circumstances to maintain their secrecy. You may not use this program code
 * without prior written authorization from Actifio Inc.
 *
 * Filename       : backupBCTStats.sql
 *
 * Description:   
 *
 * =============================================================
 */
set pages 0
set head off
set feed off
set timing off
set echo off
set numwidth 18

select file#, completion_time, datafile_blocks, blocks_read, blocks, used_change_tracking  
from v$backup_datafile 
where file# < 400
and blocks > &1 
order by 1
/

