/* ============================================================
 * Actifio VirtualData Pipeline
 * Copyright (c) 2011 Actifio Inc. All Rights Reserved
 *
 * This program code contains trade secrets of Actifio Inc. that
 * (i) derive independent economic value, actual or potential, from not being
 * generally known to, and not being readily ascertainable by proper means by
 * other persons who can obtain economic value from their disclosure or use and;
 * (ii) are the subject of efforts by Actifio Inc that are reasonable under the
 * circumstances to maintain their secrecy. You may not use this program code
 * without prior written authorization from Actifio Inc.
 *
 * Filename       : backupDatafiles_nonactivdg.sql
 *
 * Description:   get backup datafiles with given tag for nonactive dataguard
 *
 * =============================================================
 */

set lin &1
set pages 0
set head off
set feed off
set timing off
set echo off
WHENEVER SQLERROR EXIT SQL.SQLCODE
select name from v$backup_copy_details where file# > 0 and tag = upper('&2');
exit;
