#!/bin/sh
#Scipt to execure sql from freeze,thaw and abort scripts 

sqlcmd=$1
ORACLE_HOME=$2
ORACLE_SID=$3
PWDS=/act/scripts

export ORACLE_HOME=$ORACLE_HOME
export TNS_ADMIN=$ORACLE_HOME/network/admin
export ORACLE_SID=$ORACLE_SID
export PATH=$ORACLE_HOME/bin:$PATH
echo "**** $ORACLE_HOME"
echo "*** $ORACLE_SID"
sqlplus=$ORACLE_HOME/bin/sqlplus
echo "*** $sqlplus"

if [ -f $PWDS/sqlplus.out ]; then
   echo "removing sqlplus.out file..."
   rm -f $PWDS/sqlplus.out
fi
cat $sqlcmd
$sqlplus -s /nolog << EOF
@$sqlcmd
EOF
retval=`cat $PWDS/sqlplus.out`
echo $retval
exit 0

