#!/bin/bash -ex
workingdir="/mongorestore"
nodedirectory='mongo-node'

#!/bin/bash
	for i in {1..3}
	do	
    cd $workingdir
		mongo_port=`expr 27016 + $i`
		nodeid=$nodedirectory$i
		mkdir $nodeid
		cd $nodeid
		mkdir data
		mkdir log
		mongod --dbpath=$workingdir/$nodeid/data --logpath=$workingdir/$nodeid/log/mongo.log --fork --port=$mongo_port --replSet snow
	done
fi	
echo "Waiting for all nodes to initialize.."
sleep 5
mongo localhost:27017 /act/scripts/initialize-replicaset.js

