/* ============================================================
 * Actifio VirtualData Pipeline
 * Copyright (c) 2014 Actifio Inc. All Rights Reserved
 *
 * This program code contains trade secrets of Actifio Inc. that
 * (i) derive independent economic value, actual or potential, from not being
 * generally known to, and not being readily ascertainable by proper means by
 * other persons who can obtain economic value from their disclosure or use and;
 * (ii) are the subject of efforts by Actifio Inc that are reasonable under the
 * circumstances to maintain their secrecy. You may not use this program code
 * without prior written authorization from Actifio Inc.
 *
 * Filename       : readonlyDatafileCatalog.sql 
 *
 * Description:   retrieve datafiles have READONLY status
 *
 * =============================================================
 */

set pages 0
set head off
set feed off
set timing off
set echo off
set lin 320
WHENEVER SQLERROR EXIT SQL.SQLCODE
select TABLESPACE_NAME from dba_tablespaces where status = 'READ ONLY';
exit;



