/* ============================================================
 * Actifio VirtualData Pipeline
 * Copyright (c) 20112 Actifio Inc. All Rights Reserved
 *
 * This program code contains trade secrets of Actifio Inc. that
 * (i) derive independent economic value, actual or potential, from not being
 * generally known to, and not being readily ascertainable by proper means by
 * other persons who can obtain economic value from their disclosure or use and;
 * (ii) are the subject of efforts by Actifio Inc that are reasonable under the
 * circumstances to maintain their secrecy. You may not use this program code
 * without prior written authorization from Actifio Inc.
 *
 * Filename       : rmanBackupJobDetails.sql
 *
 * Description:   
 *
 * =============================================================
 */

set pages 0
set head off
set feed off
set timing off
set echo off
set numwidth 18
WHENEVER SQLERROR EXIT SQL.SQLCODE
select input_bytes, output_bytes, output_bytes_per_sec from v$rman_backup_job_details where output_device_type = 'DISK' 
and end_time = (select max(end_time) from v$rman_backup_job_details where output_device_type = 'DISK');
