#!/bin/sh
set -x

WPWD=/act/scripts

#export ACT_JOBTYPE=unmount
#export ACT_PHASE=pre

. /act/scripts/HANADB_config.conf

if [ -z $dbsid ]; then
echo "ERROR: Database SID is not set under /act/scripts/HANADB_config.conf"
exit 1
fi

dbsidadm=$dbsid"adm"
export dbsidadm

if [ "$ACT_JOBTYPE" == "unmount" ] || [ "$ACT_MULTI_OPNAME" == "unmount" ] ; then
   if [ "$ACT_PHASE" == "post" ] ; then
        echo "********** No post during unmount ************"
      exit
   fi
   if [ "$ACT_LOGSMART_TYPE" == "log" ] ; then
        echo "********** No op during log unmount ************"
      exit
   fi

   if [ "$ACT_PHASE" == "pre" ] ; then

	echo "********** call HANA DB stop ************"
	su - $dbsidadm -c "$WPWD/ACT_HANADB_saphana_stop.sh"
   fi
fi

exit 0

