#!/bin/sh
# =============================================================================
# Actifio Unified Data Protector
# Copyright (c) 2011 Actifio Inc. All Rights Reserved
#
# This program code contains trade secrets of Actifio Inc. that
# (i) derive independent economic value, actual or potential, from not being
# generally known to, and not being readily ascertainable by proper means by
# other persons who can obtain economic value from their disclosure or use and;
# (ii) are the subject of efforts by Actifio Inc that are reasonable under the
# circumstances to maintain their secrecy. You may not use this program code
# without prior written authorization from Actifio Inc.
#
# Description: shell script to validate tnsname of a given Oracle SID
#              parameter SID
#
# ==============================================================================
sid=$1
nlistener=$2

if [ -z $sid ]; then
   exit 1
fi

lis=$sid
if [ -n "$nlistener" ]; then
   lis=$nlistener
fi

. /act/act_scripts/commresource.sh

retval=`lsnrctl status $lis | grep -i $sid | grep -v TNS-`

if [ -z "$retval" ]; then
   retval=`lsnrctl status | grep $sid | grep -v TNS-`
fi
echo $retval
exit 0
