#!/usr/bin/perl

use MIME::Base64;
use Sys::Hostname;
use Storable;
use Socket;
use File::Basename;
use File::Find;
use Cwd;
use Data::Dumper;
use URI::Escape;

my @session;
my %appdetails;
my $appdetails;
my @sourcelist;
my $sourcelist;
my @hostdetails;
my $hostdetails;

my %arghash = @ARGV;
$| = 1;
my $hostname;
my $appname;
my $bkptype;
my $count=0;
my $pwd;
my $detfile;
my $AGMips;
my $userfile;
my @sesdir;
my $AGMip;
my $sesfile;
my $retuser;
#my $appid;
my @app;
my $app;

die "Usage:actAGMDBM\n       --type \n            <listAppliance> \n            <backup> \n            <agmconfig> \n            <listImageDetails> \n" if ( !exists $arghash{'--type'} );
die "Usage:actAGMDBM\n       --type \n            <listAppliance> \n            <backup> \n            <agmconfig> \n            <listImageDetails> \n" if ( (exists $arghash{'--help'}) && (!exists $arghash{'--type'}) );

if ( $arghash{'--type'} eq "agmconfig" ) {
    die " Usage: perl actAGMDBM.pl --type agmconfig \n --username <AGM username> \n --password <AGM password> \n --AGM <AGM details>\n" if ( !exists $arghash{'--username'} );
    die " Usage: perl actAGMDBM.pl --type agmconfig \n --username <AGM username> \n --password <AGM password> \n --AGM <AGM details>\n" if ( !exists $arghash{'--password'} );
    die " Usage: perl actAGMDBM.pl --type agmconfig \n --username <AGM username> \n --password <AGM password> \n --AGM <AGM details>\n" if ( !exists $arghash{'--AGM'} );
    die " Usage: perl actAGMDBM.pl --type agmconfig \n --username <AGM username> \n --password <AGM password> \n --AGM <AGM details>\n" if ( (exists $arghash{'--help'}) && ($arghash{'--type'} eq "agmconfig") );
    my $username=$arghash{'--username'};
    my $password_en=MIME::Base64::encode($arghash{'--password'});
    my $AGMip=$arghash{'--AGM'};

    my %userhash = (username => $username, password => $password_en, AGMip => $AGMip);
    $pwd = cwd();
    #print "dir is " . $pwd;
    $detfile=$pwd . "/" . $AGMip . "_details";
    #print "file is " . $detfile;
    store \%userhash, $detfile;
    print "user details are stored successfully \n";
}

if ($arghash{'--type'} eq "listAppliance" ) {
   die "Usage:actAGMDBM --type listAppliance \n --appname <application name> \n --AGM <AGM name|ip> \n" if ( (exists $arghash{'--help'} ) && ($arghash{'--type'} eq "listAppliance") );
    die "Usage:actAGMDBM --type listAppliance \n --appname <application name> \n --AGM <AGM name|ip> \n" if (( ( !exists $arghash{'--appname'} ) || ( !exists $arghash{'--AGM'} ) ) && ($arghash{'--type'} eq "listAppliance") );

$appname=$arghash{'--appname'};

    if ( !exists $arghash{'--AGM'} ) {
           $pwd = cwd();

    @sesdir = ("$pwd",);
    $count=0;
    find(\&wanted, @sesdir);
      my $retuser = retrieve ($userfile);
      $AGMips = $retuser -> {AGMip};

   if ( ($count >= 1) || ($AGMips eq "generic") ) {
     die "--AGM parameter is not specified\n Usage:actAGMDBM --type listAppliance \n --appname <application name> \n --AGM <AGM name|ip> \n" if (( !exists $arghash{'--AGM'} ) && ($arghash{'--type'} eq "listAppliance") );
     }
   }
    elsif ( exists $arghash{'--AGM'} ) {
        $AGMip=$arghash{'--AGM'};
    }

    if ( !exists $arghash{'--AGM'} ) {
           $pwd = cwd();

    @sesdir = ("$pwd",);
    print $pwd . "\n";
    $count=0;
    File::Find::find(\&wanted, @sesdir);
      my $retuser = retrieve ($userfile);
      $AGMips = $retuser -> {AGMip};
}
listAppliance();
}

if ($arghash{'--type'} eq "listImageDetails" ) {
   die "Usage:actAGMDBM --type listImageDetails \n --appname <application name> \n --hostname <source hostname> \n --AGM <AGM name|ip> \n" if ( (exists $arghash{'--help'} ) && ($arghash{'--type'} eq "listImageDetails") );
   die "Usage:actAGMDBM --type listImageDetails \n --appname <application name> \n --hostname <source hostname> \n --AGM <AGM name|ip> \n" if (( ( !exists $arghash{'--appname'} ) || ( !exists $arghash{'--AGM'} ) ) && ($arghash{'--type'} eq "listImageDetails") );

$appname=$arghash{'--appname'};
$hostname=$arghash{'--hostname'};

    if ( !exists $arghash{'--AGM'} ) {
           $pwd = cwd();

    @sesdir = ("$pwd",);
    $count=0;
    find(\&wanted, @sesdir);
      my $retuser = retrieve ($userfile);
      $AGMips = $retuser -> {AGMip};

   if ( ($count >= 1) || ($AGMips eq "generic") ) {
     die "--AGM parameter is not specified\n  Usage:actAGMDBM --type listImageDetails \n --appname <application name> \n --hostname <source hostname> \n --AGM <AGM name|ip> \n" if (( !exists $arghash{'--AGM'} ) && ($arghash{'--type'} eq "listImageDetails") );
     }
   }
    elsif ( exists $arghash{'--AGM'} ) {
        $AGMip=$arghash{'--AGM'};
    }
listImageDetails();
}

#sub wanted {
#    if(/_details$/) {
#        $userfile=$_;
#        $count++;
#    }

# }

$userfile;
sub wanted {
    #my $file_name = $_;
     $file_list = $AGMip . "_details";
    if ( ( -f $file_list ) ) {
        $userfile=$file_list;
     $count++;
     last;
    }
   # $count++;
}

if ($arghash{'--type'} eq "backup" ) {
   die "Usage:actAGMDBM --type backup \n --appname <application name> \n [--hostname <hostname>] \n [--backuptype <db|log|dblog>] \n [--backuplabel <label name>] \n --AGM <AGM name|ip> \n [--wait <yes|no>] \n" if ( (exists $arghash{'--help'} ) && ($arghash{'--type'} eq "backup") );
    die "Usage:actAGMDBM --type backup \n --appname <application name> \n [--hostname <hostname>] \n [--backuptype <db|log|dblog>] \n [--backuplabel <label name>] \n --AGM <AGM name|ip> \n [--wait <yes|no>] \n" if (( ( !exists $arghash{'--appname'} ) || ( !exists $arghash{'--AGM'} ) ) && ($arghash{'--type'} eq "backup") );

$appname=$arghash{'--appname'};

if ( !exists $arghash{'--hostname'} ) {
        $hostname=hostname;
        $hostname =~ s/(\w+)\..*/\1/;
    }
    elsif ( exists $arghash{'--hostname'} ) {
        $hostname=$arghash{'--hostname'};
    }
    if ( !exists $arghash{'--backuptype'} ) {
        $bkptype="db";
    }
    elsif ( exists $arghash{'--backuptype'} ) {
        $bkptype=$arghash{'--backuptype'};
    }

    if ( exists $arghash{'--backuplabel'} ) {
        $backlabel=$arghash{'--backuplabel'};
    }

    if ( !exists $arghash{'--wait'} ) {
        $wait="no";
    }
    elsif ( exists $arghash{'--wait'} ) {
        $wait=$arghash{'--wait'};
    }

        if ( !exists $arghash{'--AGM'} ) {
           $pwd = cwd();

    @sesdir = ("$pwd",);
    $count=0;
    find(\&wanted, @sesdir);
      my $retuser = retrieve ($userfile);
      $AGMips = $retuser -> {AGMip};

   if ( ($count >= 1) || ($AGMips eq "generic") ) {
     die "--AGM parameter is not specified\n Usage:actAGMDBM --type backup \n --appname <application name> \n [--hostname <hostname>] \n [--backuptype <db|log|dblog>] \n [--backuplabel <label name>] \n --AGM <AGM name|ip> \n" if (( !exists $arghash{'--AGM'} ) && ($arghash{'--type'} eq "backup") );
     }
   }
    elsif ( exists $arghash{'--AGM'} ) {
        $AGMip=$arghash{'--AGM'};
    }

backup();
}

sub getSessionID {

   $pwd = cwd();
    @sesdir = ("$pwd",);
    $count=0;
    File::Find::find(\&wanted, @sesdir);
      my $retuser = retrieve ($userfile);
      $AGMips = $retuser -> {AGMip};
      #print "AGM in file " . $AGMips . "\n";
    $detfile=$pwd . "/" . $AGMips . "_details";
   if ($count == 1) {
    $sesfile=$userfile;
  }
   if ($count > 1) {
    $sesfile=$detfile;
  }
  if (!-e $sesfile) {
   die "AGM user details file is missing\n";
  }
   #print "count is " . $count . "\n";
   #print "session file is " . $sesfile . "\n";
    $retuser = retrieve ($sesfile);
    my $username = $retuser -> {username};
    my $password_en = $retuser -> {password};

    my $password_de = MIME::Base64::decode($password_en);
    my $pass_enc = uri_escape($password_de);

my %token=`curl -XPOST --user $username:$pass_enc --tlsv1.2 -k -s https://$AGMips/actifio/session`; 

foreach my $key (%token) {
if ($key =~ /session_id/) { 
my @session = split(':', $key);
#print "The session id is" . $session[1] . "\n"; 
my $sessionid = $session[1];
return $sessionid;
  }
 }

}

sub listAppliance {

my $sessionid = getSessionID();
$sessionid =~ s/,$//;
$sessionid =~ s/\"//g;
$sessionid =~ s/^\s+|\s+$//g;

if ( $sessionid eq "" ) {
die "could not get sessionID \n";
}

print "\n";

my @appdetails=`curl -XGET -k -s --tlsv1.2 -H "Authorization: Actifio $sessionid" "https://$AGMips/actifio/application?filter=appname:==$appname"`;

my @arr;
my $f;

if ( @appdetails < 4 ) {
print "Application Name: " . $appname . " not found\n";
}

foreach my $k (@appdetails) {
#print $k; 
if ($k =~ /\@type/) {
$f = 1;
}

if ($f == 1) {
push(@arr, $k);
}
 
if ($k =~ /hostname/) { 
	$f = 0;
}
#continue;
#last; 
}

 
#print @arr; 
my $flag; 
foreach my $p (@arr) { 
#print $p;
$flag = 0; 
if ($p =~ /$appname/) { 
$flag = 1; 
} 
if (defined($flag) & $p =~ /\bname\b/) {
my @appliance = split(':', $p); 
my $appliancename =  $appliance[1];
$appliancename =~ s/,$//;
$appliancename =~ s/\"//g;
$appliancename =~ s/^\s+|\s+$//g;
if ( $appliancename ne $appname ) {
print "\n";
print "Application Name:     " . $appname . "\n";
print "Appliance Name:       " . $appliancename . "\n";
 } 
}
if (defined($flag) & $p =~ /\bipaddress\b/) {
my @ipadd = split(':', $p);
my $ipaddress = $ipadd[1];
$ipaddress =~ s/,$//;
$ipaddress =~ s/\"//g;
$ipaddress =~ s/^\s+|\s+$//g;
print "Appliance IPAddress:  " . $ipaddress . "\n";
}

if (defined($flag) & $p =~ /\btype\b/) {
my @appt = split(':', $p);
my $apptype = $appt[1];
$apptype =~ s/,$//;
$apptype =~ s/\"//g;
$apptype =~ s/^\s+|\s+$//g;
if ( ( $apptype eq  "CDS" ) || ( $apptype eq  "Sky" ) ) {
print "Appliance Type:       " . $apptype . "\n";
 }
}

if (defined($flag) & $p =~ /\bhostname\b/) {
  my @hname = split(':', $p);
  my $hostname = $hname[1];
  $hostname =~ s/,$//;
  $hostname =~ s/\"//g;
  $hostname =~ s/^\s+|\s+$//g;
print "Host Name:            " . $hostname . "\n";
  }

}

}

sub getAppID {

my $sessionid = getSessionID();
$sessionid =~ s/,$//;
$sessionid =~ s/\"//g;
$sessionid =~ s/^\s+|\s+$//g;

if ( $sessionid eq "" ) {
die "could not get sessionID \n";
}

#print "host name " . $hostname . "\n";

my @appdetails=`curl -XGET -k -s --tlsv1.2 -H "Authorization: Actifio $sessionid" "https://$AGMips/actifio/application?filter=appname:==$appname&filter=hostname:==$hostname"`;

foreach my $k (@appdetails) {
#print $k;
push(@arr, $k);
#if ($k =~ /},/) {
#last;
# }
}
#print @arr;
my $flag;
foreach my $p (@arr) {
#print $p . "\n";
$flag = 0;
if ( ($p =~ /$appname/) && ($p =~ /$hostname/) ) {
$flag = 1;
}

if (defined($flag) & $p =~ /id/) {
my @appi = split(':', $p);
my $appid =  $appi[1];
#print "App ID:     " . $appid . "\n";
return $appid;
}
}
}

sub backup {

my $sessionid = getSessionID();
$sessionid =~ s/,$//;
$sessionid =~ s/\"//g;
$sessionid =~ s/^\s+|\s+$//g;

if ( $sessionid eq "" ) {
die "could not get sessionID \n";
}
my $applid;
my $appid = getAppID();
$appid =~ s/,$//;
$appid =~ s/\"//g;
$appid =~ s/^\s+|\s+$//g;
$applid = $appid;
print "AppID is " . $appid . "\n";
print "\n";
if ( $appid eq "" ) {
die "could not get appID \n";
}

my @appdetails=`curl -XGET -k -s --tlsv1.2 -H "Authorization: Actifio $sessionid" "https://$AGMips/actifio/application?filter=appname:==$appname&filter=hostname:==$hostname"`;

if ( @appdetails < 4 ) {
print "Application Name: " . $appname . " not found\n";
}

my $sltf;
my $sltid;
my $slpf;
my $bkpjobid;
my $job_status;
my $job_errmsg;

foreach my $k (@appdetails) {
if ($k =~ /slt/) {
$flag=1;
}
if (defined($flag) & $k =~ /name/) {
my @slti = split(':', $k);
my $sltn =  $slti[1];
$sltn =~ s/,$//;
$sltn =~ s/\"//g;
$sltn =~ s/^\s+|\s+$//g;
$sltf = $sltn;
print "slt:     " . $sltn . "\n";
last;
}
 }

foreach my $i (@appdetails) {
if ($i =~ /slt/) {
$iflag=1;
}
if (defined($iflag) & $i =~ /id/) {
my @sltin = split(':', $i);
my $slti =  $sltin[1];
$slti =~ s/,$//;
$slti =~ s/\"//g;
$slti =~ s/^\s+|\s+$//g;
$sltid = $slti;
print "sltID:     " . $sltid . "\n";
last;
}
 }

foreach my $s (@appdetails) {
if ($s =~ /slp/) {
$sflag=1;
}
if (defined($sflag) & $s =~ /name/) {
my @slpi = split(':', $s);
my $slpn =  $slpi[1];
$slpn =~ s/,$//;
$slpn =~ s/\"//g;
$slpn =~ s/^\s+|\s+$//g;
$slpf = $slpn;
print "slp:     " . $slpf . "\n";
last;
}
 }

my $policyid;
my $optype;
my @parr;
my @policydet=`curl -XGET -k -s --tlsv1.2 -H "Authorization: Actifio $sessionid" https://$AGMips/actifio/slt/$sltid/policy`;

if ( @policydet < 4 ) {
print "Policy Details for " . $appname . " not found\n";
}

foreach my $p (@policydet) {
if ($p =~ /\@type/) {
$f = 1;
}

if ($f == 1) {
push(@parr, $p);
}

if ($p =~ /\bop\b/) {
        $f = 0;
}
#continue;
#last;
}
foreach my $p (@parr) {
#print $p;
if ($p =~ /id/) {
my @poli = split(':', $p);
my $polid =  $poli[1];
$polid =~ s/,$//;
$polid =~ s/\"//g;
$polid =~ s/^\s+|\s+$//g;
$policyid = $polid;
}
if ($p =~ /\bop\b/) {
my @opi = split(':', $p);
my $opt =  $opi[1];
$opt =~ s/,$//;
$opt =~ s/\"//g;
$opt =~ s/^\s+|\s+$//g;
$optype = $opt;
}
#print "operation type is " . $optype . "\n";
if ($optype eq "snap") {
print "PolicyID:     " . $policyid . "\n";
last;
}
}

print $policyid . "\n";

my @backupdet=`curl -XPOST -k --tlsv1.2 -H "Authorization: Actifio $sessionid" -H "Content-Type: application/json" -d '{"policy": {"id": "$policyid"},"backuptype": "$bkptype"}' https://$AGMips/actifio/application/$appid/backup 2>/dev/null`;


#if ( $backlabel ne "" ) {
#my @backupdet=`curl -XPOST -k --tlsv1.2 -H "Authorization: Actifio $sessionid" -H "Content-Type: application/json" -d '{"policy": {"id": "$policyid"},"backuptype": "$bkptype","backuplabel":"$backlabel"}' https://$AGMips/actifio/application/$appid/backup 2>/dev/null`;
#}

#print @backupdet . "\n";

if ( @backupdet == 0 ) {
sleep(15);
my @backupjob=`curl -XGET -k -s --tlsv1.2 -H "Authorization: Actifio $sessionid" "https://$AGMips/actifio/jobstatus?filter=appname:==$appname&filter=status:==running&filter=jobclasscode:==1"`;

foreach my $j (@backupjob) {
if ($j =~ /jobname/) {
my @bkpj = split(':', $j);
my $bkpjid =  $bkpj[1];
$bkpjid =~ s/,$//;
$bkpjid =~ s/\"//g;
$bkpjid =~ s/^\s+|\s+$//g;
$bkpjobid = $bkpjid;
print "Backup JobName:     " . $bkpjobid . "\n";
last;
}
 }


print "Backup Job " . $bkpjobid . " submitted Successfully\n";
}

if ( @backupdet > 0 ) {
die "Backup Job submission failed\n";
}
my $job_stat;
my @jobstatarray;

my $statuswait="no";

if ( $wait eq "yes" ) {
 $statuswait="yes";
}

if ( ( @backupdet == 0 ) && ($statuswait eq "yes") ) {
        
        $job_stat = jobStatus($bkpjobid);
        
         @jobstatarray = split /:/, $job_stat;
        $job_status = $jobstatarray[0];
        $job_error = $jobstatarray[1];

        while ( ( $job_error ne "10016" ) && ( $job_status eq "running" ) )  {
            sleep(60);
            $job_stat = jobStatus($bkpjobid);
            @jobstatarray = split /:/, $job_stat;
            $job_status = $jobstatarray[0];
            $job_error = $jobstatarray[1];
            print $job_status . "\n";
        }

        if ( $job_error eq "10016" ) {

            my @jobhiststat=`curl -XGET -k -s --tlsv1.2 -H "Authorization: Actifio $sessionid" "https://$AGMips/actifio/jobhistory?filter=jobname:==$bkpjobid"`;

foreach my $j (@jobhiststat) {
if ($j =~ /status/) {
my @jobs = split(':', $j);
my $jobstat =  $jobs[1];
$jobstat =~ s/,$//;
$jobstat =~ s/\"//g;
$jobstat =~ s/^\s+|\s+$//g;
$jobstatus = $jobstat;
#print "Backup Job:     " . $bkpjobid . " Status:" . $jobstatus . "\n";
last;
}
 }

foreach my $j (@jobhiststat) {
if ($j =~ /errorcode/) {
my @jobe = split(':', $j);
my $joberr =  $jobe[1];
$joberr =~ s/,$//;
$joberr =~ s/\"//g;
$joberr =~ s/^\s+|\s+$//g;
$joberrc = $jobstat;
#print "Backup Job:     " . $bkpjobid . " Errorcode:" . $joberrc . "\n";
last;
}
 }
}
        $re_code = 0;
        if ($job_status ne "succeeded") {
            $re_code = $job_errcode;
            print $job_errmsg . "\n";
            print "Backup Job " . $bkpjobid . " is " . $job_status . "\n";
        }
        if ($job_status eq "succeeded") {
            $re_code = $job_errcode;
            print "Backup Job " . $bkpjobid . " is " . $job_status . "\n";
        }        
         exit $re_code;
    }

}

my $job_error;
my $jobstatus;
my $joberrc;

sub jobStatus {

$bkpjobid = $_[0];

#my $jobstatus;
#my $joberrc;

my $sessionid = getSessionID();
$sessionid =~ s/,$//;
$sessionid =~ s/\"//g;
$sessionid =~ s/^\s+|\s+$//g;

if ( $sessionid eq "" ) {
die "could not get sessionID \n";
}

my @jobststat=`curl -XGET -k -s --tlsv1.2 -H "Authorization: Actifio $sessionid" "https://$AGMips/actifio/jobstatus?filter=jobname:==$bkpjobid"`;

foreach my $j (@jobststat) {
if ($j =~ /status/) {
my @jobs = split(':', $j);
my $jobstat =  $jobs[1];
$jobstat =~ s/,$//;
$jobstat =~ s/\"//g;
$jobstat =~ s/^\s+|\s+$//g;
$jobstatus = $jobstat;
#print "Backup Job:     " . $bkpjobid . " Status:" . $jobstatus . "\n";
last;
}
 }

foreach my $j (@jobststat) {
if ($j =~ /errorcode/) {
my @jobe = split(':', $j);
my $joberr =  $jobe[1];
$joberr =~ s/,$//;
$joberr =~ s/\"//g;
$joberr =~ s/^\s+|\s+$//g;
$joberrc = $jobstat;
#print "Backup Job:     " . $bkpjobid . " Errorcode:" . $joberrc . "\n";
last;
}
 }

return $jobstatus .":". $joberrc;
}

sub listImageDetails {

my $sessionid = getSessionID();
$sessionid =~ s/,$//;
$sessionid =~ s/\"//g;
$sessionid =~ s/^\s+|\s+$//g;

my $applid;
my $appid = getAppID();
$appid =~ s/,$//;
$appid =~ s/\"//g;
$appid =~ s/^\s+|\s+$//g;
$applid = $appid;
#print "AppID is " . $appid . "\n";

if ( $sessionid eq "" ) {
die "could not get sessionID \n";
}

if ( $appid eq "" ) {
die "could not get appID \n";
}

my $jobclass;
my $backupname;
my $beginpit;
my $endpit;
my $bpit;
my $epit;

my @imgdetails=`curl -XGET -k -s --tlsv1.2 -H "Authorization: Actifio $sessionid" "https://$AGMips/actifio/backup?filter=appname:==$appname&filter=jobclass:==snapshot&filter=hostname:==$hostname"`;

#my @imgdetails=`curl -XGET -k -s --tlsv1.2 -H "Authorization: Actifio $sessionid" "https://$AGMips/actifio/backup?filter=appname:==$appname"`;

print "Database Name: " . $appname . "\n";
print "Host Name: " . $hostname . "\n";
print "\n";

foreach my $p (@imgdetails) {

#print $p;

#if ( $p =~ /\bjobclass\b/ ) {
#my @jobcl = split(':', $p);
#$jobclass = $jobcl[1];
#$jobclass =~ s/,$//;
#$jobclass =~ s/\"//g;
#$jobclass =~ s/^\s+|\s+$//g;
#print "Job Type:  " . $jobclass . "\n";
# }

if ($p =~ /\bbackupname\b/) {
my @backup = split(':', $p);
$backupname =  $backup[1];
if ( $backupname =~ /Image_/ ) {
$backupname =~ s/,$//;
$backupname =~ s/\"//g;
$backupname =~ s/^\s+|\s+$//g;
print "Snapshopt Image and Recovery Range \n";
#print "Image Type:  " . Snapshot . "\n";
print "Image Name:  " . $backupname . "\n";
    }
  }

if ($p =~ /beginpit/) {
my @beginp = split(':', $p);
$beginpit =  $beginp[1];
$beginpit =~ s/,$//;
$beginpit =~ s/\"//g;
$beginpit =~ s/^\s+|\s+$//g;
use POSIX qw( strftime );
$bpit = strftime("%Y-%m-%d %H:%M:%S", localtime($beginpit/1000/1000));
  }
if ($p =~ /endpit/) {
my @endp = split(':', $p);
$endpit =  $endp[1];
$endpit =~ s/,$//;
$endpit =~ s/\"//g;
$endpit =~ s/^\s+|\s+$//g;
use POSIX qw( strftime );
$epit = strftime("%Y-%m-%d %H:%M:%S", localtime($endpit/1000/1000));
#print $endpit;
# }

if ( defined($beginpit) && defined($endpit) ) { 
#print "Snapshopt Image and Recovery Range \n";
print "RecoveryST: '" . $bpit . "'  RecoveryET: '" . $epit . "' \n";
print "\n";
}
}
}

my @dedetails=`curl -XGET -k -s --tlsv1.2 -H "Authorization: Actifio $sessionid" "https://$AGMips/actifio/backup?filter=appname:==$appname&filter=jobclass:==dedup&filter=hostname:==$hostname"`;

foreach my $q (@dedetails) {
#print $q;

if ($q =~ /\bbackupname\b/) {
my @backup = split(':', $q);
$backupname =  $backup[1];
if ( $backupname =~ /Image_/ ) {
$backupname =~ s/,$//;
$backupname =~ s/\"//g;
$backupname =~ s/^\s+|\s+$//g;
print "Dedup Image and Recovery Range \n";
#print "Image Type:  " . Dedup . "\n";
print "Image Name:  " . $backupname . "\n";
    }
  }

if ($q =~ /beginpit/) {
my @beginp = split(':', $q);
$beginpit =  $beginp[1];
$beginpit =~ s/,$//;
$beginpit =~ s/\"//g;
$beginpit =~ s/^\s+|\s+$//g;
use POSIX qw( strftime );
$bpit = strftime("%Y-%m-%d %H:%M:%S", localtime($beginpit/1000/1000));
#print $beginpit;
  }
if ($q =~ /endpit/) {
my @endp = split(':', $q);
$endpit =  $endp[1];
$endpit =~ s/,$//;
$endpit =~ s/\"//g;
$endpit =~ s/^\s+|\s+$//g;
use POSIX qw( strftime );
$epit = strftime("%Y-%m-%d %H:%M:%S", localtime($endpit/1000/1000));

if ( defined($beginpit) && defined($endpit) ) {
#print "Dedup Image and Recovery Range \n";
print "RecoveryST: '" . $bpit . "'  RecoveryET: '" . $epit . "' \n";
print "\n";
}
}
if ( $q =~ /\bsourceimage\b/ ) {
last;
}
}

my @livedetails=`curl -XGET -k -s --tlsv1.2 -H "Authorization: Actifio $sessionid" "https://$AGMips/actifio/backup?filter=appname:==$appname&filter=jobclass:==liveclone&filter=hostname:==$hostname"`;

foreach my $q (@livedetails) {
#print $q;

if ($q =~ /\bbackupname\b/) {
my @backup = split(':', $q);
$backupname =  $backup[1];
if ( $backupname =~ /Image_/ ) {
$backupname =~ s/,$//;
$backupname =~ s/\"//g;
$backupname =~ s/^\s+|\s+$//g;
print "LiveClone Image and Recovery Range \n";
print "Image Name:  " . $backupname . "\n";
    }
  }

if ($q =~ /beginpit/) {
my @beginp = split(':', $q);
$beginpit =  $beginp[1];
$beginpit =~ s/,$//;
$beginpit =~ s/\"//g;
$beginpit =~ s/^\s+|\s+$//g;
use POSIX qw( strftime );
$bpit = strftime("%Y-%m-%d %H:%M:%S", localtime($beginpit/1000/1000));
#print $beginpit;
  }
if ($q =~ /endpit/) {
my @endp = split(':', $q);
$endpit =  $endp[1];
$endpit =~ s/,$//;
$endpit =~ s/\"//g;
$endpit =~ s/^\s+|\s+$//g;
use POSIX qw( strftime );
$epit = strftime("%Y-%m-%d %H:%M:%S", localtime($endpit/1000/1000));

if ( defined($beginpit) && defined($endpit) ) {
print "RecoveryST: '" . $bpit . "'  RecoveryET: '" . $epit . "' \n";
print "\n";
}
}
if ( $q =~ /\bsourceimage\b/ ) {
last;
}
}

my @dasdetails=`curl -XGET -k -s --tlsv1.2 -H "Authorization: Actifio $sessionid" "https://$AGMips/actifio/backup?filter=appname:==$appname&filter=jobclass:==dedupasync&filter=hostname:==$hostname"`;

foreach my $q (@dasdetails) {
#print $q;

if ($q =~ /\bbackupname\b/) {
my @backup = split(':', $q);
$backupname =  $backup[1];
if ( $backupname =~ /Image_/ ) {
$backupname =~ s/,$//;
$backupname =~ s/\"//g;
$backupname =~ s/^\s+|\s+$//g;
print "DedupAsync Image and Recovery Range \n";
print "Image Name:  " . $backupname . "\n";
    }
  }

if ($q =~ /beginpit/) {
my @beginp = split(':', $q);
$beginpit =  $beginp[1];
$beginpit =~ s/,$//;
$beginpit =~ s/\"//g;
$beginpit =~ s/^\s+|\s+$//g;
use POSIX qw( strftime );
$bpit = strftime("%Y-%m-%d %H:%M:%S", localtime($beginpit/1000/1000));
#print $beginpit;
  }
if ($q =~ /endpit/) {
my @endp = split(':', $q);
$endpit =  $endp[1];
$endpit =~ s/,$//;
$endpit =~ s/\"//g;
$endpit =~ s/^\s+|\s+$//g;
use POSIX qw( strftime );
$epit = strftime("%Y-%m-%d %H:%M:%S", localtime($endpit/1000/1000));

if ( defined($beginpit) && defined($endpit) ) {
print "RecoveryST: '" . $bpit . "'  RecoveryET: '" . $epit . "' \n";
print "\n";
}
}
if ( $q =~ /\bsourceimage\b/ ) {
last;
}
}

my @sspdetails=`curl -XGET -k -s --tlsv1.2 -H "Authorization: Actifio $sessionid" "https://$AGMips/actifio/backup?filter=appname:==$appname&filter=jobclass:==StreamSnap&filter=hostname:==$hostname"`;

foreach my $q (@sspdetails) {
#print $q;

if ($q =~ /\bbackupname\b/) {
my @backup = split(':', $q);
$backupname =  $backup[1];
if ( $backupname =~ /Image_/ ) {
$backupname =~ s/,$//;
$backupname =~ s/\"//g;
$backupname =~ s/^\s+|\s+$//g;
print "StreamSnap Image and Recovery Range \n";
print "Image Name:  " . $backupname . "\n";
    }
  }

if ($q =~ /beginpit/) {
my @beginp = split(':', $q);
$beginpit =  $beginp[1];
$beginpit =~ s/,$//;
$beginpit =~ s/\"//g;
$beginpit =~ s/^\s+|\s+$//g;
use POSIX qw( strftime );
$bpit = strftime("%Y-%m-%d %H:%M:%S", localtime($beginpit/1000/1000));
#print $beginpit;
  }
if ($q =~ /endpit/) {
my @endp = split(':', $q);
$endpit =  $endp[1];
$endpit =~ s/,$//;
$endpit =~ s/\"//g;
$endpit =~ s/^\s+|\s+$//g;
use POSIX qw( strftime );
$epit = strftime("%Y-%m-%d %H:%M:%S", localtime($endpit/1000/1000));

if ( defined($beginpit) && defined($endpit) ) {
print "RecoveryST: '" . $bpit . "'  RecoveryET: '" . $epit . "' \n";
print "\n";
}
}
if ( $q =~ /\bsourceimage\b/ ) {
last;
}
}

}
