/* ============================================================
 * Actifio VirtualData Pipeline
 * Copyright (c) 2011 Actifio Inc. All Rights Reserved
 *
 * This program code contains trade secrets of Actifio Inc. that
 * (i) derive independent economic value, actual or potential, from not being
 * generally known to, and not being readily ascertainable by proper means by
 * other persons who can obtain economic value from their disclosure or use and;
 * (ii) are the subject of efforts by Actifio Inc that are reasonable under the
 * circumstances to maintain their secrecy. You may not use this program code
 * without prior written authorization from Actifio Inc.
 *
 * Filename       : asmDeviceDiskgroup.sql
 *
 * Description:   add a disk to a diskgroup
 *
 * =============================================================
 */

set pages 0
set head off
set feed off
set timing off
set echo off
set verify off
WHENEVER SQLERROR EXIT SQL.SQLCODE
select 'ACT_SEPARATOR_TAG=' || g.name from v$asm_disk d, v$asm_diskgroup g where d.group_number = g.group_number and upper(d.path) = upper('&1');
exit;

