#!/bin/sh

ORACLE_HOME=$1
orasid=$2
confDir=$3
ouser=$4
pwfile=$5

export ORACLE_HOME
PATH=$ORACLE_HOME/bin:$PATH
export PATH
LD_LIBRARY_PATH=$ORACLE_HOME/lib
export LD_LIBRARY_PATH

origsid="init"$orasid".ora"
var=`grep "ASM_" $confDir/asm_node_config.conf | cut -f2 -d:`
m=0
for x in $var; do
  m=$(($m + 1));
  orasid1=$orasid$m
  orasidnode="init"$orasid1".ora"
  pwfilenode="orapw"$orasid1
   if [ $m = 1 ]
    then
      su -m $ouser -c "srvctl add instance -d $orasid -i $orasid1 -n $x "
    else
      su -m $ouser -c "ssh -o StrictHostKeyChecking=no -l$ouser $x exit"	
      su -m $ouser -c "scp $ORACLE_HOME/dbs/$origsid $ouser@$x:$ORACLE_HOME/dbs/$orasidnode"
      if su -m $ouser -c "ssh $ouser@x stat $ORACLE_HOME/dbs/spfile$orasid.ora >/dev/null 2>&1"
      then
         mvts=`date +%Y%m%d`
         su -m $ouser -c "ssh $ouser@x mv $ORACLE_HOME/dbs/spfile$orasid.ora $ORACLE_HOME/dbs/spfile$orasid.ora-$mvts"
      fi
      su -m $ouser -c "srvctl add instance -d $orasid -i $orasid1 -n $x "
      su -m $ouser -c "scp $pwfile $ouser@$x:$ORACLE_HOME/dbs/$pwfilenode"
   fi
done

exit 0
