/* ============================================================
 * Actifio VirtualData Pipeline
 * Copyright (c) 2015 Actifio Inc. All Rights Reserved
 *
 * This program code contains trade secrets of Actifio Inc. that
 * (i) derive independent economic value, actual or potential, from not being
 * generally known to, and not being readily ascertainable by proper means by
 * other persons who can obtain economic value from their disclosure or use and;
 * (ii) are the subject of efforts by Actifio Inc that are reasonable under the
 * circumstances to maintain their secrecy. You may not use this program code
 * without prior written authorization from Actifio Inc.
 *
 * Filename       : backupDatafileNameMaxLength_nonactivdg.sql
 *
 * Description:   get max length of backup datafiles name with given tag
 *
 * =============================================================
 */

set pages 0
set head off
set feed off
set timing off
set echo off
WHENEVER SQLERROR EXIT SQL.SQLCODE
select max(length(name)) from v$backup_copy_details where file# > 0;
exit;

