#!/bin/bash

nrows=$1

mongo --port 27018 << EOF
var randomName = function() {
  // Base 36 uses letters and digits to represent a number:
  return (Math.random()+1).toString(36).substring(2);
}
var day = 1000 * 60 * 60 * 24;
var randomDate = function () {
  return new Date(Date.now() - (Math.floor(Math.random() * day)));
}
for (var i = 1; i <= $nrows; ++i) {
  db.test.insert({
      name: randomName(),
      creationDate: randomDate(),
      uid: i
  });
}
exit
EOF

