#!/bin/sh

#export ACT_JOBTYPE="unmount"
#export ACT_PHASE="pre"

set -x
conffile=$2;
if [ -z $conffile ]; then
 conffile=/act/scripts/act_Conf_Target_Slave.conf
 source $conffile
else
source /act/scripts/$conffile
fi
cd /act/scripts
echo "****************** PRESK_JOBTYPE $ACT_JOBTYPE ***************"

if [ $ACT_JOBTYPE = "unmount" ] || [ $ACT_MULTI_OPNAME = "unmount" ] ; then
   if [ $ACT_PHASE = "post" ] ; then
        echo "NO-OP for post-script when unmount"
        echo "** no op exit **"
      exit
   fi
   if [ $ACT_PHASE = "pre" ] ; then
	echo "************************* start pre during unmount ************************"

# Check if mysql service is running

mntpt=$TARGET_MNT_PNT

echo "Mount Point:" $mntpt

sqlservice=`cat $TARGET_MNT_PNT/$SRC_DATA_DIR/mysql.conf | grep socket| head -1 | awk -F"=" '{print $2}'`


if [ ! -z "$sqlservice" ]; then
MYSQL_ADMIN=`echo $MYSQL_CMD | sed '0,/mysql/s//mysqladmin/'`
su - $DBUSER -c "$MYSQL_ADMIN -S $sqlservice shutdown"
retval=$?
if [ "$retval" -gt "0" ]; then
  echo "Stop of existing service failed!"
  exit 1;
fi
fi
fi
fi

exit $?

