#!/bin/sh
set +x
ImageId=$1
ouser=$2

/act/act_scripts/mount.sh $ImageId

mntptfile="/var/act/log/"$ImageId
if [ ! -f $mntptfile ]; then
   echo "mount point file does not exists, unable to bring up database"
   exit 1
fi

mntpts=`cat $mntptfile`
for mp in ${mntpts}; do
    setdbf=`ls -l $mp | grep setdb_`
    if [ $? -eq 0 ]; then
       mntpt=$mp
       break
    fi
done
#mntpt=${mntpt%_1}
echo $mntpt

#setdbf=`ls -l $mntpt | grep setdb_ | awk '{print $NF}'`
#sid=`echo $setdbf | tr -s "_" | awk '{print $NF}'`

su - $ouser -c "/act/act_scripts/startdb.sh $mntpt"

rm $mntptfile



