#!/bin/bash
set -x
DBSID=$1
DBUSER=$2
DBPORT=$3
PORT=$4
HANAVERSION=$5

HCMT='ACT_'$DBSID'_SNAP'
DATE=`date`
echo "************************** DATE:$DATE: Freezing $DBSID database ******************"

if [ "$HANAVERSION" = "1.0" ]
then
SQL="BACKUP DATA CREATE SNAPSHOT COMMENT '$HCMT'"
else
SQL="BACKUP DATA FOR FULL SYSTEM CREATE SNAPSHOT COMMENT '$HCMT'"
fi

/usr/sap/$DBSID/$DBPORT/exe/hdbsql -i $PORT -U $DBUSER -j $SQL
retval=$?

exit $retval

