#!/bin/sh

export ACT_JOBTYPE="unmount"
export ACT_PHASE="pre"
tmp_loc=/act/touch
if [ ! -d "$tmp_loc" ]; then
   mkdir -p $tmp_loc
fi
chmod 777 /act/touch

set -x
conffile=/act/scripts/act_Conf_Target_Primary.conf
source $conffile

cd /act/scripts
echo "****************** PRESK_JOBTYPE $ACT_JOBTYPE ***************"

if [ "$ACT_JOBTYPE" = "unmount" ] || [ "$ACT_MULTI_OPNAME" = "unmount" ] ; then
   if [ "$ACT_PHASE" = "post" ] ; then
        echo "NO-OP for post-script when unmount"
        echo "** no op exit **"
      exit
   fi
   if [ "$ACT_PHASE" = "pre" ] ; then
        echo "************************* start pre during unmount ************************"

retval=$?

echo "Stop Sybase Server..!"
checkserver=`ps -ef| grep dataserver | grep -w $TARGET_SERVER_NAME | grep -v "grep -w" |wc -l`

if [ $checkserver -gt "0" ]; then
su - $OSUSER -c "stopdb"
retval=$?
fi

if [ $retval -gt "0" ]; then
  echo "Stop of Sybase server failed!"
  exit 1
fi

fi
fi

exit $?
