#!/bin/sh
# script template to be used by Actifio Connector
# supported operations
#  1. init
#  2. freeze
#  3. unfreeze (thaw)
#  4. fini
#  5. abort
# these operations are managed by Actifio Appliance and Actifio Connector

set +x 
op=$1
appid=$2
SWD=/act/scripts
echo $SWD

sname=`basename $0`

retval=0
function rexec
{
   op=$1
   script=/act/scripts/$op'.'$appid
   if [ -f $script ]; then
      $script $appid
       retval=$?
   else
      echo "NO-OP for $op"
   fi
}

allowed="init freeze thaw fini abort"
found=0
for i in $allowed
do
if [ $i = $op ]
then
   echo "executing $op...."
   rexec $op
   if [ $retval = 1 ]
    then
     exit 1
   fi
   found=1
fi
done
echo $found
if [ $found = 0 ]
then
   echo "operation not supported!"
fi

exit 0

